package com.comtika.safe.common.action;

import com.comtika.safe.common.constant.ProjectConstant;

import javax.servlet.http.HttpServletRequest;

/**
 * @Author: miss[494977551@qq.com]
 * @Date: Create in 15:06 2019/6/12
 * @DESC:  权限
 **/
public class BaseAuthUtil {

    /**
     * 获取客服端ip
     * @return
     */
    public static String doGetRequestIp(HttpServletRequest request) {//获取请求ip
        //X-Forwarded-For(XFF)是用来识别通过HTTP代理或负载均衡方式连接到Web服务器的客户端最原始的IP地址的HTTP请求头字段
        String ip = request.getHeader(ProjectConstant.ProjectIpAddress.IP_FORWARDED);
        if (ip == null || ip.length() == 0 || ProjectConstant.ProjectIpAddress.UN_KNOWN.equalsIgnoreCase(ip)) {
            ip = request.getHeader(ProjectConstant.ProjectIpAddress.IP_PROXY_CLIENT);
        }
        if (ip == null || ip.length() == 0 || ProjectConstant.ProjectIpAddress.UN_KNOWN.equalsIgnoreCase(ip)) {
            ip = request.getHeader(ProjectConstant.ProjectIpAddress.IP_WL_FORWARDED);
        }
        if (ip == null || ip.length() == 0 || ProjectConstant.ProjectIpAddress.UN_KNOWN.equalsIgnoreCase(ip)) {
            ip = request.getRemoteAddr();
        }
        ip = ip.equals(ProjectConstant.ProjectIpAddress.DEFAULT_IP) ? ProjectConstant.ProjectIpAddress.LOCAL_IP : ip;
        int index = ip.indexOf(",");
        if (index != -1) ip = ip.substring(0, index);
        return ip;
    }


}
