package com.comtika.safe.common.cache;

import com.google.common.cache.CacheLoader;
import com.google.common.cache.RemovalListener;
import lombok.Data;

import java.util.concurrent.TimeUnit;

/**
　　* @description: zqy {1317646732@qq.com}
　　* @author zqy
　　* @date 2019/9/5 12:00
　　*/
@Data
public class GoogleGuavaConfig<T> {
    private int concurrencyLevel = 4;//设置并发级别为4，并发级别是指可以同时写缓存的线程数
    private int expireTime = 60;//默认过期时间
    private TimeUnit unit = TimeUnit.MINUTES;//默认过期时间单位
    private int initialCapacity = 4;//初始容量
    private int maximumSize = 512;//设置缓存最大容量为100，超过100之后就会按照LRU最近虽少使用算法来移除缓存项
    private boolean recordStats = false; //是否记录统计
    private boolean createExpire = true; //true 使用 创建过期   false 使用 访问过期
    private boolean refreshAfter = false;//true 使用refreshAfterWrites  false 使用 expireAfterWrites
    private RemovalListener<String, T> removalListener;
    private CacheLoader<String,  T> cacheLoader = new CacheLoader<String,T>(){
        @Override
        public T load(String key) throws Exception {
            return null;
        }
    };;
    public GoogleGuavaConfig(){

    }
    public GoogleGuavaConfig(int expireTime,boolean createExpire){
        this.expireTime = expireTime;
        this.createExpire = createExpire;
    }

}
