package com.comtika.safe.common.cache;

import java.util.Map;
import java.util.concurrent.ConcurrentMap;

/**
 * @Author: miss[494977551@qq.com]
 * @Date: Create in 8:40 2019/6/18
 * @DESC:
 **/
public interface GuavaCache<T> {
    void set(String key, T value);
    void setMap(Map<String, T> map);
    /**
     * 获取值 没有 调用load 回调方法，该方法返回null 抛异常
     * @param key
     * @return
     */
    T getIfLoad(String key);

    /**
     * 获取值，没有 返回null
     * @param key
     * @return
     */
    T getIfPresent(String key);
    <T> T get(String key, Class<T> clazz);
    void remove(String key);
    void cleanTotalCache();
    void cleanUpCache();
    void cleanManyCache(Iterable<Object> keys);
    ConcurrentMap<String, T> getCacheMap();

    /**
     * 刷新会调用该方法 CacheLoader
     * @param key
     */
    void refreshCache(String key);
}
