package com.comtika.safe.common.constant;

import com.comtika.safe.common.utils.StringUtil;

import org.beetl.sql.core.engine.PageQuery;

import java.util.*;
import java.util.concurrent.ThreadLocalRandom;
import java.util.regex.Pattern;

public class ProjectConstant {

	/**
     * 系统权限修改标识：缓存在redis,值boolean型，true:权限有修改，获取权限需要更新，  false,权限无修改
     */
    public static final String PERMISSION_UPDATE_FLAG = "permission_1BPCZtZeWVJOpvJP_flag";

    public static final long ROOT_ORG_ID = 0L;//组织架构根节点id

    /**
     * 系统管理员
     */
    public static final String ADMIN = "admin";

    public static final String COMTIKA_SAFE_TOKEN = "comtikaSafe#&/key";

    public static final String WEB_SOCKET_KEY = "WEB_SOCKET_USER_KEY";
    public static final int ADMIN_ID = 1;
    public static final String USER_ID = "ELOAM_USER_ID";
    public static final String AUTH_ENTITY_KEY = "SERVER_USER_KEY";
    public static final int EXCEL_MAX_NUM = 100000;
    public static final String DEFAULT_AUTH = "999999";
    public static final String BLACK_LIST_ADDRNO = "terminal_black_";
    public static final String OTA_DATAS_KEY = "OTA_KEY_";
    public static final String SIGN_ID = "signalId";
    public static final String ACKCODE = "ackCode";
    /** ip */
    public static final String IP = "ip";
    /** port */
    public static final String PORT = "port";
    /**协议层容忍设备续充时间 分钟 默认60分钟*/
    public static final String PROTOCOL_SHOWDOWN_TIMEOUT = "proDownTimeOut";
    /**协议层在线用户充电数据**/
    public static final String PROTOCOL_SIMPLE_USER_CHARGE_DATA = "proOnlUserData";
    /***OTA 升级状态**/
    public static final String OTA_PROTOCOL_DATA_KEY = "protocolOTA";
    public static final String THE_ORDER_IS_CLOSED = "订单已结束";

    @SuppressWarnings("rawtypes")
	public static class ResConstant{
        public static PageQuery EMPTY_PAGE_QUERY;
        static {
            EMPTY_PAGE_QUERY = new PageQuery();
            EMPTY_PAGE_QUERY.setList(new ArrayList(0));
            EMPTY_PAGE_QUERY.setTotalRow(0);
        }
    }

    public static class PhoneCodeRandom{
        public static String getRandom() {
            Random random = new Random();
            String fourRandom = random.nextInt(1000000)+"";
            int randLength = fourRandom.length();
            if (randLength < 6) {
                for (int i = 1; i <= 6 - randLength; i++)
                    fourRandom = "0" + fourRandom;
            }
            return fourRandom;
        }
    }



    public static class PhonePattern{
        public static final Pattern PHONE_NO = Pattern.compile("^(1[3-9])\\d{9}$");
    }


    /**枚举toString() 方法*/
    private static final String ENUMS_TOSTRING = "{\"id\":%s,\"name\":\"%s\"}";
    public static final ThreadLocalRandom RANDOM = ThreadLocalRandom.current();


    public class ProjectIpAddress{
        public static final String IP_FORWARDED = "x-forwarded-for";
        public static final String IP_PROXY_CLIENT = "Proxy-Client-IP";
        public static final String IP_WL_FORWARDED = "WL-Proxy-Client-IP";
        public static final String UN_KNOWN = "unknown";
        public static final String DEFAULT_IP = "0:0:0:0:0:0:0:1";
        public static final String LOCAL_IP = "127.0.0.1";
    }
    public class ThirdConstant{
        public static final String AC_WX_CODE_HEAD = "ELOAM_AC_WX_CODE_HEAD";

        public static final String AC_WE_CHAT = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=APPID&redirect_uri=REDIRECT_URI&response_type=code&scope=SCOPE&state=STATE#wechat_redirect";
        public static final String OPENID = "openid";
        // 微信统一下单文档： https://pay.weixin.qq.com/wiki/doc/api/jsapi.php?chapter=9_4
        //小程序授权
        public static final String WX_CODE_SESSION_URL = "https://api.weixin.qq.com/sns/jscode2session?appid=APPID&secret=SECRET&js_code=JSCODE&grant_type=authorization_code";
        public static final String WX_APPID = "APPID";
        public static final String WX_SECRET = "SECRET";
        public static final String WX_JSCODE = "JSCODE";
        public static final String AC_WX_REDIRECT_URI = "REDIRECT_URI";
        public static final String AC_WX_SCOPE = "SCOPE";
        public static final String AC_WX_STATE = "STATE";
        // 公众号授权
        public static final String WX_AC_SESSION_URL = "https://api.weixin.qq.com/sns/oauth2/access_token?appid=APPID&secret=SECRET&code=JSCODE&grant_type=authorization_code";
    }

    public static String createEnumsToStr(int id,String name){
        return String.format(ENUMS_TOSTRING,id,name);
    }
    public static class OAuthConstant{
        public static final List<Integer> EMPAY_LIST_INT = new ArrayList<>(0);

        public static final String EMPTY_OAUTH = "";
        public static final int MERCHANT_ROLE_ID = 1;//商户管理员角色id
        public static final String COMMA = ",";
        public static final Pattern PATTERN_COMMA = Pattern.compile(COMMA);//ftpUrl 分割
        public static List<Integer> stringToList(String str){
            if(StringUtil.isEmpty(str)) return Collections.emptyList();
            String[] split = PATTERN_COMMA.split(str);
            List<Integer> res = new ArrayList<>(split.length);
            for(String st:split){
                if(StringUtil.isNotEmpty(st))
                    res.add(Integer.valueOf(st));
            }
            return res;
        }

        @SuppressWarnings("rawtypes")
		public static String listToString(Collection collection){
            if(collection == null || collection.isEmpty()) return EMPTY_OAUTH;
            StringBuilder sb = new StringBuilder();
            for(Object obj:collection){
                if(obj != null){
                    sb.append(obj);
                    sb.append(COMMA);
                }
            }
            String s = sb.toString();
            if(s.length() > 0)
                return s.substring(0,s.length()-1);
            return EMPTY_OAUTH;
        }
    }


}
