package com.comtika.safe.common.enums;

/**
 * 
 * @ClassName: GeneralStatusEnum
 * @Description:通用状态枚举 
 */
public enum GeneralStatusEnum {
    ENABLE(1, "启用"), 
    DISABLE(2, "停用");

    private int id;

    private String value;

    private GeneralStatusEnum(int id, String value) {
        this.id = id;
        this.value = value;
    }

    public int getId() {
        return id;
    }

    public String getValue() {
        return value;
    }

    public static GeneralStatusEnum getEnumById(int id) {
        for (GeneralStatusEnum each : GeneralStatusEnum.values()) {
            if (each.getId() == id) { return each; }
        }
        throw new RuntimeException(String.format("id=[%d] error", id));
    }
}
