package com.comtika.safe.common.enums;

/**
 * 
 * @ClassName: RoleStatusEnum
 * @Description:角色状态枚举
 * @version V1.0
 */
public enum RoleStatusEnum {
    ENABLE(1, "启用"), 
    DISABLE(2, "停用");

    private int id;

    private String value;

    private RoleStatusEnum(int id, String value) {
        this.id = id;
        this.value = value;
    }

    public int getId() {
        return id;
    }

    public String getValue() {
        return value;
    }

    public static RoleStatusEnum getEnumById(int id) {
        for (RoleStatusEnum each : RoleStatusEnum.values()) {
            if (each.getId() == id) { return each; }
        }
        throw new RuntimeException(String.format("id=[%d] error", id));
    }
}
