package com.comtika.safe.common.enums;

/**
 * 
 * @ClassName: SysOperateEnum
 * @Description:操作枚举
 */
public enum SysOperateEnum {
    ENABLE(1, "启用"), 
    DISABLE(2, "停用"), 
    PASS(3, "审核通过"),
    NO_PASS(4, "审核不通过"),
    START_COOPERATION(5, "合作开始"),
    END_COOPERATION(6, "合作结束");

    private int id;

    private String value;

    private SysOperateEnum(int id, String value) {
        this.id = id;
        this.value = value;
    }

    public int getId() {
        return id;
    }

    public String getValue() {
        return value;
    }

    public static SysOperateEnum getEnumById(int id) {
        for (SysOperateEnum each : SysOperateEnum.values()) {
            if (each.getId() == id) { return each; }
        }
        throw new RuntimeException(String.format("id=[%d] error", id));
    }
}
