package com.comtika.safe.common.enums.api;

import com.comtika.safe.common.utils.StringUtil;


public enum ApiRequestURI {
	addEquipTerminal(		"/equip/equipTerminal/addEquipTerminal",	"新增设备",		"equip"),
	addEquipTerminalList(	"/equip/equipTerminal/addEquipTerminalList","批量新增设备",		"equip"),
	updateEquipTerminal(	"/equip/equipTerminal/updateEquipTerminal",	"修改设备",		"equip"),
	addProduct(				"/equip/product/add",						"新增产品类型",		"equip"),
	updateProduct(			"/equip/product/update",					"修改产品类型",		"equip"),
	addOTAHsVersion(		"/ota/addOTAHsVersion",						"新增OTA版本",		"equip"),
	updateOneHsVersion(		"/ota/updateOneHsVersion",					"修改OTA版本",		"equip"),
	setDeviceWhiteListParams("/protocol/setDeviceWhiteListParams",		"配置设备的白名单",	"equip"),
	fadSendProtocolToTerminal("/protocol/fadSendProtocolToTerminal",	"发送协议到设备操作",	"equip"),
	deviceRestart(			"/protocol/fad/deviceRestart",				"设备复位操作",		"equip"),
	setDeviceMac(			"/protocol/fad/setDeviceMac",				"设置mac地址",		"equip"),
	setDeviceTime(			"/protocol/fad/setDeviceTime",				"设置设备时间",		"equip"),
	setTerminalAddress(		"/protocol/fad/setTerminalAddress",			"配置服务器地址",	"equip"),
	cleanTerminalEle(		"/protocol/cleanTerminalEle",				"清除节点电能信息",	"equip"),
	safeTerminalOff(		"/protocol/safeTerminalOff",				"集中器继电器关",	"equip"),
	safeTerminalOn(			"/protocol/safeTerminalOn",					"集中器继电器开",	"equip"),
	setSafeTaskConf(		"/protocol/setSafeTaskConf",				"下发定时任务 ",		"equip"),
	deleteSafeTask(			"/protocol/deleteSafeTask",					"删除定时任务 ",		"equip"),
	setTerminalParams(		"/protocol/setTerminalParams",				"配置节点阈值 ",		"equip"),
	safeOTAUpdate(			"/protocol/safeOTAUpdate",					"安全用电OTA升级接口 ","equip"),
	setupIpPort(			"/protocol/setupIpPort",					"设置集中器协议 集中器ip与端口 ","equip"),
	addTaskHandle(			"/task/addTaskHandle",						"添加定时任务 ",		"equip"),
	updateTaskHandle(		"/task/updateTaskHandle",					"修改定时任务 ",		"equip"),
	deleteTask(				"/task/deleteTask",							"删除定时任务 ",		"equip"),
	takeTask(				"/task/takeTask",							"下发定时任务",		"equip"),
	addMerchant(			"/merchant/add",							"新增商户",			"merchant"),
	updateMerchant(			"/merchant/updateMerchant",					"修改商户",			"merchant"),
	updateMerchantDetail(	"/merchant/updateMerchantLogoAndTitle",		"修改Logo与Title",	"merchant"),
	enableMerchant(			"/merchant/enableMerchant",					"启用/停用/审核商户","merchant"),
	addMenu(				"/menu/addMenu",							"新增菜单权限",		"menu"),
	updateMenu(				"/menu/updateMenu",							"修改菜单权限",		"menu"),
	enableMenu(				"/menu/enableMenu",							"启用/停用菜单权限",	"menu"),
	addRole(				"/role/addRole",							"新增角色",			"role"),
	updateRole(				"/role/updateRole",							"修改角色",			"role"),
	enableRole(				"/role/enableRole",							"启用/停用角色",		"role"),
	pageRoleConfig(			"/role/pageRoleConfig",						"角色页面权限配置",	"role"),
	dataRoleConfig(			"/role/dataRoleConfig",						"角色数据权限配置",	"role"),
	addUser(				"/user/addUser",							"新增用户",			"user"),
	updateUser(				"/user/updateUser",							"修改用户",			"user"),
	enableUser(				"/user/enableUser",							"启用/停用用户",		"user"),
	resetPassword(			"/user/resetPassword",						"后台密码重置",		"user"),
	addSite(				"/site/addSite",							"新增站点",			"site"),
	updateSite(				"/site/updateSite",							"修改站点",			"site"),
	deleteWattMeter(		"/meter/deleteWattMeter",					"删除站点下的电表记录","site"),
	addWattMeter(			"/meter/addWattMeter",						"新增站点电表记录",	"site"),
	updateWattMeter(		"/meter/updateWattMeter",					"更新站点电表记录",	"site");

	private String uri;
	
	private String msg;
	
	private String type;

	public String getUri() {
		return uri;
	}

	public void setUri(String uri) {
		this.uri = uri;
	}

	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		this.msg = msg;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	private ApiRequestURI(String uri, String msg, String type) {
		this.uri = uri;
		this.msg = msg;
		this.type = type;
	}
	
	public static ApiRequestURI getApiRequestByUri(String uri){
		if(StringUtil.isEmpty(uri)) return null;
		try {
			for(ApiRequestURI apiRequestURI:ApiRequestURI.values()){
				if(uri.equals(apiRequestURI.getUri())){
					return apiRequestURI;
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		return null;
	}
	
	
}
