package com.comtika.safe.common.enums.equip;

/**
 * @desc	:	集中器节点状态--插座状态
 * @author	:	actorLucky[494977551@qq.com]
 * @date	:	2018年5月20日 下午4:06:29
 */
//状态字：0-空闲，1-占用,2-正在充电中，3-充电完成，4-故障，5-维护
public enum SocketStatus {
	IDLE(0,"空闲"),
	BUSY(1,"占用"),
	TASKING(2,"正在充电中"),
	TASKED(3,"充电完成"),
	FAIL(4,"故障"),
	REPAIR(5,"维修");
	private int id;
	private String name;
	SocketStatus(int id,String name){
		this.id = id;
		this.name = name;
	}
	public int getId() {
		return id;
	}
	public String getName() {
		return name;
	}
	public static SocketStatus valueOf(int id){
		for(SocketStatus rs:SocketStatus.values()){
			if(rs.getId() == id){
				return rs;
			}
		}
		return null;
	}
	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		return sb.append("{\"id\":").append(this.id).append(",\"name\":").append("\""+this.name+"\"}").toString();
	}

}
