package com.comtika.safe.common.enums.equip.terminal;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @ClassName: TerminalStatusEnum
 * @Description:集中器状态枚举
 * @version V1.0
 */
public enum TerminalStatusEnum {
    IN_MAINTEN(0, "维护中"), 
    ON_LINE(1, "在线"),
    DISABLE(2,"禁用");
    
    private int id;

    private String text;

    TerminalStatusEnum(int id, String text) {
        this.id = id;
        this.text = text;
    }

    public int getId() {
        return id;
    }


    public String getText() {
        return text;
    }

    public static TerminalStatusEnum volueOf(int id){
    	for(TerminalStatusEnum t:TerminalStatusEnum.values()){
    		if(t.getId() == id)
    			return t;
    	}
    	return null;
    }
    public static List<Map<String,Object>> findTerminalMap(){
    	List<Map<String,Object>> list = new ArrayList<Map<String,Object>>();
    	for(TerminalStatusEnum t:TerminalStatusEnum.values()){
    		Map<String,Object> map = new HashMap<String, Object>();
    		map.put("id", t.getId());
    		map.put("name", t.getText());
    		list.add(map);
    	}
    	return list;
    }
    @Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		return sb.append("{\"id\":").append(this.id).append(",\"text\":").append("\""+this.text+"\"}").toString();
	}
}
