package com.comtika.safe.common.enums.merchant;

/**
 * 
 * @ClassName: MerchantStatusEnum
 * @Description:商户合作状态枚举
 * @version V1.0
 */
public enum CooperatStatusEnum {
    AUDIT(0, "待审核"),
    COOPERATION(1, "待合作"), 
    IN_COOPERATION(2, "合作中"),
    END_COOPERATION(3, "合作已结束"),
    NO_PASS(-1, "审核不通过");

    private int id;

    private String value;

    private CooperatStatusEnum(int id, String value) {
        this.id = id;
        this.value = value;
    }

    public int getId() {
        return id;
    }

    public String getValue() {
        return value;
    }

    public static CooperatStatusEnum getEnumById(int id) {
        for (CooperatStatusEnum each : CooperatStatusEnum.values()) {
            if (each.getId() == id) { return each; }
        }
        throw new RuntimeException(String.format("id=[%d] error", id));
    }
    
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer();
        return sb.append("{\"id\":").append(this.id).append(",\"text\":").append("\""+this.value+"\"}").toString();
    }
}
