package com.comtika.safe.common.enums.site;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @ClassName: FunctionState
 * @Description: 运营状态
 * @author zhaoLuYang
 * @date2018年7月18日 上午10:02:15
 * @version V1.0
 */
public enum SiteOperationStatus {
	DEBUG(1,"调试中"),
	RUNING(2,"正常运营"),
	WARING(3,"发送告警"),
	FAIL(4,"故障停运"),
	OUTAGE(5,"停止运营"),
	OVERHAUL(6,"运维检修");
	private int id;
	private String name;
	SiteOperationStatus(int id,String name){
		this.id = id;
		this.name = name;
	}
	/**
	 * @return the id
	 */
	public int getId() {
		return id;
	}
	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}
	public static SiteOperationStatus valueOf(int id){
		for(SiteOperationStatus obj:SiteOperationStatus.values()){
			if(obj.getId() == id)
				return obj;
		}
		return null;
	}
	public static List<Map<String,Object>> findFunctionStatesMap(){
		List<Map<String,Object>> list = new ArrayList<Map<String,Object>>();
		for(SiteOperationStatus obj:SiteOperationStatus.values()){
			Map<String,Object> map = new HashMap<String, Object>();
			map.put("id", obj.getId());
			map.put("name", obj.getName());
			list.add(map);
		}
		return list;
	}
	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		return sb.append("{\"id\":").append(this.id).append(",\"name\":").append("\""+this.name+"\"}").toString();
	}

}
