package com.comtika.safe.common.enums.user;

/**
 * @ClassName: UserStatusEnum
 */
public enum UserStatusEnum {
    AUDIT(0, "待审核"),
    ENABLE(1, "启用"), 
    DISABLE(2, "停用");
    
    private int id;

    private String value;

    private UserStatusEnum(int id, String value) {
        this.id = id;
        this.value = value;
    }

    public int getId() {
        return id;
    }

    public String getValue() {
        return value;
    }

    public static UserStatusEnum getEnumById(int id) {
        for (UserStatusEnum each : UserStatusEnum.values()) {
            if (each.getId() == id) { return each; }
        }
        throw new RuntimeException(String.format("id=[%d] error", id));
    }
}
