package com.comtika.safe.common.enums.user;

/**
 * 
 * @ClassName: UserInitEnum
 * @Description:用户类型枚举
 */
public enum UserTypeEnum {
    SYSTEM_USER(1, "系统用户"), 
    MERCHANT_USER(2, "商户用户"),
    SITE_USER(3, "站点用户");

    private int id;

    private String value;

    private UserTypeEnum(int id, String value) {
        this.id = id;
        this.value = value;
    }

    public int getId() {
        return id;
    }

    public String getValue() {
        return value;
    }

    public static UserTypeEnum getEnumById(int id) {
        for (UserTypeEnum each : UserTypeEnum.values()) {
            if (each.getId() == id) { return each; }
        }
        throw new RuntimeException(String.format("id=[%d] error", id));
    }
}
