package com.comtika.safe.common.exception;


import com.comtika.safe.common.response.RespCode;

/**
 * 项目统一异常处理类
 * @ClassName: RespException
 * @Description: 异常处理
 */
@SuppressWarnings("serial")
public class RespException extends RuntimeException {
	private int errcode;

	public RespException() {
		super();
		this.errcode = RespCode.FAIL;
	}
	public RespException(Throwable th) {
		super(th);
	}

	public RespException(String errmsg, Throwable th) {
		super(errmsg, th);
		this.errcode = RespCode.FAIL;
	}

	public RespException(String errmsg) {
		super(errmsg);
		this.errcode = RespCode.FAIL;
	}

	public RespException(int errcode, String errmsg) {
		super(errmsg);
		this.errcode = errcode;
	}

	public int getErrcode() {
		return errcode;
	}

	public void setErrcode(int errcode) {
		this.errcode = errcode;
	}

	protected RespException(String message, Throwable cause, boolean enableSuppression, boolean writableStackTrace) {
		super(message, cause, enableSuppression, writableStackTrace);
	}

}

