package com.comtika.safe.common.model;

import java.lang.reflect.Array;
import java.lang.reflect.Method;
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.comtika.safe.common.utils.StringUtil;



public final class BeanUtil {
	public static <T> T copy(Object src, Class<T> targetClass) {
		if (src == null){
			return null;
		}
		T result = null;
		try {
			result = targetClass.newInstance();
			copy(src, result);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return result;
	}

	@SuppressWarnings({ "unchecked", "rawtypes" })
	public static void copy(Object src, Object target) {
		if ((src == null) || (target == null)) {
			return;
		}
		Class<?> srcCls = src.getClass();
		Class<?> targetCls = target.getClass();
		Method[] targetMethods = targetCls.getMethods();
		Method[] arrayOfMethod1;
		int j = (arrayOfMethod1 = targetMethods).length;
		for (int i = 0; i < j; i++) {
			Method method = arrayOfMethod1[i];
			int modify = method.getModifiers();
			Class<?> returnType = method.getReturnType();
			Type[] paramTypes = method.getGenericParameterTypes();
			String targetMethodName = method.getName();

			if ((targetMethodName.startsWith("get"))
					&& (!targetMethodName.equalsIgnoreCase("getClass"))) {

				if (1 == modify) {

					if ((!Void.TYPE.isAssignableFrom(returnType))
							&& (!ClassLoader.class.isAssignableFrom(returnType))) {

						if (paramTypes.length == 0) {

							Type targetType = method.getGenericReturnType();
							String setMethodName = "set"
									+ targetMethodName.substring(3);
							try {
								Method srcMethod = srcCls.getMethod(
										targetMethodName, new Class[0]);
								Object srcVal = srcMethod.invoke(src,
										new Object[0]);
								Type srcType = srcMethod.getGenericReturnType();
								if (targetType.getTypeName().equals(
										srcType.getTypeName())) {
									Method targetSetMethod = targetCls
											.getMethod(setMethodName,
													new Class[] { method
															.getReturnType() });
									targetSetMethod.invoke(target,
											new Object[] { srcVal });
								} else if ((List.class.isAssignableFrom(method
										.getReturnType()))
										&& (List.class
												.isAssignableFrom(srcMethod
														.getReturnType()))) {
									Type pToType = ((java.lang.reflect.ParameterizedType) targetType)
											.getActualTypeArguments()[0];
									Type pSrcType = ((java.lang.reflect.ParameterizedType) srcType)
											.getActualTypeArguments()[0];
									if (pToType.getTypeName().equals(
											pSrcType.getClass())) {
										List<Object> list = (List) srcVal;
										if (list != null) {
											List<Object> toList = new ArrayList();
											for (int k = 0; k < list.size(); k++) {
												Object o = list.get(k);
												Object toVal = copy(o,
														(Class) pToType);
												if (toVal != null) {
													toList.add(toVal);
												}
											}
											Method targetSetMethod = targetCls
													.getMethod(
															setMethodName,
															new Class[] { method
																	.getReturnType() });
											targetSetMethod.invoke(target,
													new Object[] { toList });
										}
									}
								} else if ((method.getReturnType().isArray())
										&& (srcMethod.getReturnType().isArray())) {
									Class<?> componentType = method
											.getReturnType().getComponentType();
									Class<?> srcComponentType = srcMethod
											.getReturnType().getComponentType();
									if (componentType.getName().equals(
											srcComponentType.getName())) {
										int length = Array.getLength(srcVal);
										Object toArray = Array.newInstance(
												componentType, length);
										for (int f = 0; f < length; f++) {
											Object o = Array.get(srcVal, f);
											Object toVal = copy(o,
													componentType);
											Array.set(toArray, f, toVal);
										}
										Method targetSetMethod = targetCls
												.getMethod(
														setMethodName,
														new Class[] { method
																.getReturnType() });
										targetSetMethod.invoke(target,
												new Object[] { toArray });
									}
								} else {
									Object toVal = copy(srcVal,
											method.getReturnType());
									Method setMethod = targetCls.getMethod(
											setMethodName, new Class[] { method
													.getReturnType() });
									setMethod.invoke(target,
											new Object[] { toVal });
								}
							} catch (Exception localException) {
							}
						}
					}
				}
			}
		}
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static Map<String, Object> toMap(Object obj) {
		Map<String, Object> cache = new HashMap();
		if (obj == null) {
			return cache;
		}

		Class<?> clazz = obj.getClass();
		Method[] methods = clazz.getMethods();
		Method[] arrayOfMethod1;
		int j = (arrayOfMethod1 = methods).length;
		for (int i = 0; i < j; i++) {
			Method method = arrayOfMethod1[i];
			int modify = method.getModifiers();
			Class<?> returnType = method.getReturnType();
			Type[] paramTypes = method.getGenericParameterTypes();
			String methodName = method.getName();

			if (methodName.startsWith("is")) {
				try {
					clazz.getDeclaredField(methodName);
				} catch (NoSuchFieldException | SecurityException localNoSuchFieldException) {
					continue;
				}
			} else {
				if ((!methodName.startsWith("get"))
						|| (methodName.equalsIgnoreCase("getClass"))) {
					continue;
				}
			}

			if (1 == modify) {

				if ((!Void.TYPE.isAssignableFrom(returnType))
						&& (!ClassLoader.class.isAssignableFrom(returnType))) {

					if (paramTypes.length == 0) {
						try {
							Object o = method.invoke(obj, new Object[0]);
							if ((methodName.equals("getExtraMap"))
									&& (Map.class.isAssignableFrom(method
											.getReturnType()))) {
								Map map = (Map) o;
								cache.putAll(map);
							} else {
								String fieldName = StringUtil.toLowerCase(
										methodName.replaceAll("get", ""), 0);
								cache.put(fieldName, o);
							}
						} catch (Exception e) {
							throw new RuntimeException(e);
						}
					}
				}
			}
		}
		return cache;
	}
}
