package com.comtika.safe.common.model;

import java.util.Collection;
import java.util.Iterator;

final class CollectionSerializer implements ObjectSerializer {
	public static final CollectionSerializer instance = new CollectionSerializer();
	@SuppressWarnings("rawtypes")
	@Override
	public String doSerialize(Object obj, int depth) {
		if (obj == null) {
			return "null";
		}
		Collection coll = (Collection) obj;
		boolean first = true;
		Iterator iter = coll.iterator();

		StringBuilder builder = new StringBuilder();
		builder.append('[');
		while (iter.hasNext()) {
			if (first) {
				first = false;
			} else {
				builder.append(',');
			}
			Object value = iter.next();
			if (value == null) {
				builder.append("null");
			} else
				builder.append(JsonUtil.toJSONString(value, depth));
		}
		builder.append(']');
		return builder.toString();
	}
}