package com.comtika.safe.common.model;

import java.lang.reflect.Method;
import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.Map;

import com.comtika.safe.common.utils.StringUtil;



final class JavaBeanSerializer implements ObjectSerializer {
	public static final JavaBeanSerializer instance = new JavaBeanSerializer();
	@SuppressWarnings({ "rawtypes", "unchecked" })
	@Override
	public String doSerialize(Object obj, int depth) {
		if (obj == null) {
			return "null";
		}
		Map cache = new HashMap();
		Class<?> clazz = obj.getClass();
		Method[] methods = clazz.getMethods();
		Method[] arrayOfMethod1;
		int j = (arrayOfMethod1 = methods).length;
		for (int i = 0; i < j; i++) {
			Method method = arrayOfMethod1[i];
			int modify = method.getModifiers();
			Class<?> returnType = method.getReturnType();
			Type[] paramTypes = method.getGenericParameterTypes();
			String methodName = method.getName();

			if (methodName.startsWith("is")) {
				try {
					clazz.getDeclaredField(methodName);
				} catch (NoSuchFieldException | SecurityException localNoSuchFieldException) {
					continue;
				}
			} else {
				if ((!methodName.startsWith("get"))
						|| (methodName.equalsIgnoreCase("getClass"))) {
					continue;
				}
			}

			if (1 == modify) {

				if ((!Void.TYPE.isAssignableFrom(returnType))
						&& (!ClassLoader.class.isAssignableFrom(returnType))) {

					if (paramTypes.length == 0) {
						try {
							Object o = method.invoke(obj, new Object[0]);

							if ((methodName.equals("getExtraMap"))
									&& (Map.class.isAssignableFrom(method
											.getReturnType()))) {
								Map map = (Map) o;
								cache.putAll(map);
							} else {
								String fieldName = StringUtil.toLowerCase(
										methodName.replaceAll("get", ""), 0);
								cache.put(fieldName, o);
							}
						} catch (Exception e) {
							throw new RuntimeException(e);
						}
					}
				}
			}
		}
		return MapSerializer.instance.doSerialize(cache, depth);
	}
}