package com.comtika.safe.common.model;

import java.util.Iterator;
import java.util.Map;
final class MapSerializer implements ObjectSerializer {
	public static final MapSerializer instance = new MapSerializer();
	@SuppressWarnings("rawtypes")
	@Override
	public String doSerialize(Object obj, int depth) {
		if (obj == null) {
			return "null";
		}
		Map map = (Map) obj;
		StringBuilder builder = new StringBuilder();
		builder.append('{');
		boolean first = true;
		Iterator iter = map.entrySet().iterator();
		while (iter.hasNext()) {
			if (first) {
				first = false;
			} else {
				builder.append(',');
			}
			Map.Entry entry = (Map.Entry) iter.next();
			String key = String.valueOf(entry.getKey());
			builder.append('"');
			if (key == null) {
				builder.append("null");
			} else {
				JsonUtil.escapeStr(key, builder);
			}
			builder.append('"').append(':');
			builder.append(JsonUtil.toJSONString(entry.getValue(), depth));
		}
		builder.append('}');
		return builder.toString();
	}
}