/*
package com.comtika.safe.common.redis;

import java.io.Serializable;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.TimeUnit;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.data.redis.core.HashOperations;
import org.springframework.data.redis.core.ListOperations;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.core.ValueOperations;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

*/
/**
 * @desc	:	Redis
 * @author	:	actorLucky[494977551@qq.com]
 * @date	:	2018年5月11日 上午10:27:56
 *//*

@Component(value="redisApi")
public class RedisApi {

	@Resource
	private RedisTemplate<Serializable,Object> redisTemplate;

	*/
/***
	 * 获取所有的key
	 *//*

	public Set<Serializable> getKey(String pattern){
		return redisTemplate.keys(pattern);
	}

	*/
/**
	 * 写入缓存
	 * @param key 键
	 * @param value 值
	 * @return 写入是否成功
	 *//*

	public boolean set(final String key,Object value){
		boolean res = false;
		try {
			ValueOperations<Serializable,Object> opsForValue = redisTemplate.opsForValue();
			opsForValue.set(key, value);
			res = true;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return res;
	}
	*/
/**
	 * 写入缓存设置失效时间
	 * @param key	键
	 * @param vaule  值
	 * @param expireTime 失效时间
	 * @param timeType  失效时间类型
	 * @return 是否写入成功
	 *//*

	public boolean set(final String key,Object vaule,Long expireTime,TimeUnit timeType){
		boolean res = false;
		try {
			ValueOperations<Serializable, Object> opsForValue = redisTemplate.opsForValue();
			opsForValue.set(key, vaule);
			redisTemplate.expire(key, expireTime, timeType);
			res = true;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return res;
	}
	*/
/**
	 * 批量删除对应的value
	 * @param keys
	 *//*

	public void remove(final String...keys){
		for(String key:keys){
			remove(key);
		}
	}
	*/
/**
	 * 删除对应的值
	 * @param key
	 *//*

	public void remove(final String key){
		if(exists(key)){
			redisTemplate.delete(key);
		}
	}
	*/
/**
	 * 判断缓存中是否对应的值
	 * @param key
	 * @return
	 *//*

	public boolean exists(final String key){
		return redisTemplate.hasKey(key);
	}
	*/
/**
	 * 批量删除keys
	 * @param pattern
	 *//*

	public void removePattern(final String pattern){
		Set<Serializable> keys = redisTemplate.keys(pattern);
		if(keys.size() > 0){
			redisTemplate.delete(keys);
		}
	}
	*/
/**
	 * 读取缓存
	 * @param key
	 * @return
	 *//*

	public Object get(final String key){
		ValueOperations<Serializable, Object> opsForValue = redisTemplate.opsForValue();
		return opsForValue.get(key);
	}
	*/
/**
	 * 哈希 添加  注意：hmSet方法，
	 *  isForce :false 只有当值不存在时存入 有值是忽略
	 *  		 true 无论如何都存入
	 * @param key
	 * @param hashKey
	 * @param value
	 * @return 原先旧值
	 *//*

	public Object hmSet(String key,Object hashKey,Object value,boolean update){
		Object obj = null;
		try {
			HashOperations<Serializable, Object, Object> opsForHash = redisTemplate.opsForHash();
			obj = opsForHash.get(key, hashKey);
			if(obj != null && update){
				opsForHash.delete(key, hashKey);
			}
			opsForHash.putIfAbsent(key, hashKey, value);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return obj;
	}
	*/
/**
	 * 获取所有hashMap 键值
	 *//*

	public Map<Object,Object> hmGetKeys(Serializable key){
		return redisTemplate.opsForHash().entries(key);
	}
	*/
/**
	 * 删除键下 对map键值
	 *//*

	public long hmDelete(Serializable key,Object...mapKeys){
		return redisTemplate.opsForHash().delete(key, mapKeys);
	}
	*/
/**
	 * 批量添加
	 *//*

	public void hmSets(Serializable key,Map<String,Object> maps){
		redisTemplate.opsForHash().putAll(key, maps);
	}
	*/
/**
	 * 哈希 获取数据
	 * @param key
	 * @param hashKey
	 * @return
	 *//*

	public Object hmGet(String key,Object hashKey){
		HashOperations<Serializable, Object, Object> hm = redisTemplate.opsForHash();
		return hm.get(key, hashKey);
	}
	*/
/**
	 * 列表添加   队列 右进左出  栈右进右出
	 * @param key
	 * @param value
	 *//*

	public void lPush(String key,Object value){
		ListOperations<Serializable, Object> lt = redisTemplate.opsForList();
		lt.rightPush(key, value);
	}
	*/
/**
	 * 列表获取
	 * 阻塞获取 当这段时间类有值时，获得该值，如果过了这段时间还没有值 返回为null
	 *//*

	public Object lPopInBlock(String key,long overtime,TimeUnit time){
		ListOperations<Serializable, Object> lt = redisTemplate.opsForList();
		return lt.leftPop(key, overtime, time);
	}
	*/
/**设置键超时时间*//*

	public Boolean expire(String key,long overtime,TimeUnit time){
		if(overtime <  0) return false;
		return redisTemplate.expire(key, overtime, time);
	}
	*/
/**
	 * 列表获取    直接获取列表值
	 *//*

	public Object lPopNoBlock(String key){
		ListOperations<Serializable, Object> lt = redisTemplate.opsForList();
		return lt.leftPop(key);
	}
	*/
/**
	 * 获取列表
	 * @param key
	 * @param begin
	 * @param end
	 * @return
	 *//*

	public List<Object> lRange(String key,long begin,long end){
		ListOperations<Serializable, Object> lt = redisTemplate.opsForList();
		return lt.range(key, begin, end);
	}
	*/
/**
	 * 集合添加
	 * @param key
	 * @param value
	 *//*

	public void addSetData(String key,Object value){
		redisTemplate.opsForSet().add(key, value);
	}
	*/
/**
	 * 集合获取
	 * @param key
	 * @return
	 *//*

	public Object getSetMembers(String key){
		return redisTemplate.opsForSet().members(key);
	}
	*/
/**
	 * 有序集合添加
	 * @param key
	 * @param value
	 * @param score
	 *//*

	public void addZSetData(String key,Object value,double score){
		redisTemplate.opsForZSet().add(key, value, score);
	}
	*/
/**
	 * 有序集合获取
	 * @param key
	 * @param beginScore
	 * @param endScore
	 * @return
	 *//*

	public Set<Object> getZSetRangeByScourc(String key,double beginScore,double endScore){
		return redisTemplate.opsForZSet().rangeByScore(key, beginScore, endScore);
	}
}
*/
