package com.comtika.safe.common.utils;

import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Locale;
import java.util.UUID;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * @author actor_miss[494977551@qq.com]
 * @date 2019/3/14 15:44
 */
public class IDUtil {
    private static final AtomicInteger ATOMIC_INTEGER = new AtomicInteger(0);
    private static final AtomicInteger RECHARGE_IT = new AtomicInteger(0);
    private static final AtomicInteger REFUND_IT = new AtomicInteger(0);
    private static final AtomicInteger CASH_IT = new AtomicInteger(0);
    private static final int PAY_UNIQUE_NO_SIZE = 100;
    private static final int PAY_IQUE_NO_SIZE = 10000;
    private static final ConcurrentHashMap<String,SimpleDateFormat> SDF_TIME = new ConcurrentHashMap<>();
    private static final ConcurrentHashMap<String,DecimalFormat> DF = new ConcurrentHashMap<>();
    private static final String PAY_UINQUENO = "id_pay_uinqueNo";
    private static final String RECHARGE_ORDER = "id_recharge_orderNo";
    private static final String CASH_ORDER = "id_cash_orderNo";
    /**内部编号*/
    private static AtomicInteger ai = new AtomicInteger();
    /**
     * 线程安全的获取20位唯一ID, 15位时间+5位自增
     * @return
     */
    public static String getPayUinqueNo(){
        SimpleDateFormat df = findSimpleDateFormat(PAY_UINQUENO);
        DecimalFormat df1 = findDecimalFormat(PAY_UINQUENO);
        //获取一个0-999999的数
        int i = ( ATOMIC_INTEGER.incrementAndGet() & Integer.MAX_VALUE ) % PAY_UNIQUE_NO_SIZE;
        if (i == 0) {
            i = ( ATOMIC_INTEGER.incrementAndGet() & Integer.MAX_VALUE ) % PAY_UNIQUE_NO_SIZE;
        }
        if(i > PAY_UNIQUE_NO_SIZE) ATOMIC_INTEGER.set(0);
        return df.format( System.currentTimeMillis() )+df1.format(i);
    }
    /**充值订单编号*/
    public static String createRechareOrderNo(){
        SimpleDateFormat df = findSimpleDateFormat(RECHARGE_ORDER);
        DecimalFormat df1 = findDecimalFormat(RECHARGE_ORDER);
        int i = ( RECHARGE_IT.incrementAndGet() & Integer.MAX_VALUE ) % PAY_IQUE_NO_SIZE;
        if (i == 0) {
            i = ( RECHARGE_IT.incrementAndGet() & Integer.MAX_VALUE ) % PAY_IQUE_NO_SIZE;
        }
        return  df.format( System.currentTimeMillis() )+df1.format(i);
    }
    //退款订单编号
    public static String createRefundOrderNo(){
        SimpleDateFormat df = findSimpleDateFormat(RECHARGE_ORDER);
        DecimalFormat df1 = findDecimalFormat(RECHARGE_ORDER);
        int i = ( REFUND_IT.incrementAndGet() & Integer.MAX_VALUE ) % PAY_IQUE_NO_SIZE;
        if (i == 0) {
            i = ( REFUND_IT.incrementAndGet() & Integer.MAX_VALUE ) % PAY_IQUE_NO_SIZE;
        }
        return  df.format( System.currentTimeMillis() )+df1.format(i);
    }

    /**提现订单编号*/
    public static String createCashOrderNo(){
        SimpleDateFormat df = findSimpleDateFormat(CASH_ORDER);
        DecimalFormat df1 = findDecimalFormat(CASH_ORDER);
        int i = ( CASH_IT.incrementAndGet() & Integer.MAX_VALUE ) % PAY_IQUE_NO_SIZE;
        if (i == 0) {
            i = ( CASH_IT.incrementAndGet() & Integer.MAX_VALUE ) % PAY_IQUE_NO_SIZE;
        }
        return  "TX_"+df.format(System.currentTimeMillis())+"_"+df1.format(i);
    }

    public static void main(String[] args) {
        for (int o=0;o<20;o++){
            System.out.println("........................");
            System.out.println(createCashOrderNo());
        }
    }
    /**获取时间*/
    private static SimpleDateFormat findSimpleDateFormat(String key){
        SimpleDateFormat df = SDF_TIME.get(key);
        if(df == null){
            if(PAY_UINQUENO.equals(key)){
                df = new SimpleDateFormat( "yyMMdd", Locale.CHINA );
            }else if(RECHARGE_ORDER.equals(key)){
                df = new SimpleDateFormat( "yyyyMMdd-HHmmss-SSS", Locale.CHINA );
            }else if (CASH_ORDER.equals(key)){
                df = new SimpleDateFormat( "yyMMdd", Locale.CHINA );
            }
            SDF_TIME.put(key,df);
        }
        return df;
    }
    public static String getUUID(){
        return UUID.randomUUID().toString().replace("-", "");
    }
    private static DecimalFormat findDecimalFormat(String key){
        DecimalFormat df = DF.get(key);
        if(df == null){
            if(PAY_UINQUENO.equals(key)){
                df = new DecimalFormat("00");
            }else if(RECHARGE_ORDER.equals(key)){
                df = new DecimalFormat("0000");
            }else if (CASH_ORDER.equals(key)){
                df = new DecimalFormat("0000");
            }
            DF.put(key,df);
        }
        return df;
    }
    public synchronized static String getSign(){
        DecimalFormat df1 = new DecimalFormat("000");
        //获取一个0-999的数
        int i = ( ai.incrementAndGet() & Integer.MAX_VALUE ) % 1000;
        if (i == 0) {
            i = ( ai.incrementAndGet() & Integer.MAX_VALUE ) % 1000;
        }
        return df1.format(i);
    }


}
