package com.comtika.safe.common.utils;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author actor_miss[494977551@qq.com]
 * @date 2019/3/19 19:23
 */
public class MapUtil {
    /**转换为String*/
    public static String convertStr(Map<String,Object> map, String key){
        Object o = map.get(key);
        if(o == null) return null;
        return o.toString();
    }
    /**转int*/
    public static Integer convertInt(Map<String,Object> map, String key){
        Object o = map.get(key);
        if(o == null) return null;
        return Integer.valueOf(o.toString());
    }
    /**转long*/
    public static Long convertLong(Map<String,Object> map, String key){
        Object o = map.get(key);
        if(o == null) return 0L;
        return Long.valueOf(o.toString());
    }
    /**转日期格式*/
    public static String convertDateFormat(Map<String,Object> map, String key,String format,boolean isSave){
        if (map.containsKey(key)) {
            Long aLong = convertLong(map, key);
            String res;
            if(aLong == null) {
                res =  "--";
            }else res = DateTimeUtils.formatDate(new Date(aLong),format);
            if(isSave)
                map.put(key,res);
            return res;
        }
        return "--";
    }
    public static String convertDateFormat(Map<String,Object> map, String key,String format){
        return convertDateFormat(map,key,format,true);
    }
    public static <T> void mapPut(Map<String, List<T>> map,T t,String key){
        List<T> ts = map.get(key);
        if(ts == null){
            ts = new ArrayList<>();
            ts.add(t);
            map.put(key,ts);
        }else ts.add(t);
    }
    public static void useTimeConvert(Map<String,Object> map,String key){
        Integer t = MapUtil.convertInt(map, key);
        if(t == null){
            map.put(key,"--");
            return;
        }
        int i = t / 60;
        StringBuilder sb = new StringBuilder();
        if(i > 0) sb.append(i+"小时");
        int tmp = t % 60;
        if(t % 60 != 0) tmp++;
        sb.append(tmp+"分");
        map.put(key,sb.toString());
    }
    /**支付转换*/
    public static void realFeeConver(Map<String,Object> map,String key){
        Integer integer = MapUtil.convertInt(map, key);
        if(integer == null) map.put(key,"--");
        else map.put(key,integer*1.0/100);
    }
    public static void realFeeConver(Map<String,Object> map,String...keys){
        for(String key:keys){
            if(StringUtil.isEmpty(key))continue;
            Integer integer = MapUtil.convertInt(map, key);
            if(integer == null) map.put(key,"--");
            else map.put(key,integer*1.0/100);
        }
    }
    public static String dateFormat(Long startTime,Long endTime){
        return DateTimeUtils.formatDate(new Date(startTime),DateTimeUtils.FORMAT_BRIEF)+"~"+DateTimeUtils.formatDate(new Date(endTime),DateTimeUtils.FORMAT_BRIEF);
    }
    public static String dateFormat(Long startTime){
        return DateTimeUtils.formatDate(new Date(startTime),DateTimeUtils.FORMAT_YMD);
    }
    public static String dateFormat(){
        return "截止"+DateTimeUtils.formatDate(new Date(System.currentTimeMillis()),DateTimeUtils.FORMAT_BRIEF);
    }


}
