package com.comtika.safe.common.utils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Map;

/**
 * 时间工具类
 * @author Administrator
 *
 */
public class TimeUtil {
	public static SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	/**
	 * 获取某个月份第一天的时间戳
	 * @return
	 * @throws ParseException
	 */
	public static Long dateMonthToStamp(String date) throws ParseException{
		String start = date +"-01 00:00:00";
		Date startDate = simpleDateFormat.parse(start);
		return startDate.getTime();
	}
	/**
	 * 获取某个月份第一天的时间戳
	 * @return
	 * @throws ParseException
	 */
	public static Long dateMonthToStamp(Integer year,Integer month) throws ParseException{
		Calendar cal = Calendar.getInstance();
		//设置年份
		cal.set(Calendar.YEAR,year);
		//设置月份
		cal.set(Calendar.MONTH, month-1);
		//设置为1号,当前日期既为本月第一天
		cal.set(Calendar.DAY_OF_MONTH, 1);
		//将小时至0
		cal.set(Calendar.HOUR_OF_DAY, 0);
		//将分钟至0
		cal.set(Calendar.MINUTE, 0);
		//将秒至0
		cal.set(Calendar.SECOND,0);
		//将毫秒至0
		cal.set(Calendar.MILLISECOND, 0);

		return cal.getTimeInMillis();
	}
	/**
	 * 获取某月最后一天的的时间戳
	 * @param month
	 * @return
	 * @throws ParseException
	 */
	public static Long dateMonthLastDayToStamp(Integer year,Integer month) throws ParseException{

		Calendar cal = Calendar.getInstance();
		//设置年份
		cal.set(Calendar.YEAR,year);
		//设置月份
		cal.set(Calendar.MONTH, month-1);
		//获取某月最大天数
		int lastDay = cal.getActualMaximum(Calendar.DAY_OF_MONTH);
		//设置日历中月份的最大天数
		cal.set(Calendar.DAY_OF_MONTH, lastDay);
		//格式化日期
		SimpleDateFormat simple = new SimpleDateFormat("yyyy-MM-dd");
		String lastDayOfMonth = simple.format(cal.getTime());
		lastDayOfMonth = lastDayOfMonth + " 23:59:59";
		return simpleDateFormat.parse(lastDayOfMonth).getTime();
	}
	/**
	 * 获取昨日日期零点和23点59分的时间戳
	 * @throws ParseException
	 */
	public static void yesterdayTime(Map<String, Object> map) throws ParseException{
		// dateToStamp(map);
		try {
			if (map.containsKey("startTime")) {
				Long time = Long.parseLong(map.get("startTime").toString());
				map.put("yesterdayStartTime", time-86400000L);
				map.put("yesterdayEndTime",time);
			}
		}catch (Exception e){

		}
	}
	/**
	 * 获取当前日期凌晨和当前时间的时间戳
	 * @throws ParseException
	 */
	public static void dateToStamp(Map<String, Object> map) throws ParseException{
		/*SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		SimpleDateFormat simpleDateFormat1 = new SimpleDateFormat("yyyy-MM-dd");
		Date date = new Date();
		String start = simpleDateFormat1.format(date)+" 00:00:00";
		Date startDate = simpleDateFormat.parse(start);*/
		long startTimeOfToday = DateTimeUtils.getStartTimeOfToday();
		map.put("startTime", startTimeOfToday);
		map.put("endTime", System.currentTimeMillis());
	}

}
