/*
package com.comtika.safe.config.redis;

import com.comtika.safe.common.redis.MyCacheErrorHandler;
import org.springframework.cache.CacheManager;
import org.springframework.cache.annotation.CachingConfigurerSupport;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.cache.interceptor.CacheErrorHandler;
import org.springframework.cache.interceptor.KeyGenerator;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.redis.cache.RedisCacheConfiguration;
import org.springframework.data.redis.cache.RedisCacheManager;
import org.springframework.data.redis.connection.RedisConnectionFactory;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.serializer.RedisSerializationContext;
import org.springframework.data.redis.serializer.RedisSerializer;
import org.springframework.data.redis.serializer.StringRedisSerializer;
import java.time.Duration;

*/
/**
 * @Author: miss[494977551@qq.com]
 * @Date: Create in 17:35 2019/6/11
 * @DESC:
 **//*

@Configuration
@EnableCaching // 开启缓存支持
public class RedisCommonConfig extends CachingConfigurerSupport {

    @Bean("redisTemplate")
    public RedisTemplate<String, Object> redisTemplate(RedisConnectionFactory redisConnectionFactory) {

        RedisTemplate<String, Object> template = new RedisTemplate<>();
        RedisSerializer<String> redisSerializer = new StringRedisSerializer();
        template.setConnectionFactory(redisConnectionFactory);
        //key序列化方式
        template.setKeySerializer(redisSerializer);
        //value序列化
        template.setValueSerializer(DefaultJackson2JsonRedisSerializer.DEFAULT_JACKJSON);
        //value hashmap序列化
        template.setHashValueSerializer(DefaultJackson2JsonRedisSerializer.DEFAULT_JACKJSON);
        return template;
    }

    @Bean
    public KeyGenerator keyGenerator() {
        return (t,m,o)->{
            StringBuffer sb = new StringBuffer();
            sb.append(t.getClass().getName());
            sb.append(m.getName());
            for (Object obj : o) {
                sb.append(obj.toString());
            }
            return sb.toString();
        };
    }
    @Bean
    public CacheManager cacheManager(RedisConnectionFactory redisConnectionFactory) {
        RedisSerializer<String> redisSerializer = new StringRedisSerializer();
        // 配置序列化（解决乱码的问题）,过期时间30秒
        RedisCacheConfiguration config = RedisCacheConfiguration.defaultCacheConfig()
                .entryTtl(Duration.ofSeconds(30))
                .serializeKeysWith(RedisSerializationContext.SerializationPair.fromSerializer(redisSerializer))
                .serializeValuesWith(RedisSerializationContext.SerializationPair.fromSerializer(DefaultJackson2JsonRedisSerializer.DEFAULT_JACKJSON))
                .disableCachingNullValues();
        RedisCacheManager cacheManager = RedisCacheManager.builder(redisConnectionFactory)
                .cacheDefaults(config)
                .build();
        return cacheManager;
    }
    */
/**
     * redis数据操作异常处理 这里的处理：在日志中打印出错误信息，但是放行
     * 保证redis服务器出现连接等问题的时候不影响程序的正常运行，使得能够出问题时不用缓存
     *
     * @return
     *//*

    @Bean
    @Override
    public CacheErrorHandler errorHandler() {
        return new MyCacheErrorHandler();
    }

}
*/
