package com.comtika.safe.config.swagger2;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.Contact;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

@Configuration
@EnableSwagger2
public class SwaggerConfig {
    @Bean
    public Docket docket() {
        ApiInfoBuilder version = new ApiInfoBuilder()
                .title("康体佳||安全用电")
                .description("康体佳||安全用电API")
                .termsOfServiceUrl("https://www.comtikaiot.cn/api/")
                .version("1.0.0");

        version.contact(new Contact("missMyLove", "", "494977551@qq.com"));

        return new Docket(DocumentationType.SWAGGER_2)
                .apiInfo(version.build())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.comtika.safe.controller"))
                .paths(PathSelectors.any())
                .build();
    }

}
