package com.comtika.safe.controller.equip.product;


import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.comtika.safe.common.action.BaseController;
import com.comtika.safe.common.response.RespWrapper;
import com.comtika.safe.entity.equip.product.CtkProductType;
import com.comtika.safe.service.equip.product.ProductService;

@RestController
@RequestMapping("/equip/product")
public class ProductController extends BaseController{
	
	@Autowired
	private ProductService productService;
	
	@ApiOperation(value = "新增产品类型", notes = "新增产品类型")
	@ApiImplicitParam(name = "ctkProductType", value = "产品类型实体", required = false, dataType = "CtkProductType",paramType="query")
	@PostMapping("/add")
	public RespWrapper<Object> addProduct( @RequestBody CtkProductType ctkProductType){
		return productService.addProduct(ctkProductType);
	}
	
	@ApiOperation(value = "产品列表", notes = "产品列表")
	@GetMapping("/list")
	public RespWrapper<Object> queryList(){
		return productService.queryList();
	}
	
	@ApiOperation(value = "修改产品", notes = "修改产品")
	@ApiImplicitParam(name = "ctkProductType", value = "产品类型实体", required = false, dataType = "CtkProductType",paramType="query")
	@PostMapping("/update")
	public RespWrapper<Object> update( @RequestBody CtkProductType ctkProductType){
		return productService.update(ctkProductType);
	}
}
