package com.comtika.safe.controller.homePage;

import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.comtika.safe.common.action.BaseController;
import com.comtika.safe.common.response.RespWrapper;
import com.comtika.safe.service.homePage.HomePageService;

/**
 * 首页数据查询
 * @author Jimmy
 *
 */
@RestController
@RequestMapping("homePage")
public class HomePageController extends BaseController{

	@Autowired
	private HomePageService homePageService;


	@ApiOperation(value = "首页数据查询，查询商户数据与站点数量", notes = "首页数据查询，查询商户数据与站点数量")
	@PostMapping("/queryMerchantAndSiteNumber")
	public RespWrapper<Object> queryMerchantAndSiteNumber(){
		return homePageService.queryMerchantAndSiteNumber(super.getOrgData());
	}

	@ApiOperation(value = "首页数据查询，查询设备总数，在线设备，三项设备，单项设备", notes = "首页数据查询，查询设备总数，在线设备，三项设备，单项设备")
	@PostMapping("/queryEquipNumber")
	public RespWrapper<Object> queryEquipNumber(){
		return homePageService.queryEquipNumber(super.getOrgData());
	}

	@ApiOperation(value = "首页地图站点数据", notes = "首页地图站点数据")
	@PostMapping("/querySite")
	public RespWrapper<Object> querySite(){
		return homePageService.querySite(super.getOrgData());
	}

	@ApiOperation(value = "查询首页总电量，今日电量接口")
	@GetMapping("findHomeEleTotal")
	public RespWrapper findHomeEleTotal(){
		return homePageService.findHomeEleTotal(findUserCache());
	}

}
