package com.comtika.safe.controller.log;


import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.comtika.safe.common.action.BaseController;
import com.comtika.safe.common.response.RespWrapper;
import com.comtika.safe.service.log.LogService;

@RestController
@RequestMapping("/log")
public class LogController extends BaseController{
	
	@Autowired
	private LogService logService;
	
	@ApiOperation(value = "查询登录日志", notes = "查询登录日志")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "loginName", value = "登录名", required = false, dataType = "String",paramType="query"),
            @ApiImplicitParam(name = "startTime", value = "开始时间", required = false, dataType = "Long",paramType="query"),
            @ApiImplicitParam(name = "endTime", value = "结束时间", required = false, dataType = "Long",paramType="query"),
            @ApiImplicitParam(name = "start", value = "页数", required = false, dataType = "Integer",paramType="query"),
            @ApiImplicitParam(name = "size", value = "页容量", required = false, dataType = "Integer",paramType="query")
    })
	@PostMapping("/queryLoginLog")
	public RespWrapper<Object> queryLoginLog(Integer start,Integer size, String loginName,Long startTime,Long endTime){
		return logService.queryLoginLog(  start, size,loginName, startTime, endTime);
	}
	
	@ApiOperation(value = "查询操作日志", notes = "查询操作日志")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "loginName", value = "登录名", required = false, dataType = "String",paramType="query"),
            @ApiImplicitParam(name = "startTime", value = "开始时间", required = false, dataType = "Long",paramType="query"),
            @ApiImplicitParam(name = "endTime", value = "结束时间", required = false, dataType = "Long",paramType="query"),
            @ApiImplicitParam(name = "start", value = "页数", required = false, dataType = "Integer",paramType="query"),
            @ApiImplicitParam(name = "size", value = "页容量", required = false, dataType = "Integer",paramType="query"),
            @ApiImplicitParam(name = "name", value = "用户姓名", required = false, dataType = "String",paramType="query"),
            @ApiImplicitParam(name = "visitType", value = "模块类别", required = false, dataType = "String",paramType="query")
    })
	@PostMapping("/queryVisitLog")
	public RespWrapper<Object> queryVisitLog(){
		return logService.queryVisitLog(request);
	}
	
	@ApiOperation(value = "查询异常日志", notes = "查询异常日志")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "loginName", value = "登录名", required = false, dataType = "String",paramType="query"),
            @ApiImplicitParam(name = "startTime", value = "开始时间", required = false, dataType = "Long",paramType="query"),
            @ApiImplicitParam(name = "endTime", value = "结束时间", required = false, dataType = "Long",paramType="query"),
            @ApiImplicitParam(name = "start", value = "页数", required = false, dataType = "Integer",paramType="query"),
            @ApiImplicitParam(name = "size", value = "页容量", required = false, dataType = "Integer",paramType="query"),
            @ApiImplicitParam(name = "name", value = "用户姓名", required = false, dataType = "String",paramType="query"),
            @ApiImplicitParam(name = "errorType", value = "模块类别", required = false, dataType = "String",paramType="query")
    })
	@PostMapping("/queryErrorLog")
	public RespWrapper<Object> queryErrorLog(){
		return logService.queryErrorLog(request);
	}
}
