package com.comtika.safe.controller.mobile;

import com.comtika.safe.common.action.BaseController;
import com.comtika.safe.common.response.RespWrapper;
import com.comtika.safe.entity.mobile.EleTotalQueryHelp;
import com.comtika.safe.entity.safe.TerminalNewestData;
import com.comtika.safe.service.mobile.IMobileService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * @Author: miss[494977551@qq.com]
 * @Date: Create in 15:21 2020/10/24
 * @DESC: 手机端新增接口
 **/
@RestController
@RequestMapping("mobile")
@Api(description = "手机端增加的部分接口")
public class MobileController extends BaseController {

    @Autowired
    private IMobileService iMobileService;

    @ApiOperation(value = "获取用户站点电量统计")
    @PostMapping("findSiteEleTotal")
    public RespWrapper<Map<String,Object>> findUserSiteEleTotal(@RequestBody EleTotalQueryHelp help){
        // 这里应该还有时间
        if(help.getStartTime() == null || help.getEndTime() == null) return RespWrapper.makeFailResp("查询时间不能为空");

        return iMobileService.findUserSiteEleTotal(help,findUserCache());
    }
    @ApiOperation(value = "查询各设备电量统计")
    @PostMapping("findTerminalEleTotal")
    public RespWrapper<Map<String,Object>> findTerminalEleTotal(@RequestBody EleTotalQueryHelp help){
        // 这里应该还有时间
        if(help.getStartTime() == null || help.getEndTime() == null) return RespWrapper.makeFailResp("查询时间不能为空");
        if(help.getSiteId() == null) return RespWrapper.makeFailResp("站点id不能为空");
        return iMobileService.findTerminalEleTotal(help,findUserCache());
    }

    @ApiOperation(value = "查询各插座电量统计")
    @PostMapping("findSocketEleTotal")
    public RespWrapper<Map<String,Object>> findSocketEleTotal(@RequestBody EleTotalQueryHelp help){
        if(help.getStartTime() == null || help.getEndTime() == null) return RespWrapper.makeFailResp("查询时间不能为空");
        if(help.getTerminalId() == null) return RespWrapper.makeFailResp("设备id不能为空");
        return iMobileService.findSocketEleTotal(help);
    }

    @ApiOperation(value = "查询设备列表电量统计曲线")
    @PostMapping("findTerminalTotalList")
    public RespWrapper findTerminalEleTotalList(@RequestBody EleTotalQueryHelp help){
        if(help.getStartTime() == null || help.getEndTime() == null) return RespWrapper.makeFailResp("查询时间不能为空");
        if(help.getTerminalId() == null) return RespWrapper.makeFailResp("设备id不能为空");
        return iMobileService.findTerminalEleTotalList(help);
    }
    @GetMapping("findTerminalDataTotal/{terminalNo}")
    public RespWrapper<Map<String,Object>> findTerminalDataTotal(@PathVariable("terminalNo")String terminalNo){
        return iMobileService.findTerminalDataTotal(terminalNo);
    }
    @GetMapping("findTerminalNewDataInfo/{id}")
    public RespWrapper<TerminalNewestData> findTerminalNewDataInfo(@PathVariable("id")Integer id){
        return iMobileService.findTerminalNewDataInfo(id);
    }



}
