package com.comtika.safe.controller.ota;

import com.comtika.safe.common.action.BaseController;
import com.comtika.safe.common.response.RespWrapper;
import com.comtika.safe.entity.ota.OtaRecord;
import com.comtika.safe.service.ota.IOtaService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.beetl.sql.core.engine.PageQuery;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("ota")
@Api(description = "OTA 管理")
public class OtaController extends BaseController {
    @Autowired
    private IOtaService iOtaService;

    @GetMapping("findHsVesionPage")
    public RespWrapper<PageQuery<Map<String,Object>>> findFadVersionPage(Integer start,Integer size,String hsName,Long startTime,Long endTime){
        return iOtaService.findFadVersionPage(start,size,hsName,startTime,endTime);
    }
    @ApiOperation(value = "新增OTA版本")
    @PostMapping("/addOTAHsVersion")
    public RespWrapper<Boolean> addOTAVersion(@RequestBody OtaRecord ck) {
        return iOtaService.addOTAVersion(ck);
    }
    @ApiOperation(value = "修改OTA版本")
    @PostMapping("/updateOneHsVersion")
    public RespWrapper<Boolean> updateOTAHsVersion(@RequestBody OtaRecord hs){
        return iOtaService.updateOTAHsVersion(hs);
    }
    @ApiOperation(value = "OTA 版本升级时，先调用该接口查询所有升级的OTA版本，升级时传otaId 升级")
    @GetMapping("findAllOtaVersion")
    public RespWrapper<List<OtaRecord>> findAllOtaVersion(){
        return iOtaService.findAllOtaVersion();
    }

    @ApiOperation(value = "删除OTA")
    @DeleteMapping("deleteOta/{id}")
    public RespWrapper<Boolean> deleteOta(@PathVariable("id")Integer id){
        return iOtaService.deleteOta(id);
    }

}
