package com.comtika.safe.core.aspect;

import com.comtika.safe.common.utils.StringUtil;
import com.comtika.safe.core.async.AsyncHelp;
import lombok.extern.slf4j.Slf4j;
import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.Signature;
import org.aspectj.lang.annotation.AfterThrowing;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Pointcut;
import org.aspectj.lang.reflect.MethodSignature;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.lang.reflect.Method;

/**
 * @Author: miss[494977551@qq.com]
 * @Date: Create in 10:42 2019/9/6
 * @DESC:   aop 日志运用 错误日志
 **/
@Component
@Aspect
@Slf4j
public class ComtikaAspect {


    @Autowired
    private AsyncHelp asyncHelp;


    @Pointcut("@annotation(com.comtika.safe.core.aspect.ComtikaLog)")
    public void pointCut(){};



    private Method getInvokeMethod(JoinPoint joinPoint) {
        Signature signature = joinPoint.getSignature();
        MethodSignature methodSignature = (MethodSignature)signature;
        Method targetMethod = methodSignature.getMethod();
        return targetMethod;
    }
    private static final String ERROR_MSG = "请求方法：%s,请求类型：%s，请求参数：%s，异常信息：%s。";
    // private static final String PARAM_FORM = "\"%s\":\"%s\"";
    /**
     * 异常 处理数据
     * @param joinPoint
     * @param e
     */
    @AfterThrowing(pointcut = "pointCut()",throwing = "e")
    public void afterThrowing(JoinPoint joinPoint, Throwable e){
        Method method = getInvokeMethod(joinPoint);
        ComtikaLog annotation = method.getAnnotation(ComtikaLog.class);
        LogServiceType logType = annotation == null? LogServiceType.COMMON : annotation.logType();
        HttpServletRequest request = ((ServletRequestAttributes) RequestContextHolder.getRequestAttributes()).getRequest();
        HttpSession session = request.getSession();
        String userId;
        // 兼容2套方式获取操作者id
        if(logType == LogServiceType.APP){
            //Object attribute = session.getAttribute(ProjectConstant.AUTH_ENTITY_KEY);

        }else {

        }
        String describe = annotation.methodName();
        String methodName = StringUtil.isNotEmpty(describe)?describe:method.getName();
        //asyncHelp.addErrorLog(userId,logType.getName(), BaseAuthUtil.doGetRequestIp(request),String.format(ERROR_MSG,method.getName(),request.getMethod(),findRequestParam(joinPoint.getArgs(),request),e.getMessage()));
        //asyncHelp.addErrorLog(userId,logType.getName(), BaseAuthUtil.doGetRequestIp(request),String.format(ERROR_MSG,methodName,request.getMethod(), Arrays.toString(joinPoint.getArgs()),e.getMessage()));
    }
    //@Before("pointCut()")
    public void before(JoinPoint joinPoint)  {
    }

    //private LogServiceType findLogType(Method method){
    //    ComtikaLog annotation = method.getAnnotation(ComtikaLog.class);
    //    return annotation == null? LogServiceType.COMMON : annotation.logType();
    //}
   /* private String findParamByParameterNames(HttpServletRequest request){
        return findParamByParameterNames(request,true);
    }
    private String findParamByParameterNames(HttpServletRequest request, boolean isEnd){
        StringBuilder sb = new StringBuilder("{");
        Enumeration<String> headerNames = request.getParameterNames();
        boolean isNoAddPrefix = true;
        String key;
        while (headerNames.hasMoreElements()){
            key = headerNames.nextElement();
            if(isNoAddPrefix){
                isNoAddPrefix = false;
            }else  sb.append(",");
            sb.append(String.format(PARAM_FORM, key,request.getParameter(key)));
        }
        if(isEnd)sb.append("}");
        return sb.toString();
    }

    private String findRequestParam(Object[] obj, HttpServletRequest request){
        int length = obj.length;
        if(length == 1){
            Object oneObj = obj[0];
            if(oneObj instanceof MultipartFile){
                return "{\"文件名\":"+((MultipartFile) oneObj).getOriginalFilename()+"}";
            }else if(oneObj instanceof StandardMultipartHttpServletRequest){
                return findParamByParameterNames(request);
            }else if(oneObj instanceof String || oneObj instanceof Integer){
                // 这里说明只有一个参数
                return findParamByParameterNames(request);
            }
            return JSONObject.toJSONString(oneObj);
        }else {
            boolean isFile = false;
            String fileName = null;
            for(Object ob:obj){
                if(ob instanceof MultipartFile){
                    isFile = true;
                    fileName = ((MultipartFile) ob).getOriginalFilename();
                    break;
                }
            }
            String params = findParamByParameterNames(request, !isFile);
            if (isFile) {
                if(params.length() > 3){
                    params += ",\"文件名\":"+fileName;
                }else {
                    params += "\"文件名\":"+fileName;
                }
                params += "}";
            }
            return params;
        }
    }*/
}
