package com.comtika.safe.core.exception;


import com.comtika.safe.common.action.BaseController;
import com.comtika.safe.common.exception.RespException;
import com.comtika.safe.common.exception.UnOAuthException;
import com.comtika.safe.common.response.RespCode;
import com.comtika.safe.common.response.RespWrapper;
import com.comtika.safe.core.aspect.ComtikaLog;
import com.comtika.safe.core.aspect.LogServiceType;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;


/**
 * 全局异常处理
 * @author actor_miss[494977551@qq.com]
 * @date 2019/8/6 18:30
 */
@ControllerAdvice
public class ComtikaExceptionHanlder extends BaseController {

    /**
     * 浏览器和其他客户端都返回了json 数组，不满足自适应，当前后端分离满足要求
     * @return
     */
    @ExceptionHandler(value= RespException.class)
    @ResponseBody
    @ComtikaLog(logType = LogServiceType.EX_HANDLE)
    public RespWrapper<String> dealException(RespException e){
        if(e instanceof UnOAuthException){
            response.setStatus(RespCode.UNAUTHORIZED);
            return null;
        }
        return RespWrapper.makeResp(RespCode.FAIL,"系统繁忙,请重试",null);
    }

}
