package com.comtika.safe.core.interceptor;

import com.comtika.safe.common.constant.ProjectConstant;
import com.comtika.safe.common.response.RespCode;

import org.springframework.web.servlet.HandlerInterceptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.util.regex.Pattern;


public class ExpressAuthHandlerInterceptor implements HandlerInterceptor {

    private static final Pattern[] PASS_PATTERN = new Pattern[]{
            Pattern.compile(".*/user/pass/.*"),
            Pattern.compile("/user/login"),
            Pattern.compile("/user/logout"),
            Pattern.compile("/messagepush/checkWeChatCode"),
            Pattern.compile("/messagepush/weChatAcCodeAuth"),
            Pattern.compile("/messagepush/sendPhoneCode/*"), // 发生验证码接口放行
    };
    private static final String ONE_LS = "/";
    private static final String TWO_LS = "//";



    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        // 下面还需处理
        String requestURI = request.getRequestURI().replaceAll(TWO_LS, ONE_LS);
        //System.out.println("访问URL:"+requestURI);
        //TODO 过滤白名单
        for(Pattern p:PASS_PATTERN){
            if(p.matcher(requestURI).matches()) return true;
        }
        //todo 登录时将这个值放置里面 UserCoreCache 在其他地方用到时拿出
        if (request.getSession().getAttribute(ProjectConstant.COMTIKA_SAFE_TOKEN) == null) {
            printWriterOut(response,RespCode.UNAUTHORIZED);//这里需要登入
            return false;
        }
       return true;
    }


    /**
     * 异常输出
     */
    private void printWriterOut(HttpServletResponse response, int code) {
        response.setContentType("text/json; charset=utf-8");
        response.setStatus(code);
    }
}
