package com.comtika.safe.core.lucene.pool;

import com.comtika.safe.core.lucene.LuceneUtils;
import org.apache.commons.pool2.BasePooledObjectFactory;
import org.apache.commons.pool2.PooledObject;
import org.apache.commons.pool2.impl.DefaultPooledObject;
import org.apache.lucene.index.IndexWriter;

/**
 * @Author: miss[494977551@qq.com]
 * @Date: Create in 9:54 2020/9/11
 * @DESC:
 **/
public class WritePoolFactory extends BasePooledObjectFactory<IndexWriter> {

    private LuceneUtils.LuceneType luceneType;
    public WritePoolFactory(LuceneUtils.LuceneType type){
        this.luceneType = type;
    }

    @Override
    public IndexWriter create() throws Exception {
        return LuceneUtils.findWriter(luceneType);
    }

    @Override
    public PooledObject<IndexWriter> wrap(IndexWriter indexWriter) {
        return new DefaultPooledObject<>(indexWriter);
    }
    @Override
    public void destroyObject(PooledObject<IndexWriter> p) throws Exception {
        super.destroyObject(p);
        if(p != null)
            p.getObject().close();
    }
}
