package com.comtika.safe.core.lucene.pool;

import com.comtika.safe.core.lucene.LuceneUtils;
import org.apache.commons.pool2.impl.GenericObjectPool;
import org.apache.commons.pool2.impl.GenericObjectPoolConfig;
import org.apache.lucene.index.IndexWriter;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @Author: miss[494977551@qq.com]
 * @Date: Create in 9:45 2020/9/11
 * @DESC:
 **/
public class WriterPool {

    private static Map<LuceneUtils.LuceneType,WriterPool> LT = new ConcurrentHashMap<>();

    public static WriterPool findWitePool(LuceneUtils.LuceneType luceneType){
        WriterPool writerPool = LT.get(luceneType);
        if(writerPool == null){
            WriterPool instance = new WriterPool(luceneType);
            LT.put(luceneType,instance);
            return instance;
        }
        return writerPool;
    }


    private GenericObjectPoolConfig getDefaultConfig() {
        GenericObjectPoolConfig conf = new GenericObjectPoolConfig();
        conf.setMaxTotal(50);
        conf.setMaxIdle(0);
        conf.setMinIdle(0);
        conf.setMaxWaitMillis(60000);
        return conf;
    }
   /* private volatile static WriterPool pool;
    private static WriterPool getInstance(LuceneUtils.LuceneType ftpConfig) {
        if (pool == null) {
            synchronized (WriterPool.class) {
                if (pool == null) {
                    pool = new WriterPool(ftpConfig);
                }
            }
        }
        return pool;
    }*/
    private static GenericObjectPool<IndexWriter> connPool;
    private WriterPool(LuceneUtils.LuceneType type) {
        connPool = new GenericObjectPool<IndexWriter>(new WritePoolFactory(type), getDefaultConfig());
    }

    public IndexWriter getConnection() {
        try {
            return connPool.borrowObject();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public void close(IndexWriter conn) {
        if (conn != null) {
            try {
                conn.close();
            }catch (Exception e){

            }
        }
    }
    public void returnConnection(IndexWriter conn) {
        if(conn != null)
            connPool.returnObject(conn);
    }
}
