package com.comtika.safe.core.protocol;

import java.util.HashMap;
import java.util.Map;

public class ComtikaExtra {
    private Map<String, Object> params = new HashMap<>(4);

    public void putExtra(String str, Object obj) {
        params.put(str, obj);
    }

    public String getExtraString(String key) {
        return (String) params.get(key);
    }

    public <T> T getExtra(String attribute, Class<T> clazz) {
        Object obj = params.get(attribute);
        if (obj == null) {
            return null;
        }
        if (clazz.isAssignableFrom(obj.getClass())) {
            return (T) obj;
        } else {
            throw new ClassCastException(obj.getClass().getName() + " cannot be cast to " + clazz.getName());
        }
    }
    public Object getExtra(String key){
        return params.get(key);
    }
}
