package com.comtika.safe.core.protocol.cache;


import com.comtika.safe.common.constant.ProjectConstant;
import com.comtika.safe.common.exception.RespException;
import com.comtika.safe.common.utils.StringUtil;
import com.comtika.safe.core.protocol.entity.charge.ChargeEnd;
import com.comtika.safe.core.protocol.entity.node.NodeChargeData;
import com.comtika.safe.core.protocol.entity.version.OTAUpgradeEntity;
import com.comtika.safe.core.protocol.ProtocolConstant;
import org.springframework.stereotype.Component;

import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;

/**
 *
 * @ClassName: BlackListCache
 * @Description: 协议层 redis缓存
 * @author zhaoLuYang
 * @date2018年7月17日 下午4:02:59
 * @version V1.0
 */
@Component
public class ProtocolRedisCache {
	/*@Autowired
	private RedisApi redisApi;*/
	/**集中器**/
	/*@Autowired
	private EquipTerminalDao terminalDao;*/

	/***添加黑名单  加黑名单只有5分钟，5分钟后会过期*/
	public void addTerminalBlacklist(String addrNo){
		SafeCache.FIVE_CREATE_CACHE.set(ProjectConstant.BLACK_LIST_ADDRNO+addrNo,true);
	}
	/**判断是否在黑名单中*/
	public boolean checkTerminalBlacklist(String addrNo){
		return SafeCache.FIVE_CREATE_CACHE.getIfPresent(ProjectConstant.BLACK_LIST_ADDRNO+addrNo) != null;
	}
	/**移除黑名单*/
	public void removeTerminalBlacklist(String addrNo){
		SafeCache.FIVE_CREATE_CACHE.remove(ProjectConstant.BLACK_LIST_ADDRNO+addrNo);
	}
	/***黑名单缓存                ================================               end**/
	/**获取版本数据*/
	public Byte[] findTerminalOTAData(Integer id){
		// 这里使用本地缓存
		/*Object o = redisApi.get(ProjectConstant.OTA_DATAS_KEY + id);
		if(o != null) return (Byte[]) o;
		return null;*/
		return SafeCache.findOTAData(ProjectConstant.OTA_DATAS_KEY + id);
	}
	public static void removeOTAData(Integer id){
		SafeCache.removeOTAData(ProjectConstant.OTA_DATAS_KEY + id);
	}

	//otaDatasKey46
	public void addTermianlOTAData(Integer id,Byte[] bytes){
		//redisApi.set(ProjectConstant.OTA_DATAS_KEY + id,bytes,1L,TimeUnit.DAYS);
		SafeCache.saveOTAData(ProjectConstant.OTA_DATAS_KEY + id,bytes);
	}

	private String createKey(String uniqueNo,int plugNo){
		return String.format(ProtocolConstant.EX_ORDER_UNIQUE_NO,uniqueNo,plugNo);

	}
	public boolean checekEXOrderList(String uniqueNo,int plugNo){
		String key = createKey(uniqueNo,plugNo);
		return SafeCache.FIVE_CREATE_CACHE.getIfPresent(key) != null;
	}


	/**2018 年 12月 5日 端点升级准备去掉*/
	/***OTA 端点    start*/
	/**获取断点Map 数据**/
	public Map<String, OTAUpgradeEntity> findOTAPoint(){
		/*try {
			Object obj = redisApi.get(ProjectConstant.OTA_PROTOCOL_DATA_KEY);
			if(obj != null){
				return (Map<String, OTAUpgradeEntity>) obj;
			}
		} catch (Exception e) {
			e.printStackTrace();
		}*/
		return null;
	}
	/***更新断点数据*/
	public void updateOTAOPoint(String addrNo,OTAUpgradeEntity ota){
		/*try {
			Map<String, OTAUpgradeEntity> findOTAPoint = findOTAPoint();
			if(findOTAPoint != null && findOTAPoint.containsKey(addrNo))
				findOTAPoint.remove(addrNo);
			*//*boolean bl = true;
			if(ota.getOTAStaus() == OTAStatus.OTA_SUCCESS || ota.getOTAStaus() == OTAStatus.OTA_FALL){
				if(findOTAPoint.containsKey(addrNo)){
					findOTAPoint.remove(addrNo);
				}else{
					bl = false;
				}
			}else{
				findOTAPoint.put(addrNo, ota);
			}
			if(bl){
				redisApi.set(ProjectConstant.OTA_PROTOCOL_DATA_KEY, findOTAPoint);
			}*//*
		} catch (Exception e) {
			e.printStackTrace();
		}*/
	}
	public void updateOTAPoint2(Map<String, OTAUpgradeEntity> map){
		//redisApi.set(ProjectConstant.OTA_PROTOCOL_DATA_KEY,map);
	}

	/**删除指定OTA 断点数据*/
	public void removeOTAPoint(String addrNo){
		try {
		/*	Map<String, OTAUpgradeEntity> findOTAPoint = findOTAPoint();
			if(findOTAPoint.containsKey(addrNo)){
				findOTAPoint.remove(addrNo);
				redisApi.set(ProjectConstant.OTA_PROTOCOL_DATA_KEY, findOTAPoint);
			}*/
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/***
	 * OTA 获取指定集中器断点数据
	 */
	public OTAUpgradeEntity findOTAPointByTerminalNo(String addrNo){
		try {
			/*Map<String, OTAUpgradeEntity> findOTAPoint = findOTAPoint();
			if(findOTAPoint.containsKey(addrNo)){
				return findOTAPoint.get(addrNo);
			}*/
		} catch (Exception e) {
			e.printStackTrace();
		}
		return new OTAUpgradeEntity();
	}
	/*****OTA 端点  end ***/
	/**更新集中器在线列表**/
	/*public void updateTerminalOnlineList(List<String> list){
		try {
			redisApi.set(ProjectConstant.TERMINAL_ON_LINE_LIST,list);
		}catch (Exception e){}
	}*/
	/**获取在线集中器列表**/
/*	public List<String> findTerminalOnlineList(){
		try {
			Object obj = redisApi.get(ProjectConstant.TERMINAL_ON_LINE_LIST);
			if(obj != null)return (List<String>) obj;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return new ArrayList<String>();
	}*/
	/**判断集中器是否在线*/
	/*public boolean checkTerminalOnlineList(String addrNo){
		try {
			return findTerminalOnlineList().contains(addrNo);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return false;
	}*/
	/**强制使集中器掉线  使用到场景 OTA升级通知成功后需清除*/
	/*public void forceTerminalDownNow(String addrNo){
		try {
			List<String> list = findTerminalOnlineList();
			if(list.contains(addrNo)){
				list.remove(addrNo);
				redisApi.set(ProjectConstant.TERMINAL_ON_LINE_LIST, list);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}*/
	/**获取集中器与节点的关系*/
	private static final String TERMINAL_NO_NODE = "terminal_node_";
	public static final String EMPTY_TERMINAL = " ";


	/******==================集中器订单========================*/
	private static final String ORDER_CHANGE_ING = "oder_change_";//充电中的订单
	public void addChargeOrderNo(String orderNo){
		// redisApi.set(ORDER_CHANGE_ING+orderNo,1,2L,TimeUnit.DAYS);
	}
	public boolean checkChargeOrderNo(String orderNo){
		//return redisApi.exists(ORDER_CHANGE_ING+orderNo);
		return true;
	}
	public void removeChargeOrderNo(String orderNo){
		// redisApi.remove(ORDER_CHANGE_ING+orderNo);
	}
	/**=======================================================*/
	//下面使用 保存用户最后一次充电数据
	/**获取上报数据*/
	public NodeChargeData findUserChargeData(String orderNo){
		/*try {
			Object o = redisApi.get(insideOrderNoConvert(orderNo));
			if( o != null) return (NodeChargeData) o;
		}catch (Exception e){
			e.printStackTrace();
		}*/
		return null;
	}
	/**处理上报数据*/
	public void handleUserChargeData(ChargeEnd chargeEnd, String orderNo){
		if(chargeEnd == null) return;
		if(StringUtil.isEmpty(orderNo)) return;
		NodeChargeData userChargeData = findUserChargeData(orderNo);
		if(userChargeData != null){
			chargeEnd.setPlugNo(userChargeData.getPlugNo());
			chargeEnd.setEleEPLast(userChargeData.getEleEPLast());
			chargeEnd.setEleEP(userChargeData.getEleEP());
			chargeEnd.setChargeTime(userChargeData.getChargeTime());
			removeUserChargeData(orderNo);
		}
	}
	/**上报数据*/
	private String insideOrderNoConvert(String orderNo){
		if(StringUtil.isEmpty(orderNo))throw new RespException("操作充电数据，订单编号不能为空");
		return String.format(ProtocolConstant.PREFIX_CHARGE_DATA,orderNo);
	}
	/**更新用户充点数据*/
	public void updateUserChargeData(String orderNo,NodeChargeData data){
		/*try {
			if(data != null) redisApi.set(insideOrderNoConvert(orderNo),data,1L,TimeUnit.DAYS);//用户充电数据最多保存一天
		}catch (Exception e){}*/
	}
	/***充电数据在结束时，移除 */
	public void removeUserChargeData(String orderNo){
		/*try {
			redisApi.remove(insideOrderNoConvert(orderNo));
		}catch (Exception e){}*/
	}
	/**默认是60分钟 --> 1个小时   */
	public int findTerminalShowdownTimeoutMillisecond(){
		int res = ProtocolConstant.DEFALUT_TIMEOUT;
		/*try {
			Object time = redisApi.get(ProjectConstant.PROTOCOL_SHOWDOWN_TIMEOUT);
			if(time != null) {
				res = StringUtil.convertInt(time.toString(), ProtocolConstant.DEFALUT_TIMEOUT);
				if( res < ProtocolConstant.MIN_DROP_LINE_TIMEOUT_MINUTE || res > ProtocolConstant.DEFALUT_TIMEOUT) res = ProtocolConstant.DEFALUT_TIMEOUT;
			}
		}catch (Exception e){
			redisApi.remove(ProjectConstant.PROTOCOL_SHOWDOWN_TIMEOUT);
			res = ProtocolConstant.DEFALUT_TIMEOUT;
			e.printStackTrace();
		}*/
		return res*ProtocolConstant.ONE_MINUTE;
	}
	/*public void setTerminalShowdownTimeout(int timeout){
		try {
			timeout = Math.max(timeout,ProtocolConstant.MIN_DROP_LINE_TIMEOUT_MINUTE);
			redisApi.set(ProjectConstant.PROTOCOL_SHOWDOWN_TIMEOUT,timeout);
		}catch (Exception e){e.printStackTrace();}
	}
	*//***下面是用户充电数据简单 缓存*//*
	public Map<String,Long> findUserChargeSimpleData(){
		try {
			Object res = redisApi.get(ProjectConstant.PROTOCOL_SIMPLE_USER_CHARGE_DATA);
			if(res != null)return (Map<String, Long>) res;
		}catch (Exception e){
			redisApi.remove(ProjectConstant.PROTOCOL_SIMPLE_USER_CHARGE_DATA);
			e.printStackTrace();
		}
		return null;
	}*/

	public void start(){
		try {
			LocalProtocolCache.SIMPLE_CHARGE_DATA.clear();
			// 查询正在充电的数据
		/*	Map<String, Long> userChargeSimpleData = findUserChargeSimpleData();
			if(userChargeSimpleData != null)
				LocalProtocolCache.SIMPLE_CHARGE_DATA.putAll(userChargeSimpleData);*/
		}catch (Exception e){
			e.printStackTrace();
		}
	}
	public void stop(){
		updateSimpleToRedis();
		LocalProtocolCache.SIMPLE_CHARGE_DATA.clear();
	}

	public void updateSimpleToRedis(){
		try {
			/*if(LocalProtocolCache.SIMPLE_CHARGE_DATA.size() > 0){
				redisApi.set(ProjectConstant.PROTOCOL_SIMPLE_USER_CHARGE_DATA,LocalProtocolCache.SIMPLE_CHARGE_DATA);
			}*/
		}catch (Exception e){
			e.printStackTrace();
		}
	}

	/**判断订单是否已经处理**/
	public boolean checkOrderIsHandle(String orderNo){
		try {
		/*	String key = String.format(ProtocolConstant.HANDLE_ORDER,orderNo);
			if(redisApi.exists(key)) return true;
			//5分钟
			redisApi.set(key,0,5L, TimeUnit.MINUTES);*/
		}catch (Exception e){
			e.printStackTrace();
		}
		return false;
	}
	/***判断集中器是否上电已经处理过*/
	public boolean chechTerminalPowerUpHandle(String terminalNo){
		try {
			/*String key = String.format(ProtocolConstant.TERMINAL_POWER_UP,terminalNo);
			if(redisApi.exists(key)) return true;
			//5分钟
			redisApi.set(key,0,5L, TimeUnit.MINUTES);*/
		}catch (Exception e){
			e.printStackTrace();
		}
		return false;
	}
	/******==================集中器订单========================*/
	public static final AtomicInteger AI = new AtomicInteger(0);
	public void handelUserSimpleChargeData(ChargeDataHandleType type, String orderNo){
		if(StringUtil.isEmpty(orderNo)) return;
		int i = AI.incrementAndGet();
		switch (type){
			case UPDATE:LocalProtocolCache.SIMPLE_CHARGE_DATA.put(orderNo,System.currentTimeMillis());break;
			case DEL:LocalProtocolCache.SIMPLE_CHARGE_DATA.remove(orderNo);break;
			default:break;
		}
		//这么多数据 只有在服务器启动与结束时更新到redis中
		/*if(i >= ProtocolConstant.DEFAULT_USER_CHARHE_NUM){
			updateSimpleToRedis();
			AI.set(0);
		}*/
	}
	public enum ChargeDataHandleType{
		UPDATE,DEL;
	}
}
