package com.comtika.safe.core.protocol.entity;

import com.comtika.safe.common.response.RespWrapper;
import com.comtika.safe.common.utils.StringUtil;
import com.comtika.safe.core.protocol.utils.BaseTypeConvert;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;

@Data
public class AuxHandleHelp {
    /**
     * 00: 关闭辅助继电器
     * 01：打开辅助继电器
     * 02：查看辅助继电器状态
     */
    private String terminalNo;//设备编码
    private Integer status;//状态码
    private List<Boolean> bitList = new ArrayList<>();

    public RespWrapper check(){
        if(StringUtil.isEmpty(terminalNo))
            return RespWrapper.makeFailResp("集中器编号不能为空");
        if(status == null) return RespWrapper.makeFailResp("操作辅助值不能为空");
        if(status != 2 && bitList.isEmpty() ){
            return RespWrapper.makeFailResp("操作辅助继电器不能为空");
        }
        return RespWrapper.makeSuccessResp(true);
    }

    public  byte bitToByte(){
        byte[] bytes = new byte[8];
        for(int i=0;i<bitList.size();i++){
            bytes[i] = convet(bitList.get(i));
        }
       return BaseTypeConvert.expectSizeBytes2Bte(bytes);
    }
    public void byteToBit(byte bt){
        byte[] bytes = BaseTypeConvert.byte2ExpectBytes(bt, 8);
        for(int i=0;i<4;i++){
            bitList.add(byteToBool(bytes[i]));
        }
    }

    private boolean byteToBool(byte bt){
        return bt == 1;
    }
    private byte convet(Boolean aBoolean) {
        if(aBoolean) return 1;
        return 0;
    }


}
