package com.comtika.safe.core.protocol.entity;

import com.comtika.safe.common.response.RespWrapper;
import com.comtika.safe.common.utils.StringUtil;
import lombok.Data;

import java.util.regex.Pattern;

@Data
public class ProtocolHelp {
    private static final Pattern PATTERN = Pattern.compile("[^0123456789abcdeABCDE]");
    private String terminalNo;
    private String cmd;
    private String controllerCode;
    private String data;
    public RespWrapper<Boolean> checkProtocol(){
        if(StringUtil.isEmpty(terminalNo))
            return RespWrapper.makeFailResp("设备唯一编码不能为空");
        if(StringUtil.isEmpty(cmd))
            return RespWrapper.makeFailResp("命令码不能为空");
        if(StringUtil.isEmpty(controllerCode))
            return RespWrapper.makeFailResp("控制码不能为空");
        if(terminalNo.length() != 12)
            return RespWrapper.makeFailResp("设备编码长度不是12位");
        if(cmd.length() == 2)
            return RespWrapper.makeFailResp("命令码长度不是2位");
        if(controllerCode.length() == 2)
            return RespWrapper.makeFailResp("控制码长度不是2位");
        if(StringUtil.isNotEmpty(data) ){
            if(data.length() % 2 != 0)
              return RespWrapper.makeFailResp("数据不是为偶数");
            if(patterm(data))
                return RespWrapper.makeFailResp("不是16进制的数据");
        }
        if (patterm(terminalNo,cmd,controllerCode)) {
            return RespWrapper.makeFailResp("不是16进制的数据");
        }
        return RespWrapper.makeSuccessResp(true);
    }
    private boolean patterm(String...strs){
        for(String st:strs){
            if (PATTERN.matcher(st).find()) {
                return true;
            }
        }
        return false;
    }

}
