package com.comtika.safe.core.protocol.entity.charge;

import com.comtika.safe.core.protocol.eunms.charge.ChargeResCode;
import com.comtika.safe.core.protocol.ComtikaExtra;
import lombok.Data;

/**
 *
 * @ClassName: ChargeEnd
 * @Description: 充电结束数据可扩展
 * @author zhaoLuYang
 * @date2018年5月31日 上午10:49:08
 * @version V1.0
 */
@Data
public class ChargeEnd<T> extends ComtikaExtra {

	/**
	 * 6Bs	NodeID	节点ID号
		8Bs	OrderNum	订单号
		1B	Ret	返回码:0-结束订单下发成功，1-接收数据出错，2-设备忙，4-无此订单
		4Bs	EP	当前电量--0.01kWH
		4Bs	EP_Last	充电前的电量--0.01kWH
		2Bs	Min	充电时长--1min
		1B	Plug_Nb	插座编号
	 */
	private T t;//后期这个需要移除
	/**结束原因*/
	private String reason;
	/**节点ID号*/
	private String nodeNo;
	/**订单号*/
	private String orderNo;
	/**返回码:0-结束订单下发成功，1-接收数据出错，2-设备忙，4-无此订单*/
	private ChargeResCode resCode;
	/**当前电量--0.01kWH*/
	private int eleEP;//当前电量 0.01kwh
	/**充电前的电量--0.01kWH*/
	private int eleEPLast;
	/**充电时长--1min*/
	private int chargeTime;
	/**插座编号*/
	private int plugNo;
	/**是否需要生成子订单*/
	private boolean sonSheet;


}
