package com.comtika.safe.core.protocol.entity.device;


import com.comtika.safe.core.protocol.ComtikaExtra;
import com.comtika.safe.core.protocol.entity.FaultEnableReport;
import lombok.Data;


/**
 * @desc	:	设置参数配置
 * @author	:	actorLucky[494977551@qq.com]
 * @date	:	2018年5月20日 上午10:49:31
 */
@Data
public class DeviceParams extends ComtikaExtra {

	/**
	 *  配置节点参数  01H
		 * 节点ID号: String                id:"00000000107F"
		 * 充满电电流阈值:单位1mA（1~1000） int   fz
		 * 充满电电流时长阈值，单位1min（1~255）
		 * 充电过载保护阈值，单位0.1A（1~168）
		 * 充电过载保护时长阈值，单位1ms（1~255）
		 * 漏电保护电流阈值，单位1 mA（1~255）
		 * 漏电保护电流时长阈值，单位1ms（1~255）
		 * 充电超时阈值，单位1小时（1~255）
		 * 充电启动时间 ，单位1s（1~255）
		 * 开路电流 ，单位1mA（1~20）
		 * 额定电压--单位--1V   （110,220)
		 * 报警使能位：
				Bit0：过压；Bit1：欠压；Bit2：过流；
				Bit3：过载；Bit4：过温；
				Bit5：负载连接失败
				Bit6：漏电流保护；Bit7：接地故障；
	 */
	private String nodeId;//节点ID号: String                id:"00000000107F"
	private int chargeFullI;//充满电电流阈值:单位1mA（1~1000
	private int chargeFullIT;//充满电电流时长阈值，单位1min（1~255）
	private int overLoad;//充电过载保护阈值，单位0.1A（1~168）
	private int overLoadT;//充电过载保护时长阈值，单位1ms（1~255）
	private int leakI;//漏电保护电流阈值，单位1 mA（1~255）
	private int leakIT;//漏电保护电流时长阈值，单位1ms（1~255）
	private int chargeTimeout;//充电超时阈值，单位1小时（1~255）
	private int chargeStartI;//充电启动时间 ，单位1s（1~255）
	private int disconI;//开路电流 ，单位1mA（1~20）
	private int voltRated;//额定电压--单位--1V   （110,220)
	private FaultEnableReport faultEnable;
	private int plugNo;


}
