package com.comtika.safe.core.protocol.entity.netty;

import com.comtika.safe.core.protocol.utils.ProtocolIDUtil;
import lombok.Data;

/**
 * @desc	:	操作实体
 * @author	:	actorLucky[494977551@qq.com]
 * @date	:	2018年5月18日 下午12:37:04
 */
@Data
public class OrderEntity{

	/**序列化必需要无参构造*/
	public OrderEntity() {
	}
	public OrderEntity(byte[] ids, byte orderCode, byte operationCode, byte[] dataBytes){
		this.id  = ProtocolIDUtil.decodeEvenProtocolID(ids);
		this.orderCode = orderCode < 0? (orderCode+256):orderCode;
		this.operationCode = (operationCode < 0? (operationCode+256):operationCode);
		this.data = dataBytes;
	}
	public OrderEntity(String ids, byte orderCode, byte operationCode, byte[] dataBytes){
		this.id  = ids;
		this.orderCode = (orderCode < 0? (orderCode+256):orderCode);
		this.operationCode = (operationCode < 0? (operationCode+256):operationCode);
		this.data = dataBytes;
	}
	public OrderEntity(String ids, int orderCode, int operationCode, byte[] dataBytes){
		this.id  = ids;
		this.orderCode = orderCode;
		this.operationCode = operationCode;
		this.data = dataBytes;
	}
	public OrderEntity(byte[] ids, int orderCode, int operationCode, byte[] dataBytes){
		this.id  = ProtocolIDUtil.decodeEvenProtocolID(ids);
		this.orderCode = orderCode;
		this.operationCode = operationCode;
		this.data = dataBytes;
	}

	/*
	 * 设置唯一标识
	 */
	private String id;
	/*
	 * 操作编码   或响应编码
	 */
	private int orderCode;
	/*
	 * 操作指令 或响应指令
	 */
	private int operationCode;
	/*
	 * 数据
	 */
	private byte[] data;
	/**所有数据*/
	private byte[] allData;
	/**帮助GC清理数据*/
	public void cleanData(){
		try{
			if(this.data != null) this.data = null;
			if(this.allData != null) this.allData = null;
		}catch (Exception e){
			e.printStackTrace();
		}
	}

	public void setAllData(byte[] allData) {
		this.allData = allData;
	}

	public byte[] getAllData() {
		return allData;
	}

	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public int getOrderCode() {
		return orderCode;
	}
	public void setOrderCode(int orderCode) {
		this.orderCode = orderCode;
	}
	public int getOperationCode() {
		return operationCode;
	}
	public void setOperationCode(int operationCode) {
		this.operationCode = operationCode;
	}
	public byte[] getData() {
		return data;
	}
	public void setData(byte[] data) {
		this.data = data;
	}
}
