package com.comtika.safe.core.protocol.entity.node;

import com.comtika.safe.core.protocol.entity.FaultEnableReport;
import com.comtika.safe.core.protocol.eunms.charge.ChargeEndType;
import com.comtika.safe.core.protocol.eunms.node.NodeStatus;
import lombok.Data;

/**
 * @desc	:
 * @author	:	actorLucky[494977551@qq.com]
 * @date	:	2018年5月22日 上午9:39:41
 */
@Data
public class NodeReportData{
	/**
	 * 6Bs	NodeID	节点ID号
		8Bs	OrderNum	订单号
		1B	FC	结束类型:  01：故障结束；02：断开连接结束(插座被拔出)；
				03：充满电完成主动结束  04：完成设定充电结束(充电时间到，剩余设定充电电量为0)
		1B	Status	状态字:  0-空闲，1-占用,2-正在充电中，3-充满，4-故障，5-维护
		4Bs	EP	当前电量--单位: 0.01kWH
		4Bs	EP_Last	充电前的电量-- 单位: 0.01kWH

		2Bs	Min	充电时长---单位: 1min
		2Bs	Fault	故障字：Bit0：过压；Bit1：欠压；Bit2：过流；
		Bit3：过载；Bit4：过温；
		Bit5：负载连接失败(请先确保连接负载，再下订单)
		Bit6：漏电流保护；Bit7：接地故障；
		Bit8：充电超时；   其它位保留。
		4Bs	FaultData	故障数据： 数据单位，过压、欠压--0.1V；过流--1mA；
				过载--0.001kW；过温--1摄氏度；漏电保护--0.1mA；负载连接异常--数据为0，无单位；
		1B	Plug_Nb	插座编号
	 */
	private String nodeId;
	private String orderNo;
	private ChargeEndType endType;
	private NodeStatus nodeStatus;
	private int eleEP;
	private int eleEPLast;
	private int chargeTime;
	private FaultEnableReport fault;
	private int faultVaule;
	private int plugNo;


}
