package com.comtika.safe.core.protocol.entity.node;


import com.comtika.safe.core.protocol.eunms.device.EquipWarnType;
import com.comtika.safe.core.protocol.eunms.device.EquipmentCode;
import lombok.Data;

import java.util.List;

/***
 *
 * @ClassName: NodeWarnData
 * @Description: 告警数据
 * @author actor_miss
 * @date2018年9月25日 下午6:09:20
 * @version V1.2.1
 */
@Data
public class NodeWarnData {
	private String addrNo;//集中器编号
	private String nodeNo;//节点编号
	private int plugNo;//插座编号
	private List<EquipWarnType> list;//错误
	private int equipT;//温度
	private int eleV;//电压
	private int eleI;//电流
	private int eleP;//功率
	private EquipmentCode equipmentCode;
	private Long time;
	public NodeWarnData(){
		this.time = System.currentTimeMillis();
	}


	@Override
	public String toString() {
		return "NodeWarnData{" +
				"addrNo='" + addrNo + '\'' +
				", nodeNo='" + nodeNo + '\'' +
				", plugNo=" + plugNo +
				", list=" + list +
				", equipT=" + equipT +
				", eleV=" + eleV +
				", eleI=" + eleI +
				", eleP=" + eleP +
				", equipmentCode=" + equipmentCode +
				", time=" + time +
				'}';
	}
}
