package com.comtika.safe.core.protocol.eunms;

import java.util.HashMap;
import java.util.Map;

/**
 * @desc	:	集中器响应状态
 * @author	:	actorLucky[494977551@qq.com]
 * @date	:	2018年5月21日 下午4:11:15
 */
public enum AckCode {
	/**
	 * 应答码: 01H:节点成功受理，02H:命令或数据格式无效，03H:节点忙，04H:节点不存在或者不在线
	 */
	SUCCESS(0x01,"集中器受理成功/节点成功受理"),
	REQ_FAIL(0x02,"集中器受理失败/命令或数据格式无效"),
	NODE_BUSY(0x03,"集中器忙/节点忙"),
	NODE_DOWNLINE(0x04,"节点不存在或者不在线 ");
	private int id;
	private String name;
	AckCode(int id, String name){
		this.id = id;
		this.name = name;
	}
	public static Map<Byte,AckCode> ACK_MAP = new HashMap<>(8);
	static {
		for(AckCode ack:AckCode.values())
			ACK_MAP.put((byte) ack.id,ack);
	}
	public int getId() {
		return id;
	}
	public String getName() {
		return name;
	}

	public static AckCode valueOf(int id){
		for(AckCode cht:AckCode.values()){
			if(cht.getId() == id){
				return cht;
			}
		}
		return null;
	}
	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		return sb.append("{\"id\":").append(this.id).append(",\"name\":").append("\""+this.name+"\"}").toString();
	}

}
