package com.comtika.safe.core.protocol.eunms;

import java.util.HashMap;
import java.util.Map;


/**
 * @desc	:	特殊标记码
 * @author	:	actorLucky[494977551@qq.com]
 * @date	:	2018年5月17日 下午3:42:29
 */
public enum SpecialCode {
	/**开始*/
	START_CODE(104,"开始"),
	/**超长指令*/
	SUPER_LONG_CODE(0x85,"超长指令标识"),
	/**结束*/
	END_CODE(22,"结束");
	private int id;
	private String name;
	SpecialCode(int id, String name){
		this.id = id;
		this.name = name;
	}
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public static SpecialCode valueOf(int id){
		for(SpecialCode sc:SpecialCode.values()){
			if(sc.getId() == id){
				return sc;
			}
		}
		return null;
	}
	public Map<Integer,String> getMapSpecialCode(){
		SpecialCode[] values = SpecialCode.values();
		Map<Integer,String> map = new HashMap<Integer, String>(values.length);
		for(SpecialCode sc:values){
			map.put(sc.getId(), sc.getName());
		}
		return map;
	}
	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		return sb.append("{\"id\":").append(this.id).append(",\"name\":").append("\""+this.name+"\"}").toString();
	}

}
