package com.comtika.safe.core.protocol.eunms.charge;
/**
 *
 * @ClassName: AnswerCard
 * @Description:智能卡响应操作
 * @author actor_miss
 * @date2018年9月14日 下午2:59:50
 * @version V1.2.1
 * 应答码: 2018.11.19  修改
 * 0-启动充电成功（报余额）
 * 1-余额不足（报余额）
 * 2-此卡 不 可用
 * 3-设备故障，请更换其它设备
 * 4-此卡只能开启一个插座
 * 5.此卡不可在该商户下使用
 */
public enum AnswerCard {
	SUCCESS(0,"启动充电成功"),
	BALANCE_LOW(1,"余额不足"),
	NOT_ACTIVE(2,"此卡不可用"),
	EQUIP_FAILL(3,"设备故障，请更换其它设备"),
	EQUIP_BUSY(4,"此卡只能开启一个插座"),
	NO_MERCHANT(5,"此卡不可在该商户下使用");
	private int code;
	private String name;
	AnswerCard(int code, String name){
		this.code = code;
		this.name = name;
	}
	public int getCode() {
		return code;
	}
	public void setCode(int code) {
		this.code = code;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public static AnswerCard valueOf(int code){
		for(AnswerCard a:AnswerCard.values()){
			if(a.getCode() == code)
				return a;
		}
		return null;
	}
	public static boolean isBalance(int code){
		AnswerCard answerCard = valueOf(code);
		if(answerCard == SUCCESS || answerCard == BALANCE_LOW)
			return true;
		return false;
	}
	public static boolean isBalance(AnswerCard answerCard){
		if(answerCard == SUCCESS || answerCard == BALANCE_LOW)
			return true;
		return false;
	}
}
