package com.comtika.safe.core.protocol.eunms.charge;

/**
 * @desc	:	充电结束类型
 * @author	:	actorLucky[494977551@qq.com]
 * @date	:	2018年5月22日 上午7:21:35
 *
 *
 * 01：故障结束；
 * 02：拔掉插座结束
 * 03：充满电 完成 主动 结束
 * 04：充电时间到结算
 * 05：充电电量到结算
 * 06：涓流充电结束结算（电池已充满）
 */
public enum ChargeEndType {
	/**故障结束*/
	FAULT(1,"故障结束"),
	/**拔掉插座结束*/
	PULL_OUT(2,"插座拔出结束"),
	/**充满电 完成 主动 结束*/
	FINISH(3,"充满电 完成 主动 结束")	,
	/**充电时间到结算*/
	FINISH_TIME(4,"充电时间到"),
	/**充电电量到结算**/
	FINISH_KUM(5,"充电电量到"),
	/***设备充满*/
	FINISH_FULL(6,"设备已充满");
	private int id;
	private String name;
	ChargeEndType(int id, String name){
		this.id = id;
		this.name = name;
	}
	public int getId() {
		return id;
	}
	public String getName() {
		return name;
	}
	public static ChargeEndType valueOf(int id){
		for(ChargeEndType cht:ChargeEndType.values()){
			if(cht.getId() == id){
				return cht;
			}
		}
		return null;
	}
	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		return sb.append("{\"id\":").append(this.id).append(",\"name\":").append("\""+this.name+"\"}").toString();
	}

}
