package com.comtika.safe.core.protocol.eunms.charge;



/**
 * @desc	:	充电响应码
 * @author	:	actorLucky[494977551@qq.com]
 * @date	:	2018年5月22日 上午8:12:04
 */
public enum ChargeResCode {

	/**
	 * 订单下发成功
	 */
	SUCCESS(0,"订单下发成功"),
	/**接收数据出错*/
	SD_FAIL(1,"接收数据出错"),
	/**设备忙*/
	D_BUSY(2,"设备忙"),
	/**设备故障*/
	D_FAIL(3,"设备故障"),
	/**插座未插入*/
	CZF(4,"插座未插入"),
	/**被动结束充电  网络异常  三分钟异常*/
	NETWORK_TIMEOUT(5,"设备掉线，结束充电"),
	/**被动结束充电  主动上报数据*/
	ACTIVE_UP_DATA(6,"硬件异常或充电时间到"),
	/**插座主动拔出*/
	SOCKET_PULL_OUT(7,"插座已拔出"),
	/**设备已充满*/
	FINISH_FULL(8,"设备已充满"),
	/**集中器上电*/
	POWER_UP(8,"设备断电，结束充电");
	private int id;
	private String name;
	ChargeResCode(int id, String name){
		this.id = id;
		this.name = name;
	}
	public int getId() {
		return id;
	}
	public String getName() {
		return name;
	}

	public static ChargeResCode valueOf(int id){
		for(ChargeResCode cht:ChargeResCode.values()){
			if(cht.getId() == id){
				return cht;
			}
		}
		return null;
	}


}
