package com.comtika.safe.core.protocol.eunms.device;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @desc : 公共设备码 设备码、产品名称--设备类型枚举
 * @author : actorLucky[494977551@qq.com]
 * @date : 2018年5月24日 下午3:59:49
 */
public enum EquipmentCode {
    GPRS_16(16,0x98, "双节点GRPS-16路", "16路电单车交流");
    private int id;//前端传的id
    private int code;//这是指令码

    private String equipmentName;//硬件说明

    private String productName;//后管说明

    EquipmentCode(int id , int code, String equipmentName, String productName) {
    	this.setId(id);
        this.code = code;
        this.equipmentName = equipmentName;
        this.productName = productName;
    }

    public int getCode() {
        return code;
    }


    public String getEquipmentName() {
        return equipmentName;
    }


    public String getProductName() {
        return productName;
    }


    public static EquipmentCode valueOfByName(String productName) {
        for (EquipmentCode cht : EquipmentCode.values()) {
            if (cht.getProductName().equals(productName)) {
                return cht;
            }
        }
        return null;
    }
    public static List<Map<String,Object>> findEquipMap(){
    	List<Map<String,Object>> res = new ArrayList<Map<String,Object>>();
    	for(EquipmentCode e: EquipmentCode.values()){
    		Map<String,Object> map = new HashMap<String, Object>();
    		map.put("name", e.getProductName());
    		map.put("id", e.getId());
    		res.add(map);
    	}
    	return res;
    }

    public static EquipmentCode valueOf(int code) {
        for (EquipmentCode cht : EquipmentCode.values()) {
            if (cht.getCode() == code) { return cht; }
        }
        return null;
    }
    public static EquipmentCode valueOfById(int id) {
    	for (EquipmentCode cht : EquipmentCode.values()) {
    		if (cht.getId() == id) { return cht; }
    	}
    	return null;
    }

    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer();
        return sb.append("{\"id\":").append(this.id).append(",\"code\":").append(this.code)
        		.append(",\"equipmentName\":")
            .append("\"" + this.equipmentName + "\"").append(",\"productName\":").append("\""+this.productName+"\"}").toString();
    }

	/**
	 * @return the id
	 */
	public int getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(int id) {
		this.id = id;
	}

}
