package com.comtika.safe.core.protocol.eunms.netty;


/**
 * @desc	:	操作指令枚举
 * @author	:	actorLucky[494977551@qq.com]
 * @date	:	2018年5月18日 下午12:04:38
 */
public enum OperationCode {
	SYS_CONTROL(0xF2,"系统控制 F2H"),
	LOGIN(0xF0,"集中器登录 F0H"),
	SKIP(0xF1,"心跳 F1H"),
	UPDATE_TERMINAL_MAC(0xE1,"设置集中器MAC E1H"),
	FIND_TERMINAL_MAC(0xE2,"查询集中器MAC E2H"),
	UPDATE_TERMINAL_TIME(0x8C,"设置集中器时间 8CH"),
	FIND_TERMINAL_TIME(0x8D,"查询集中器时间 8DH"),
	// 忽略该版本指令
	//UPDATE_IP_PORT(0xFC,"设置集中器远程更新IP和端口 FCH"),
	//GET_IP_PORT(0xFD,"查询集中器远程更新IP和端口 FDH"),
	GET_DETAIL_HD(0x4A,"查询集中器软硬件信息 4AH"),
	SET_HOST_IPPORT(0xF8,"设置集中器主服务器IP和端口 F8H"),
	GET_HOST_IPPORT(0xF9,"查询集中器主服务器IP和端口 F9H"),
	//SET_BACKUP_IP_PORT(0xFA,"集中器备用服务器IP和端口 FAH"),
	//GET_BACKUP_IP_PORT(0xFB,"查询集中器备用服务器IP和端口 FBH"),
	SET_NODE_PARAM(0x01,"配置节点参数 01H"),
	// SET_NODE_PATTERN(0x02,"设置节点工作模式 02H"),
	SET_NODE_RTC(0x03,"设置节点RTC 03H"),
	GET_NODE_STATUS(0x10,"查询节点状态及故障信息 10H"),
	GET_NODE_CDCS(0x11,"查询节点充电数据 11H"),
	GET_NODE_VERSION(0x12,"查询节点版本信息 12H"),
	GET_NODE_PARAM(0x13,"查询节点配置参数 13H"),
	//GET_NODE_RECORD(0x14,"查询节点充电记录 14H"),
	CHARGE_START(0x20,"开始充电命令 20H"),
	CHARGE_END(0x21,"结束充电命令 21H"),
	NODE_EXCEPTION(0x50,"节点自动结束充电集中器主动上报 50H"),
	NODE_WARN_DATA(0x51,"节点告警出现集中器主动上报 51H"),
	UP_DATA(0x53,"集中器主动上报节点充电数据 53H"),
	AUTO_CARD(0x54,"集中器主动上报节点刷卡数据 54H"),
	/**设置集中器 MAC  E1*/
	//SET_MAC(0xE1,"设置集中器MAC E1H"),
	/**查询集中器MAC E2*/
	//GET_MAC(0xE2,"查询集中器MAC地址 E2H"),
	/**集中器上电事件**/
	TERMINAL_POWER_UP(0xEF,"集中器上电事件 EFH"),
	FIND_ELE_TOTAL(0x73,"查询电能表指令 73H"),
	PROTO_ICCID(0xF3,"集中器 主动上报物联网卡 ICCID F3H"),
	PROTO_IMEI(0xF4,"集中器 主动上报移动模块 IMEI F4H"),
	PROTO_ICCID_UP(0xFA,"查询 集中器物联网卡 ICCID FAH"),
	PROTO_IMEI_UP(0xFB,"查询 集中器 移动 模块 IMEI FBH"),

	TERMINAL_MODEL_WORK(0xF5,"集中器主动上报移动模块厂商信息F5H"),
	TERMINAL_MODEL_MOBILE_VERSION(0xF6,"集中器主动上报移动模块产品型号信息 F6H"),
	TERMINAL_MODEL_SF_VERSION(0xF7,"集中器主动上报移动模块软件版本信息 F7H"),
	TERMINAL_MODEL_WIFI_LEV(0xFC,"集中器主动上报移动模块信号质量信息 FCH"),
	TERMINAL_MODEL_FIND_WIFI_LEV(0xFD,"查询集中器移动模块信号质量信息 FDH"),

	/**
	 * 下面增加安全用电协议
	 * 安全用电增加：配置节点阈值 02H
	 * 安全用电增加：集中器继电器关（节点开关控制）71H
	 * 安全用电增加：集中器继电器开（节点开关控制）70H
	 * 安全用电增加：下发定时任务 82H
	 * 删除定时任务 84H
	 * 清除节点电能信息 85H
	 * 查询节点阈值 14H
	 * 查询节点实时数据 15H
	 * 节点告警/预警出现集中器主动上报 55H ----
	 * 节点周期上报实时数据 56H
	 */
	SAFE_CONFIG_THR(0x02,"配置节点阈值 02H"),
	SAFE_SWITCH_OFF(0x71,"集中器继电器关（节点开关控制）71H"),
	SAFE_SWITCH_ON(0x70,"集中器继电器开（节点开关控制）70H"),
	SAFE_SWITCH_FIND(0x72,"集中器继电器状态查询（节点开关状态查询）72H"),
	HANDLE_AUX_STATUS(0x74," 集中器辅助继电器控制（开/ 关/ 查询 状态 ）74H"),
	SAFE_TASK_ADD(0x82,"下发定时任务 82H"),
	SAFE_TASK_FIND(0x83,"查询定时任务 83H"),
	SAFE_TASK_DELETE(0x84,"删除定时任务 84H"),
	SAFE_ELE_DELETE(0x85,"清除节点电能信息 85H"),
	SAFE_THR_FIND(0x14,"查询节点阈值 14H"),
	SAFE_DATA_FIND(0x15,"查询节点实时数据 15H"),
	SAFE_WARN_UP(0x55,"节点告警/预警出现集中器主动上报 55H"),
	SAFE_DATA_UP(0x56,"节点周期上报实时数据 56H"),
	FIND_SERVER_TIME(0x8E,"查询服务器时间 8EH"),
	CTJ_FIND_TIME_CONF(0xE3,"查询集中器 Timer 配置 E3H"),
	CTJ_CONF_TIME_HANDLE(0xE4,"设置集中器 Timer 周期 E4H"),


	/***
	 * 超长指令
	 */
	// plc 白名单
	FIND_MATER_NODE_WHITE_LIST(0xB0,"查询设备是否为主节点 B0H"),
	SET_MATER_NODE_WHITE_LIST(0xB1,"配置下发白名单列表 B1H"),
	FIND_TERMINAL_WHITE_LIST(0xB2,"查询主节点已配置存储在FLASH里的白名单列表 B2H"),
	FIND_TERMINAL_ONLINE_WHITE_LIST(0xB3,"查询主节点实时组网信息：已经组网的从节点列表 B3H"),
	/**
	 * 用于设备升级
	 */
	/***Server读取Client可用固件存储空间 A0H*/
	OTA_READ_STORGE(0xA0,"Server读取Client可用固件存储空间 A0H"),
	/**Server通知Client即将开始固件传输 A1H*/
	OTA_NOTICE_GO(0xA1,"Server通知Client即将开始固件传输 A1H"),
	/***Server传输给Client固件的指令 A2H*/
	OTA_SEND_RUN(0xA2,"Server传输给Client固件的指令 A2H"),
	/**Server传输固件结束 A3H*/
	OTA_SEND_END(0xA3,"Server传输固件结束 A3H"),
	/**Server询问Client固件校验是否正确 A4H*/
	OTA_ASK_OK(0xA4,"Server询问Client固件校验是否正确 A4H"),
	/**Server要求Client进行固件自更新 A5H*/
	OTA_UPDATE_START(0xA5,"Server要求Client进行固件自更新 A5H");
	private int code;
	private String name;
	OperationCode(int code, String name){
		this.code = code;
		this.name = name;
	}
	public int getCode() {
		return code;
	}
	public String getName() {
		return name;
	}
	public static OperationCode valueOf(int code){
		for(OperationCode oct: OperationCode.values()){
			if(oct.getCode() == code){
				return oct;
			}
		}
		return null;
	}
	public static String valueOfName(int code){
		for(OperationCode oct: OperationCode.values()){
			if(oct.getCode() == code){
				return oct.getName();
			}
		}
		return Integer.toHexString(code);
	}
	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		return sb.append("{\"code\":").append(this.code).append(",\"name\":").append("\""+this.name+"\"}").toString();
	}

	public static void main(String[] args){
		System.out.println(valueOfName(0xFD));
	}


}
