package com.comtika.safe.core.protocol.eunms.netty;

/**
 * @desc	:	操作码 枚举
 * @author	:	actorLucky[494977551@qq.com]
 * @date	:	2018年5月18日 下午12:02:45
 */
public enum OrderCodeType {
	/**集中器控制或参数配置*/
	CLIENT_PARAM_SET(0x00,"集中器控制或参数配置",0x80),
	/**集中器下属某终端单点控制*/
	CON_SINGLE(0x01,"集中器下属某终端单点控制",0x80),
	/**集中器下属某类终端组控制*/
	CON_GROUP(0x02,"集中器下属某类终端组控制",0x80),
	/**集中器下属某类终端广播控制*/
	CON_BROADCAST(0x03,"集中器下属某类终端广播控制",0x80),
	/**集中器主动上报数据*/
	CLIENT_TO_SERVER(0x04,"集中器主动上报数据",0x80),
	/**超长指令【用于设备升级】*/
	CON_SUPER_LONG(0x05,"超长指令",0x85);
	private int reqCode;
	private String name;
	private int resCode;
	public int getResCode() {
		return resCode;
	}
	OrderCodeType(int reqCode, String name, int resCode){
		this.name = name;
		this.reqCode = reqCode;
		this.resCode = resCode;
	}
	public int getReqCode() {
		return reqCode;
	}
	public String getName() {
		return name;
	}

	/**
	 * 根据字符串请求码       获取枚举
	 * @param reqCode
	 * @return
	 */
	public static OrderCodeType valueOf(int reqCode){
		for(OrderCodeType oc: OrderCodeType.values()){
			if(oc.getReqCode() == reqCode){
				return oc;
			}
		}
		return null;
	}
	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		return sb.append("{\"reqCode\":").append(this.reqCode).append(",\"name\":").append("\""+this.name+"\"").
				append("\"resCode\":").append(this.resCode+"}").toString();
	}
}
