package com.comtika.safe.core.protocol.eunms.node;

/**
 * @desc	:	集中器节点状态--插座状态
 * @author	:	actorLucky[494977551@qq.com]
 * @date	:	2018年5月20日 下午4:06:29
 */
//状态字：0-空闲，1-占用,2-正在充电中，3-充电完成，4-故障，5-维护
public enum NodeStatus {
	IDLE(0,"空闲"),
	BUSY(1,"占用"),
	TASKING(2,"正在充电中"),
	TASKED(3,"充电完成"),
	FAIL(4,"故障"),
	REPAIR(5,"维修");
	private int id;
	private String name;
	NodeStatus(int id, String name){
		this.id = id;
		this.name = name;
	}
	public int getId() {
		return id;
	}
	public String getName() {
		return name;
	}
	public static NodeStatus valueOf(int id){
		for(NodeStatus rs:NodeStatus.values()){
			if(rs.getId() == id){
				return rs;
			}
		}
		return null;
	}

}
