package com.comtika.safe.core.protocol.eunms.version;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/***
 *
 * @ClassName: OTAStatus
 * @Description: ota状态
 * @author zhaoLuYang
 * @date2018年8月15日 上午11:32:11
 * @version V1.0
 */
public enum OTAStatus {
	OTA_SUCCESS(0, "升级成功"), OTA_FALL(1, "升级失败"), OTA_SEND(2, "发送数据包..."), OTA_RUNING(
			3, "设备升级中..."),LOW_LEVE(4,"没有升级功能");
	private int id;
	private String name;

	OTAStatus(int id, String name) {
		this.id = id;
		this.name = name;
	}

	public int getId() {
		return id;
	}

	public String getName() {
		return name;
	}

	public static OTAStatus valueOf(int id) {
		for (OTAStatus s : OTAStatus.values()) {
			if (s.getId() == id) {
				return s;
			}
		}
		return null;
	}

	public static List<Map<String, Object>> findOTAStatusMap() {
		List<Map<String, Object>> res = new ArrayList<Map<String, Object>>();
		for (OTAStatus s : OTAStatus.values()) {
			Map<String, Object> map = new HashMap<String, Object>();
			map.put("id", s.getId());
			map.put("name", s.getName());
			res.add(map);
		}
		return res;
	}
	@Override
	public String toString() {
		return "{\"id\":"+this.id+",\"name\":\""+this.name+"\"}";
	}


}
