package com.comtika.safe.core.protocol.netty.config;

import com.comtika.safe.core.protocol.netty.NettyServerHandle;
import com.comtika.safe.core.protocol.netty.hcode.NettyDecoder;
import com.comtika.safe.core.protocol.netty.hcode.NettyEncoder;
import io.netty.channel.ChannelInitializer;
import io.netty.channel.socket.SocketChannel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class NettyChannelInitializer extends ChannelInitializer<SocketChannel> {


    @Autowired
    private NettyServerHandle nettyServerHandle;

    @Override
    protected void initChannel(SocketChannel ch) throws Exception {
        ch.pipeline().addLast("decoder",new NettyDecoder()).addLast("encoder",new NettyEncoder()).addLast(nettyServerHandle);
    }
}
