package com.comtika.safe.core.protocol.netty.hcode;

import com.comtika.safe.core.protocol.utils.BaseTypeConvert;
import com.comtika.safe.core.protocol.entity.netty.OrderEntity;
import com.comtika.safe.core.protocol.ProtocolConstant;
import com.comtika.safe.core.protocol.utils.SocketUtil;
import com.comtika.safe.core.protocol.eunms.SpecialCode;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.ByteToMessageDecoder;

import java.util.ArrayList;
import java.util.List;

/***
 * 解码
 */
//@Component
public class NettyDecoder extends ByteToMessageDecoder {
    private static int count = ProtocolConstant.ORIGIN_LENGTH;

    @Override
    protected void decode(ChannelHandlerContext ctx, ByteBuf in, List<Object> out) throws Exception {
        try{
            int i = in.readableBytes();
            count = ProtocolConstant.ORIGIN_LENGTH;
            if(i >= count){
                if(!SocketUtil.checkOrderStartNetty(in,i)){
                    return;
                }
                int b = 0;
                //判断 控制码 是否是长指令    4,1,-16,16,22
                boolean bl = (in.readByte() == (byte) SpecialCode.SUPER_LONG_CODE.getId());
                if(bl){
                    count = ProtocolConstant.SUPER_LONG_LENGTH;
                    byte[] b2 = new byte[]{in.readByte(),in.readByte()};
                    //b = Integer.valueOf(ProtocolIDUtil.decodeEvenProtocolID(b2));// 移除 这里转换为16进制的字符串
                    b = BaseTypeConvert.bytes2IntBE(b2);
                }else{
                    count = ProtocolConstant.ORIGIN_LENGTH;
                    b = in.readByte();//这里长度 并包括一个控制指令
                }
                if(b < 0){
                    b += 256;
                }
                //临时长度
                int tmpLeng = in.readableBytes();
                if (tmpLeng < b + 2) {
                    in.resetReaderIndex();
                    return ;
                }
                //现在的位置还在数字长度
                in.readerIndex(in.readerIndex() + b + 1);//到最后看是否是 结束符号
                if( in.readByte() == SpecialCode.END_CODE.getId()){
                    in.resetReaderIndex();//回到标记位置
                    byte[] res = new byte[count+b-1];
                    in.readBytes(res);
                    //否则 数据够啦 长度为 count+b-1
                    //byte[] res = SocketUtil.findByteBufNetty(in,count+b-1);
                    OrderEntity checkOrderData = null;
                    try {
                        checkOrderData = SocketUtil.checkOrderData(res,bl);
                    } catch (Exception e) {
                        e.printStackTrace();
                        System.out.println("解码异常："+e.getMessage());
                    }
                    //验证成功
                    if(checkOrderData != null)out.add(checkOrderData);
                }
                //in.discardReadBytes();
            }
        }catch (Exception e){
            e.printStackTrace();
        }
    }
    public static void main(String[] args) throws Exception {
        NettyDecoder nd = new NettyDecoder();
        List<Object> list = new ArrayList<>();
        byte t[] = new byte[]{104,0,16,0,85,102,-128,104,4,1,-16,16,22};
        ByteBuf byteBuf = Unpooled.copiedBuffer(t);
        nd.decode(null,byteBuf,list);
        list.forEach(s->{
            System.out.println(s);
        });
    }
}
