package com.comtika.safe.core.protocol.netty.hcode;

import com.comtika.safe.core.protocol.ProtocolConstant;
import com.comtika.safe.core.protocol.cache.SafeCache;
import com.comtika.safe.core.protocol.entity.netty.OrderEntity;
import com.comtika.safe.core.protocol.eunms.netty.OrderCodeType;
import com.comtika.safe.core.protocol.utils.SocketUtil;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToByteEncoder;

/***
 * 编码器
 */
//@Component
public class NettyEncoder extends MessageToByteEncoder<OrderEntity> {

    @Override
    protected void encode(ChannelHandlerContext ctx, OrderEntity oe, ByteBuf out) throws Exception {
        try{
            // System.out.println("发送指令：【"+oe.toJson()+"】时间为："+ DateTimeUtils.formatDate(DateTimeUtils.FORMAT));
            byte[] data = oe.getData();
            int dataL = data.length;
            boolean bl = (oe.getOrderCode() == OrderCodeType.CON_SUPER_LONG.getReqCode());
            if (bl) {// 超长指令
                dataL += ProtocolConstant.SUPER_LONG_LENGTH;
            } else {
                dataL += ProtocolConstant.ORIGIN_LENGTH;
            }
            byte[] createByteByEntity = null;
            try {
                createByteByEntity = SocketUtil.createByteByEntity(oe, dataL,bl);
                //oe.setAllData(createByteByEntity);// 这里是所有数据
                SafeCache.set(oe,createByteByEntity);//心电跟踪
                out.writeBytes(createByteByEntity);
            } catch (Exception e) {
                e.printStackTrace();
            }
            createByteByEntity = null;
            oe = null;
        }catch (Exception e){
            e.printStackTrace();
        }
    }
}
