package com.comtika.safe.core.protocol.ota;


import com.comtika.safe.core.protocol.utils.ProtocolIDUtil;

import java.util.zip.CRC32;

/***
 *
 * @ClassName: CRC32Utils
 * @Description:CRC32 校验
 * @author zhaoLuYang
 * @date2018年8月23日 下午3:01:16
 * @version V1.0
 */
public class CRC32Utils {
	private static final CRC32 CRC = new CRC32();
	/**
	 * @Title: encrypt
	 * @Description: CRC32 检验
	 * @param data
	 * @return
	 * long
	 * @throws
	 * @变更记录  2018年8月23日 下午4:15:05 zhaoLuYang create
	 */
	public static long encrypt(byte[] data) {
		return iswardEncrypt(data);
	}
	/***
	 * CRC32 校验
	 */
	public static byte[] encryptByte(Byte[] data) throws ArrayIndexOutOfBoundsException{
		int size = data.length;
		byte[] bt = new byte[size];
		for(int i=0;i<size;i++){
			bt[i] = data[i];
		}
		long iswardEncrypt = iswardEncrypt(bt);
		System.out.println(iswardEncrypt);
		String s = Long.toHexString(iswardEncrypt);
		int length = s.length();
		if(length > 9){
			throw new ArrayIndexOutOfBoundsException("上传文件大于规定文件大小，请检查升级包大小");
		}
		for(int i=length;i<8;i++){
			s="0"+s;
		}
		return ProtocolIDUtil.encodeEvenProtocolID(s);
	}
	private static long iswardEncrypt(byte[] data){
		CRC.reset();
		CRC.update(data);
		return CRC.getValue();
	}


}
