package com.comtika.safe.core.protocol.responseUtil;


import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

/**
 * @author actor
 * @date 2018/12/11 16:00
 */
public class FutureAdapter<V> implements Future<V> {
    private final ResponseFuture future;
    public FutureAdapter(String sign){
        this.future = new DefaultFuture(sign);
    }
    public FutureAdapter(String sign,int time,TimeUnit unit){
        this.future = new DefaultFuture(sign,time,unit);
    }

    public FutureAdapter(ResponseFuture future) {
        this.future = future;
    }

    public ResponseFuture getFuture() {
        return this.future;
    }

    public boolean cancel(boolean mayInterruptIfRunning) {
        return false;
    }

    public boolean isCancelled() {
        return false;
    }

    public boolean isDone() {
        return this.future.isDone();
    }

    public V get() throws InterruptedException, ExecutionException {
        try {
            return (V)this.future.get();
        } catch (Exception var2) {
            throw new ExecutionException(var2.getMessage(), var2);
        } catch (Throwable var3) {
            throw new InterruptedException(var3.getMessage());
        }
    }

    public V get(long timeout, TimeUnit unit) throws InterruptedException, ExecutionException, TimeoutException {
        int timeoutInMillis = (int)TimeUnit.MILLISECONDS.convert(timeout, unit);
        try {
            return (V)this.future.get(timeoutInMillis,TimeUnit.MILLISECONDS);
        } catch (TimeoutException var6) {
            throw new TimeoutException(var6.getMessage());
        } catch (Exception var7) {
            throw new ExecutionException(var7.getMessage(), var7);
        } catch (Throwable var8) {
            throw new InterruptedException(var8.getMessage());
        }
    }

    public static void main(String[] args)throws Exception{
        FutureAdapter f1 = new FutureAdapter(new DefaultFuture("miss"));
        FutureAdapter f2 = new FutureAdapter(new DefaultFuture("haha"));
        Thread.sleep(2000);

        Object o = f1.get();
        System.out.println(o);
        Object o2 = f2.get();
        System.out.println(o2);
    }
}
