package com.comtika.safe.core.protocol.utils;


import com.comtika.safe.common.utils.StringUtil;
import com.comtika.safe.core.protocol.entity.FaultEnableReport;
import com.comtika.safe.core.protocol.eunms.OnOffType;

/**
 *
 * @ClassName: FaultDiagnosis
 * @Description:故障诊断
 * @author zhaoLuYang
 * @date2018年5月31日 上午10:22:43
 * @version V1.0
 */
public class FaultDiagnosis {
	/**
	 * /**
	 * 故障字：Bit0：过压；Bit1：欠压；Bit2：过流；
		Bit3：过载；Bit4：过温；
		Bit5：负载连接失败(请先确保连接负载，再下订单)
		Bit6：漏电流保护；Bit7：接地故障；
		Bit8：充电超时；

	private OnOffType tooV;
	private OnOffType oweV;
	private OnOffType tooI;
	private OnOffType tooLoad;
	private OnOffType tooHot;
	private OnOffType loadConFail;
	private OnOffType protectI;
	private OnOffType groundFail;
	private OnOffType chargeTimeout;
	 */
	public static String faultDiagnosis(FaultEnableReport fault){
		StringBuffer sb = new StringBuffer("");
		if(fault.getTooV() == OnOffType.ON){
			sb.append("过压、");
		}
		if(fault.getOweV() == OnOffType.ON){
			sb.append("欠压、");
		}
		if(fault.getTooI() == OnOffType.ON){
			sb.append("过流、");
		}
		if(fault.getTooLoad() == OnOffType.ON){
			sb.append("过载、");
		}
		if(fault.getTooHot() == OnOffType.ON){
			sb.append("过温、");
		}
		if(fault.getProtectI() == OnOffType.ON){
			sb.append("负载连接失败(请先确保连接负载，再下订单)、");
		}
		if(fault.getProtectI() == OnOffType.ON){
			sb.append("漏电流保护、");
		}
		if(fault.getGroundFail() == OnOffType.ON){
			sb.append("接地故障、");
		}
		if(fault.getChargeTimeout() == OnOffType.ON){
			sb.append("充电超时、");
		}
		String str = sb.toString();
		if(StringUtil.isEmpty(str)){
			return str;
		}
		return str.substring(0, str.lastIndexOf("、"));
	}
	public static void main(String[] args) {
		FaultEnableReport fl = new FaultEnableReport(new byte[]{0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0});
		System.out.println(faultDiagnosis(fl));

	}
}
