package com.comtika.safe.core.protocol.utils;


import com.comtika.safe.common.exception.RespException;

/**
 *
 * @ClassName: ProtocolIDUtil
 * @Description:这里是用在与硬件通讯标识公共类
 * @author zhaoLuYang
 * @date2018年6月1日 上午10:11:36
 * @version V1.0
 */
public class ProtocolIDUtil {

	/**
	 * 并且字符串为偶数
	 * 将对于的数据编码成字符串
	 */
	public static byte[] encodeEvenProtocolID(String str){
		int length = str.length();
		if(length%2 !=0 ){
			throw new RespException("String entry must be an accidental length");
		}
		byte[] res = new byte[length/2];
		for(int i=0;i<length/2;i++){
			int parseInt = Integer.parseInt(str.substring(i*2, (i+1)*2),16);
			res[i] = (byte) parseInt;
		}
		return res;
	}

	/**
	 * 解码字节数组为字符串 返回为偶数长度的字符串
	 */
	public static String decodeEvenProtocolID(byte[] by){
		StringBuffer sb = new StringBuffer();
		int size = by.length;
		for(int i = 0; i < size ; i++){
			String str = Integer.toHexString(by[i]<0?by[i]+256:by[i]);//转化16进制
			try {
				int tmp  = Integer.parseInt(str);
				sb.append(tmp<10?"0"+tmp:tmp);
			} catch (Exception e) {
				if(str.length() == 2){
					sb.append(str);
				}else{
					sb.append("0"+str);
				}
			}
		}
		return sb.toString();
	}

}
