package com.comtika.safe.core.protocol.utils;

import com.comtika.safe.common.response.RespWrapper;
import com.comtika.safe.core.protocol.entity.DeviceParamsHelp;
import com.comtika.safe.core.protocol.entity.safe.BitHelp;
import com.comtika.safe.core.protocol.entity.safe.SafeTaskHelp;
import com.comtika.safe.core.protocol.entity.safe.WarnDataHelp;
import com.comtika.safe.core.protocol.entity.safe.WarnErrHelp;
import com.comtika.safe.core.protocol.entity.timer.TimerQueryHelp;
import com.comtika.safe.entity.report.RepAlwaysData;
import com.comtika.safe.entity.safe.RepDataRecord;
import lombok.extern.log4j.Log4j2;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Log4j2
public class SafeDataConvertUtil {
    /** leakageCurrent  2
     *   private Integer tempAbove;//节点预警温度保护上限阈值 1b
     *     private Integer currentAbove;// 节 点 预 警 电 流 保 护 上 限 阈 值 2b
     *     private Integer powerAbove;//节 点 预 警 功 率 保 护 上 限 阈 值  2b
     *     private Integer voltageBelow;//节点预警电压保护下限阈值， 2b
     *     private Integer voltageAbove;//节点预警电压保护上限阈值， 2b
     *
     *     private Integer tempAboveMain1;//主机预警温度保护上限阈值 1
     *     [][] 2
     *     private Integer leakageCurrentUp;// 节点报警漏电流保护阈值 2
     *     private Integer tempAboveUp;//节点报警温度保护上限阈值 1
     *     private Integer currentAboveUp;//节 点 报 警 电 流 保 护 上 限 阈 值 2b
     *     private Integer powerAboveUp;2
     *      private int voltageBelowUp;2
     *     private int voltageAboveUp;2
     *     private Integer currentShortCircuit;//节点报警短路阈值2
     *     private Integer tempAboveMain2;1
     *     private Integer delayShutdown;//主机报警断电延迟时长 1
     *     private Integer sensitivitySmokeDetector;1
     * @param data
     * @return
     */
    public static RespWrapper<DeviceParamsHelp> findTerminalParams(byte[] data) {
        if (data.length != 42) {
            log.error("数据格式错误");
            return RespWrapper.makeFailResp("数据格式错误");
        }
        DeviceParamsHelp help = new DeviceParamsHelp();
        byte[] lv2 = new byte[2];
        // byte[] lv4 = new byte[4];
        System.arraycopy(data, 6, lv2, 0, 2);
        help.setLeakageCurrent(BaseTypeConvert.bytes2IntBE(lv2));
        help.setTempAbove(data[8]);
        System.arraycopy(data, 9, lv2, 0, 2);
        help.setCurrentAbove(BaseTypeConvert.bytes2IntBE(lv2));
        System.arraycopy(data, 11, lv2, 0, 2);
        help.setPowerAbove(BaseTypeConvert.bytes2IntBE(lv2));
        System.arraycopy(data, 13, lv2, 0, 2);
        help.setVoltageBelow(BaseTypeConvert.bytes2IntBE(lv2));
        System.arraycopy(data, 15, lv2, 0, 2);
        help.setVoltageAbove(BaseTypeConvert.bytes2IntBE(lv2));
        help.setTempAboveMain1(data[17]);
        System.arraycopy(data, 20, lv2, 0, 2);
        help.setLeakageCurrentUp(BaseTypeConvert.bytes2IntBE(lv2));
        help.setTempAboveUp(data[22]);
        System.arraycopy(data, 23, lv2, 0, 2);
        help.setCurrentAboveUp(BaseTypeConvert.bytes2IntBE(lv2));
        System.arraycopy(data, 25, lv2, 0, 2);
        help.setPowerAboveUp(BaseTypeConvert.bytes2IntBE(lv2));
        System.arraycopy(data, 27, lv2, 0, 2);
        help.setVoltageBelowUp(BaseTypeConvert.bytes2IntBE(lv2));
        System.arraycopy(data, 29, lv2, 0, 2);
        help.setVoltageAboveUp(BaseTypeConvert.bytes2IntBE(lv2));
        System.arraycopy(data, 31, lv2, 0, 2);
        help.setCurrentShortCircuit(BaseTypeConvert.bytes2IntBE(lv2));
        help.setTempAboveMain2(data[33]);
        help.setDelayShutdown(data[34]);
        help.setSensitivitySmokeDetector(data[35]);
        return RespWrapper.makeSuccessResp(help);
    }

    /**
     *   private int leakageCurrent;// 节点预警漏电流保护阈值 2b
     *     private int tempAbove;//节点预警温度保护上限阈值 1b
     *     private int currentAbove;// 节 点 预 警 电 流 保 护 上 限 阈 值 2b
     *     private int powerAbove;//节 点 预 警 功 率 保 护 上 限 阈 值  2b
     *     private int voltageBelow;//节点预警电压保护下限阈值， 2b
     *     private int voltageAbove;//节点预警电压保护上限阈值， 2b
     *     private int tempAboveMain1;//主机预警温度保护上限阈值 1
     *     private int leakageCurrentUp;// 节点报警漏电流保护阈值 2
     *     private int tempAboveUp;//节点报警温度保护上限阈值 1
     *     private int currentAboveUp;//节 点 报 警 电 流 保 护 上 限 阈 值 2b
     *     private int powerAboveUp;
     *     private int voltageBelowUp;
     *     private int voltageAboveUp;
     *     private int currentShortCircuit;//节点报警短路阈值 2
     *     private int tempAboveMain2;1
     *     private int delayShutdown;//主机报警断电延迟时长 1
     *     private int sensitivitySmokeDetector;1
     * @param res
     * @param help
     */
    public static void setTerminalParams(byte[] res, DeviceParamsHelp help) {
        // System.arraycopy(ProtocolIDUtil.encodeEvenProtocolID(enp.getNodeNo()), 0, res, 0, 6);//节点
        System.arraycopy(BaseTypeConvert.int2BytesBE(help.getLeakageCurrent(), 2), 0, res, 6, 2);
        res[8] = (byte) help.getTempAbove();
        System.arraycopy(BaseTypeConvert.int2BytesBE(help.getCurrentAbove(), 2), 0, res, 9, 2);
        System.arraycopy(BaseTypeConvert.int2BytesBE(help.getPowerAbove(), 2), 0, res, 11, 2);
        System.arraycopy(BaseTypeConvert.int2BytesBE(help.getVoltageBelow(), 2), 0, res, 13, 2);
        System.arraycopy(BaseTypeConvert.int2BytesBE(help.getVoltageAbove(), 2), 0, res, 15, 2);
        res[17] = (byte) help.getTempAboveMain1();
        // 18 19
        System.arraycopy(BaseTypeConvert.int2BytesBE(help.getLeakageCurrentUp(), 2), 0, res, 20, 2);
        res[22] = (byte)help.getTempAboveUp();
        System.arraycopy(BaseTypeConvert.int2BytesBE(help.getCurrentAboveUp(), 2), 0, res, 23, 2);
        System.arraycopy(BaseTypeConvert.int2BytesBE(help.getPowerAboveUp(), 2), 0, res, 25, 2);
        System.arraycopy(BaseTypeConvert.int2BytesBE(help.getVoltageBelowUp(), 2), 0, res, 27, 2);
        System.arraycopy(BaseTypeConvert.int2BytesBE(help.getVoltageAboveUp(), 2), 0, res, 29, 2);
        System.arraycopy(BaseTypeConvert.int2BytesBE(help.getCurrentShortCircuit(), 2), 0, res, 31, 2);
        res[33] = (byte)help.getTempAboveMain2();
        res[34] = (byte)help.getDelayShutdown();
        res[35] = (byte)help.getSensitivitySmokeDetector();
    }
    private static int base = 14;
    public static RespWrapper<List<SafeTaskHelp>> handleSafeFindTask(byte[] data) {
        int length = data.length;
        if(length == 0)return RespWrapper.makeSuccessResp(new ArrayList<>(0));
        int size = byteToInt(data[0]);
        log.error("获取的定时任务个数为：{}",size);
        if(size == 0) return RespWrapper.makeSuccessResp(new ArrayList<>(0));
        List<SafeTaskHelp> list = new ArrayList<>(size);
        try {
            for(int i=0;i<size;i++){
                int bit = i*base;
                SafeTaskHelp help = new SafeTaskHelp();
                help.setNumber(data[bit+1]);
                help.setStartDay(data[bit+2]);
                help.setStartMonth(data[bit+3]);
                help.setStartYear(byteToYear(data[bit+4]));
                help.setEndDay(data[bit+5]);
                help.setEndMonth(data[bit+6]);
                help.setEndYear(byteToYear(data[bit+7]));
                help.setTaskModel(data[bit+8]);
                help.setLoop(data[bit+9]);
                help.setTaskTime(data[bit+10]);
                help.setTaskMinute(data[bit+11]);
                help.setBit(BitHelp.bytesToBit(new byte[]{data[bit+12],data[bit+13]}));
                help.setContent(data[bit+14]);
                list.add(help);
            }
        }catch (Exception e){
            e.printStackTrace();
            return RespWrapper.makeFailResp("解析数据错误:"+e.getMessage());
        }
        return RespWrapper.makeSuccessResp(list);
    }
    private static int byteToInt(byte b){
        if(b < 0)
            return 256+b;
        return b;
    }
    public static byte[] safeTaskConvert(List<SafeTaskHelp> list)throws Exception{
        int size = list.size();
        byte[] bytes = new byte[size*base];
        for(int i =0 ;i<size;i++){
            int index = base*i;
            SafeTaskHelp help = list.get(i);
            bytes[index] = (byte) help.getNumber();
            bytes[index+1] = (byte) help.getStartDay();
            bytes[index+2] = (byte) help.getStartMonth();
            bytes[index+3] = yearToByte(help.getStartYear());
            bytes[index+4] = (byte) help.getEndDay();
            bytes[index+5] = (byte) help.getEndMonth();
            bytes[index+6] = yearToByte(help.getEndYear());

            bytes[index+7] = (byte) help.getTaskModel();
            bytes[index+8] = (byte) help.getLoop();
            bytes[index+9] = (byte) help.getTaskTime();
            bytes[index+10] = (byte) help.getTaskMinute();
            byte[] bytes1 = BitHelp.convertBytes(help.getBit());
            bytes[index+11] = bytes1[0];
            bytes[index+12] = bytes1[1];
            bytes[index+13] = (byte) help.getContent();
        }
        return bytes;
    }
    private static byte yearToByte(String year){
        if(year.length() > 2){
            String str = String.valueOf(year);
            return Byte.valueOf(str.substring(str.length()-2));
        }
        return Byte.valueOf(year);
    }
    private static String byteToYear(byte by){
        // int it = by;
        return "20"+by;
    }

    // 处理数据
    public static RepDataRecord repDataConvert(byte[] data) {

        RepDataRecord res = new RepDataRecord();
        byte[] lv6 = new byte[6];
        System.arraycopy(data, 0, lv6, 0, 6);
        res.setNodeNo(ProtocolIDUtil.decodeEvenProtocolID(lv6));
        res.setDeviceId((int) data[6]);
        res.setSubT((int) data[7]);
        byte[] lv2 = new byte[2];
        byte[] lv4 = new byte[4];
        System.arraycopy(data, 8, lv2, 0, 2);
        res.setSubV(BaseTypeConvert.bytes2IntBE(lv2));
        System.arraycopy(data, 10, lv4, 0, 4);
        res.setSubI(BaseTypeConvert.bytes2IntBE(lv4));
        System.arraycopy(data, 14, lv4, 0, 4);
        res.setSubP(BaseTypeConvert.bytes2IntBE(lv4));
        System.arraycopy(data, 18, lv4, 0, 4);
        res.setSubE(BaseTypeConvert.bytes2IntBE(lv4));
        System.arraycopy(data, 22, lv2, 0, 2);
        res.setSubLeakI(BaseTypeConvert.bytes2IntBE(lv2));
        res.setMainT((int) data[24]);
        res.setPlugState((int) data[25]);
        res.setPlugNo((int) data[26]);
        return res;

    }

    public static WarnDataHelp reqWarnDataConvert(byte[] data)throws Exception {
        WarnDataHelp help = new WarnDataHelp();
        byte[] lv6 = new byte[6];
        System.arraycopy(data, 0, lv6, 0, 6);
        String nodeNo = ProtocolIDUtil.decodeEvenProtocolID(lv6);//节点id
        help.setNodeNo(nodeNo);
        help.setPlugNo(data[6]);
        byte[] lv4 = new byte[4];
        // 4个字节 暂时不处理 4个字节
        help.setWarnT(data[11]);
        byte[] lv2 = new byte[2];
        System.arraycopy(data, 12, lv2, 0, 2);
        help.setWarnV(BaseTypeConvert.bytes2IntBE(lv2));
        System.arraycopy(data, 14, lv4, 0, 4);
        help.setWarnI(BaseTypeConvert.bytes2IntBE(lv4));
        System.arraycopy(data, 18, lv4, 0, 4);
        help.setWarnP(BaseTypeConvert.bytes2IntBE(lv4));
        System.arraycopy(data, 22, lv2, 0, 2);
        help.setWarnLeakI(BaseTypeConvert.bytes2IntBE(lv2));
        help.setMainT(data[24]);
        System.arraycopy(data, 7, lv4, 0, 4);
        WarnErrHelp warnHelp = WarnErrHelp.createWarnHelp(lv4,nodeNo);
        help.setErr(warnHelp);
        return help;
    }

    public static RepAlwaysData handleFindReportData(byte[] data)throws Exception {
        RepAlwaysData res = new RepAlwaysData();
        byte[] lv6 = new byte[6];
        System.arraycopy(data, 0, lv6, 0, 6);
        String nodeNo = ProtocolIDUtil.decodeEvenProtocolID(lv6);
        res.setNodeNo(nodeNo);
        // 加4个字节
        byte[] lv4 = new byte[4];

        res.setDeviceId(data[10]);
        res.setRepT(data[11]);
        byte[] lv2 = new byte[2];
        System.arraycopy(data, 12, lv2, 0, 2);
        res.setRepV(BaseTypeConvert.bytes2IntBE(lv2));

        System.arraycopy(data, 14, lv4, 0, 4);
        res.setRepI(BaseTypeConvert.bytes2IntBE(lv4));


        System.arraycopy(data, 18, lv4, 0, 4);
        res.setRepP(BaseTypeConvert.bytes2IntBE(lv4));

        System.arraycopy(data, 22, lv4, 0, 4);
        res.setRepEleP(BaseTypeConvert.bytes2IntBE(lv4));

        System.arraycopy(data, 26, lv2, 0, 2);
        res.setRepLeakI(BaseTypeConvert.bytes2IntBE(lv2));

        res.setMainT(data[28]);
        res.setPlugState(data[29]);
        res.setPlugNo(data[30]);
        System.arraycopy(data, 6, lv4, 0, 4);
        WarnErrHelp warnHelp = WarnErrHelp.createWarnHelp(lv4,nodeNo);
        res.setErr(warnHelp);
        return res;
    }

    public static void doHandleTimerData(List<TimerQueryHelp> list, byte[] data) {
        byte[] bytes = BaseTypeConvert.int2BytesBE(data[1],8);
        byte[] lv2 =  new byte[2];
        for(int i=0;i<8;i++){
            System.arraycopy(data, (i+1)*2, lv2, 0, 2);
            TimerQueryHelp l1 = new TimerQueryHelp(bytes[i],BaseTypeConvert.bytes2IntBE(lv2));
            list.add(l1);
        }
    }
}
