package com.comtika.safe.core.protocol.utils;


import com.comtika.safe.core.protocol.entity.netty.OrderEntity;
import com.comtika.safe.core.protocol.eunms.DataLength;
import com.comtika.safe.core.protocol.eunms.SpecialCode;
import io.netty.buffer.ByteBuf;

//import org.apache.mina.core.buffer.IoBuffer;


/**
 * @desc	:	socket 检查通用类
 * @author	:	actorLucky[494977551@qq.com]
 * @date	:	2018年5月18日 下午2:49:20
 */
public class SocketUtil {
	/*** 普通指令，除数据后的长度*/
	public static final int ORIGIN_LENGTH = 13;
	/**超长指令长度**/
	public static final int SUPER_LONG_LENGTH = 14;


	/***
	 * netty 判断是否是请求头
	 * @param in
	 * @return
	 */
	public static boolean checkOrderStartNetty(ByteBuf in,int totalCount)throws Exception{
		byte b ;
		while (totalCount > 0){
			totalCount--;
			in.markReaderIndex();
			b = in.readByte();
			if(b == SpecialCode.START_CODE.getId()){
				if(totalCount > 6){
					in.readerIndex(in.readerIndex()+6);
					if(in.readByte() == SpecialCode.START_CODE.getId()) {
						return true;
					}else {
						in.resetReaderIndex();
						in.readByte();
					}
				}else {//这里说明不够数据，准备下次 准备抛弃读过的数据
					in.resetReaderIndex();
					in.discardReadBytes();
					return false;
				}
			}
		}
		return false;
	}


	/**
	 * 检验数据是否正确
	 * @param by
	 * @return
	 * @throws Exception
	 */
	public static OrderEntity checkOrderData(byte[] by, boolean bl) throws Exception{
		// if(ProtocolConstant.DEFAULT_CHECK == ValidateType.CS){
		// 	return checkOrderDataByCS(by,bl);
		// }
		// return null;
		return checkOrderDataByCS(by,bl);//只有cs 校验
	}
	/**
	 * 和校验
	 *
	 *
	 *这里需要修改，因为超长指令有2个字节的数据长度，其他指令都是一个字节的指令，所有到超长指令时需要另外一种方式解析
	 *2018.08.14
	 * @param by
	 * @return
	 */
	public static OrderEntity checkOrderDataByCS(byte[] by,boolean bl)throws Exception{
		int totalLength = by.length;
		int sum = 0;
		byte[] ids = new byte[6];
		byte orderCoder = 0;
		byte operationCode = 0;
		//boolean bl = (orderCoder == (byte)SpecialCode.SUPER_LONG_CODE.getId());
		byte[] dataBy = null;
		if(bl){
			dataBy = new byte[totalLength-SUPER_LONG_LENGTH];
		}else{
			dataBy = new byte[totalLength-ORIGIN_LENGTH];
		}
		int index = 0;
		for(int i=0;i<totalLength-2;i++){
			byte b = by[i];
			sum += b;
			if(i > 0 && i < 7){//下面是集中器编号
				ids[index++] = b;
			}else if(i == 8){
				orderCoder = b;// 这个是响应码 0x85
			}else{
				if(bl){
					if(i == 11){//9 与 10 为数据长度 忽略
						index = 0;
						operationCode = b;
					}else if( i > 11){
						try {
							dataBy[index++] = b;
						} catch (Exception e) {
							e.printStackTrace();
							return null;
						}
					}
				}else{
					if(i == 10){ //9是长度
						index = 0;
						operationCode = b;
					}else if(i > 10 ){
						try {
							dataBy[index++] = b;
						} catch (Exception e) {
							e.printStackTrace();
							return null;
						}
					}
				}
			}
		}
		int r = by[totalLength-2];
		if(r < 0){
			r +=256;
		}
		int tmpNum = sum % 256;
		if(tmpNum < 0){
			tmpNum+=256;
		}
		if(tmpNum == r){
			OrderEntity res = new OrderEntity(ids, orderCoder, operationCode, dataBy);
			res.setAllData(by);
			return res;
		}
		return null;
	}

	private static byte[] adjustValueConvertByte(int id)throws Exception{
		String adjustValue = adjustValue(id);
		int length = adjustValue.length()/2;
		byte[] res = new byte[length];
		for(int i=0;i<length;i++){
			res[i] = Byte.valueOf(adjustValue.substring(i*2, (i+1)*2));
		}
		return res;
	}
	/***
	 *
	 * @Title: adjustValueConvert
	 * @Description: TODO(这里用一句话描述这个方法的作用)
	 * @param id
	 * @return
	 * @throws Exception
	 * byte[]
	 * @throws
	 * @变更记录  2018年8月28日 上午10:04:11 zhaoLuYang create
	 */
	public static byte[] adjustValueConvert(int id, DataLength data)throws Exception{
		int bit = data.getId();
		if(bit%2 != 0){
			throw new RuntimeException("输入：【"+bit+"】必须是偶数");
		}
		String hex = Integer.toHexString(id);
		int length = hex.length();
		if(length > bit){
			throw new RuntimeException("长度大于输入：【"+bit+"】长度");
		}
		for(int i=length;i<bit;i++){
			hex = "0"+hex;
		}
		return ProtocolIDUtil.encodeEvenProtocolID(hex);
	}
	/***
	 * 调整值
	 */
	private static String adjustValue(int id)throws Exception{
		String str = String.valueOf(id).trim();
		int i = str.length();
		if(i > 4){
			throw new RuntimeException("Send Data out Fix Length");
		}
		for(;i<4;i++){
			str = "0"+str;
		}
		return str;
	}
	//生成  发送byte[] 数组
	public static byte[] createByteByEntity(OrderEntity oe,int totalLength,boolean isSuperLongOper)throws Exception{
		byte[] by = new byte[totalLength];
		byte[] data = oe.getData();
		int tmpDataL = data.length;

		byte startByte =  (byte) SpecialCode.START_CODE.getId();
		by[0] = startByte;
		System.arraycopy(ProtocolIDUtil.encodeEvenProtocolID(oe.getId()), 0, by, 1, 6);
		by[7] = startByte;
		by[8] = (byte) oe.getOrderCode();
		//这里需要修改
		if(isSuperLongOper){//超长指令
			System.arraycopy(adjustValueConvert(tmpDataL+1, DataLength.PAIR),0,by,9,2);
			by[11] = (byte)oe.getOperationCode();
			if(tmpDataL > 0){
				System.arraycopy(data, 0, by, 12, tmpDataL);
			}
		}else{
			by[9] = (byte) (1+tmpDataL);
			by[10] = (byte) oe.getOperationCode();
			if(tmpDataL > 0){
				System.arraycopy(data, 0, by, 11, tmpDataL);
			}
		}
		int sum = 0;
		for(int i=0;i< totalLength-2;i++){
			sum +=by[i];
		}
		if(sum < 0){
			sum += 256;
		}
		by[totalLength-2] = (byte) (sum%256);
		by[totalLength-1] = (byte) SpecialCode.END_CODE.getId();
		return by;
	}
	/**通过byteBuf 获取byte数组*/
	public static byte[] findByteBufNetty(ByteBuf in, int count)throws Exception {
		byte[] res = new byte[count];
		for(int i=0;i < count;i++){
			res[i] = in.readByte();
		}
		return res;
	}
}
