package com.comtika.safe.core.weChat;

import com.comtika.safe.common.response.RespWrapper;
import com.comtika.safe.common.utils.DateTimeUtils;
import com.comtika.safe.common.utils.StringUtil;
import com.comtika.safe.entity.warn.help.WarnMessageHelp;

import java.util.*;

/**
 * @author actor_miss
 * @version V1.2.1
 * @ClassName: MessageDataHandle
 * @Description:消息处理类
 * @date2018年9月12日 下午10:18:56
 */
public class MessageDataHandle {
    private static final String KEYWORD_INDEX = "KW_I";
    private static final String TMP_VALUE = "T_V";
    private static final String COLOR_VALUE = "C_V";
    private static final String MSG_NOT_COLOR_ALI = "\\\"keyword" + KEYWORD_INDEX
            + "\\\":{\\\"value\\\":\\\"" + TMP_VALUE + "\\\"},";
    private static final String MSG_COLOR_WX = "\"keyword" + KEYWORD_INDEX
            + "\":{\"color\":\"" + COLOR_VALUE + "\",\"value\":\"" + TMP_VALUE + "\"},";
    private static final String MSG_WARN_WX = "\"" + KEYWORD_INDEX
            + "\":{\"color\":\"" + COLOR_VALUE + "\",\"value\":\"" + TMP_VALUE + "\"},";
    private static String[] COLOR_STYLE = new String[]{"#173177", "#E41834"};
    private static final String[] WX_NAMES = new String[]{"touser", "template_id", "page", "form_id", "data", "emphasis_keyword"};
    private static final String[] ALI_NAMES = new String[]{"to_user_id", "form_id", "user_template_id", "page", "data"};
    public static final String[] WX_WARN_NAME = new String[]{"touser", "template_id", "data"};

    /**
     * @param list
     * @param isWX 是否是微信
     * @param isPN 是否是微信工作号推送
     * @return
     * @throws ArrayIndexOutOfBoundsException String
     * @throws
     * @Title: createTemplateMessage
     * @Description: TODO(支付宝)
     * @变更记录 2018年9月13日 下午8:47:47 actor_miss create
     *  这里是小程序消息
     */
    public static String createTemplateMessage(List<String> list, boolean isWX, boolean isPN) throws ArrayIndexOutOfBoundsException {
        if (list == null) return null;
        int size = list.size();
        if (size < 1) return null;
        StringBuffer sb = new StringBuffer("{");
        if (isWX) {
            for (int i = 0; i < size; ) {
                sb.append((MSG_COLOR_WX.replaceAll(TMP_VALUE, list.get(i)).replaceAll(KEYWORD_INDEX, (++i) + "").replaceAll(COLOR_VALUE, COLOR_STYLE[0])
                ));
            }
        } else {
            for (int i = 0; i < size; ) {
                sb.append((MSG_NOT_COLOR_ALI.replaceAll(TMP_VALUE, list.get(i)).replaceAll(KEYWORD_INDEX, (++i) + "")));
            }
        }
        String k = sb.toString();
        if (isPN) return k;
        return k.substring(0, k.lastIndexOf(",")) + "}";
    }


    /**
     * @param order
     * @param template
     * @return Map<String   ,   Object>
     * @throws
     * @Title: createTempalteReturnMap
     * @Description: TODO(微信)
     * @变更记录 2018年9月12日 下午11:32:31 actor_miss create
     */
   /* public static RespWrapper<String> createTempalteReturnMap(
            CtkServiceOrder order, MessageTemplateType template, boolean supperColler) {
        try {//下面根据不同模版封装不同数据
            List<String> list = new ArrayList<String>();
            *//**
             * 结束充电通知
             * 1、订单编号
             * 2、插座编号
             * 3、开始时间
             * 4、结束时间
             * 5、充电时长
             * 6、充电费用
             * 7、备注（结束原因)
             *
             *//*
            if (template == MessageTemplateType.WX_CHAGER_END) {
                if (StringUtil.isEmpty(order.getOrderNo())) {
                    return RespWrapper.makeFailResp("订单号不能为空");
                }
                if (order.getEndTime() == null) {
                    return RespWrapper.makeFailResp("结束时间不能为空");
                }
                list.add(order.getOrderNo());
                list.add(order.getSocketSeq());
                list.add(DateTimeUtils.formatDate(new Date(order.getStartTime()), DateTimeUtils.FORMAT));
                list.add(DateTimeUtils.formatDate(new Date(order.getEndTime()), DateTimeUtils.FORMAT));
                list.add(orderNoDateAdjust(order.getActChargerTime()));
                list.add(StringUtil.convertInt(order.getTotalFee() + "", 0) * 1.0 / 100 + "元");
                list.add(order.getOrderRes());
                *//**
                 * 充电开始
                 * 1、订单编号
                 * 2、插座编号
                 * 3、开始时间
                 * 4、计划充电时间长
                 * 5、预支付金额
                 *//*
            } else if (template == MessageTemplateType.WX_CHAGER_START) {
                if (StringUtil.isEmpty(order.getOrderNo())) {
                    return RespWrapper.makeFailResp("订单号不能为空");
                }
                if (order.getStartTime() == null) {
                    return RespWrapper.makeFailResp("结束时间不能为空");
                }
                list.add(order.getOrderNo());
                list.add(order.getSocketSeq());
                list.add(DateTimeUtils.formatDate(new Date(order.getStartTime()), DateTimeUtils.FORMAT));
                list.add(orderNoDateAdjust(StringUtil.convertInt(order.getActPeriod() + "", 0)));
                list.add(StringUtil.convertInt(order.getChargeMoney() + "", 0) * 1.0 / 100 + "元");
            } else {
                return RespWrapper.makeFailResp("没有对应消息模版");
            }
            //return RespWrapper.makeSuccessResp(sortMapByKey(JSONObject.parseObject(createTemplateMessage(list,true),Map.class)));
            return RespWrapper.makeSuccessResp(createTemplateMessage(list, true, false));

            //return RespWrapper.makeSuccessResp(privateMap(list,supperColler));
        } catch (Exception e) {
            e.printStackTrace();
            return RespWrapper.makeFailResp("异常：" + e.getMessage());
        }
    }
*/
    private static final String VISIT_FIRST_MESSAGE = "您有新的预约待审核！";
    private static final String VISIT_REMARK_MESSAGE = "请及时审核！";
    private static final String VISIT_VALID_FIRST = "尊敬的用户，你的预约审核结果已出！";
    //private static final String VISIT_VALID_SUC = "请务必带好身份证到访，到达门禁设备时，请将身份证放入对应刷卡区，进行人证比对成功后，开门进入！";
    private static final String VISIT_VALID_SUC = "请务必带好身份证到访登记，更高效快捷通行！";

    // 创建=> 预约消息通知
    public static RespWrapper<String> createVisitMessage(String visitName, Long visitTime, String visitCause){
        List<ParamProperty> list = new ArrayList<>(8);
        list.add(new ParamProperty("first", VISIT_FIRST_MESSAGE, COLOR_STYLE[0]));
        list.add(new ParamProperty("keyword1", visitName, COLOR_STYLE[0]));
        list.add(new ParamProperty("keyword2", DateTimeUtils.formatDate(new Date(visitTime), DateTimeUtils.FORMAT),COLOR_STYLE[0]));
        list.add(new ParamProperty("keyword3", visitCause, COLOR_STYLE[0]));
        list.add(new ParamProperty("remark", VISIT_REMARK_MESSAGE, COLOR_STYLE[1]));
        return RespWrapper.makeSuccessResp(privateStringList(list));
    }
    // 创建审核通知
    public static RespWrapper<String> createValidVisitMessage(boolean isSuccess,String remark){
        List<ParamProperty> list = new ArrayList<>(8);
        list.add(new ParamProperty("first", VISIT_VALID_FIRST, COLOR_STYLE[0]));
        if(isSuccess) {
            list.add(new ParamProperty("keyword1", "同意", COLOR_STYLE[0]));
            list.add(new ParamProperty("remark", VISIT_VALID_SUC, COLOR_STYLE[1]));
        }else{
            list.add(new ParamProperty("keyword1", "拒绝", COLOR_STYLE[0]));
            list.add(new ParamProperty("remark", remark, COLOR_STYLE[1]));
        }
        list.add(new ParamProperty("keyword2", DateTimeUtils.formatDate(new Date(), DateTimeUtils.FORMAT),COLOR_STYLE[0]));
        return  RespWrapper.makeSuccessResp(privateStringList(list));
    }
    /**
     * 创建告警消息 data 数据
     **/
   /* public static RespWrapper<String> createWarnMessage(SysAppointment appointment, boolean isAuto) {
        try {
            List<ParamProperty> list = new ArrayList<>();
            list.add(new ParamProperty("keyword1", warnEntiy.getTerminalNo(), COLOR_STYLE[0]));
            //keys.add(warnEntiy.getTerminalNo());//设备编号
            list.add(new ParamProperty("keyword2", warnEntiy.getEquipName(), COLOR_STYLE[0]));
            //keys.add(warnEntiy.getEquipName());//设备名称
            list.add(new ParamProperty("keyword3", warnEntiy.getSiteName(), COLOR_STYLE[0]));
            //keys.add(warnEntiy.getSiteName());//设备地址
            //告警等级 加告警类型
            Integer warnLevel = warnEntiy.getWarnLevl() == null ? 2 : warnEntiy.getWarnLevl();
            String warnString = warnLevel == 1 ? "一级告警" : "二级告警";
            //keys.add(warnString+"/"+warnEntiy.getWarnType());//告警描述
            list.add(new ParamProperty("keyword5", DateTimeUtils.formatDate(new Date(warnEntiy.getStartTime()), DateTimeUtils.FORMAT), COLOR_STYLE[0]));

            if (isAuto) {
                list.add(new ParamProperty("first", "设备已自动处理告警，请放心使用！", COLOR_STYLE[1]));
                list.add(new ParamProperty("remark", "流水号：" + warnEntiy.getSerialNo(), COLOR_STYLE[0]));
                list.add(new ParamProperty("keyword4", warnString + "/" + warnEntiy.getWarnType(), COLOR_STYLE[0]));
            } else {
                list.add(new ParamProperty("first", "流水号：" + warnEntiy.getSerialNo(), COLOR_STYLE[0]));
                list.add(new ParamProperty("remark", "请及时处理告警，防止造成严重事故！", COLOR_STYLE[1]));
                list.add(new ParamProperty("keyword4", warnString + "/" + warnEntiy.getWarnType(), COLOR_STYLE[1]));
            }
            return RespWrapper.makeSuccessResp(privateStringList(list));
        } catch (Exception e) {
            e.printStackTrace();
            return RespWrapper.makeErrorResp("异常：" + e.getMessage());
        }
    }*/

    private static String privateStringList(List<ParamProperty> list) {
        StringBuffer sb = new StringBuffer("{");
        list.forEach(s -> {
            sb.append(MSG_WARN_WX.replaceAll(KEYWORD_INDEX, s.getName()).replaceAll(TMP_VALUE, s.getKey()).replaceAll(COLOR_VALUE, s.getColor()));
        });
        String k = sb.toString();
        return k.substring(0, k.lastIndexOf(",")) + "}";
    }


    private static Map<String, Object> privateMap(List<String> list, boolean supperColler) {
        int size = list.size();
        Map<String, Object> res = new HashMap<String, Object>();
        for (int i = 0; i < size; ) {
            Map<String, Object> tmpMap = new HashMap<String, Object>();
            if (supperColler) {
                tmpMap.put("color", COLOR_STYLE[0]);
            }
            String st = list.get(i);
            String v = "keyword" + (++i);
            tmpMap.put("value", st);
            res.put(v, tmpMap);
        }
        return res;
    }

    /**
     * 充电时长 转变===》 小时 分钟
     */
    public static String orderNoDateAdjust(int tmp) {
        try {
            if (tmp == 0) {
                return "--";
            }
            StringBuffer sb = new StringBuffer();
            int tm = (int) (tmp / 60);
            if (tm > 0) {
                sb.append(tm + "小时");
            }
            if (tmp % 60 != 0) {
                sb.append((tmp - tm * 60) + "分");
            }
            return sb.toString();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "--";
    }

    /**
     * 使用 Map按key进行排序
     *
     * @param map
     * @return
     */
    public static Map<String, Object> sortMapByKey(Map<String, Object> map) {
        if (map == null || map.isEmpty()) return null;
        Map<String, Object> sortMap = new TreeMap<String, Object>((s1, s2) -> s1.compareTo(s2));
        sortMap.putAll(map);
        return sortMap;
    }

    /**
     * @param strs 微信参数： oppenId 模版id,跳转页，formId,数据，数据放大 】【支付宝参数： "to_user_id","form_id","user_template_id","page","data" ]oppenId,formId,模版id,跳转页，数据
     * @return
     * @throws ArrayIndexOutOfBoundsException String
     * @throws
     * @Title: toJson
     * 支付宝生成格式
     * {"to_user_id":"oppid","form_id":"IWoyxQit_zXugUW_FLMYEI1W0n9t32Qe3Xel01MLsuA","user_template_id":"sss222formId","page":"page/index","data":"{\"keyword1\":{\"value\":\"张三\"},\"keyword2\":{\"value\":\"李思\"}}"}
     * <p>
     * {"to_user_id":"2088102122458832","form_id":"2017010100000000580012345678","user_template_id":"MDI4YzIxMDE2M2I5YTQzYjUxNWE4MjA4NmU1MTIyYmM=","page":"page/component/index","data":"{\"keyword1\":{\"value\":\"12:00\"},\"keyword2\":{\"value\":\"20180808\"},\"keyword3\":{\"value\":\"支付宝\"}}"}
     * 官网格式：
     * "{\"to_user_id\":\"2088102122458832\",\"form_id\":\"2017010100000000580012345678\",\"user_template_id\":\"MDI4YzIxMDE2M2I5YTQzYjUxNWE4MjA4NmU1MTIyYmM=\",\"page\":\"page/component/index\",\"data\":\"{\\\"keyword1\\\":{\\\"value\\\":\\\"12:00\\\"},\\\"keyword2\\\":{\\\"value\\\":\\\"20180808\\\"},\\\"keyword3\\\":{\\\"value\\\":\\\"支付宝\\\"}}\"}"
     * 微信格式
     * 生成的格式：
     * {"touser":"oppid","template_id":"IWoyxQit_zXugUW_FLMYEI1W0n9t32Qe3Xel01MLsuA","page":"page/index","form_id":"sss222formId","data":{"keyword1":{"color":"#173177","value":"张三"},"keyword2":{"color":"#173177","value":"李思"}}}
     * 官网
     * {"touser": "OPENID","template_id": "TEMPLATE_ID","page": "index","form_id": "FORMID","data": {"keyword1": {"value": "339208499"},"keyword2": {"value": "2015年01月05日 12:30"},"keyword3": {"value": "粤海喜来登酒店"},"keyword4": {"value": "广州市天河区天河路208号"}},"emphasis_keyword": "keyword1.DATA"}
     * @Description: TODO(参数依次是 ： " touser ", " template_id ", " page ", " form_id ", " data ", " emphasis_keyword ")
     * @变更记录 2018年9月13日 下午10:43:49 actor_miss create
     */
    public static String toJson(boolean isWX, String... strs) throws ArrayIndexOutOfBoundsException {
        if (strs == null) return null;
        int size = strs.length;
        if (isWX)
            if (size > WX_NAMES.length) throw new ArrayIndexOutOfBoundsException("微信字段过多");
            else if (size > ALI_NAMES.length) throw new ArrayIndexOutOfBoundsException("支付宝字段过多");
        StringBuffer sb = new StringBuffer("{");
        int i = 0;
        if (isWX) {
            for (; i < size; i++) {
                String tmps = WX_NAMES[i];
                if ("data".equals(tmps)) {
                    sb.append("\"" + tmps + "\":" + strs[i] + ",");
                } else {
                    sb.append("\"" + tmps + "\":\"" + strs[i] + "\",");
                }
            }
        } else {
            for (; i < size; i++) {
                sb.append("\"" + ALI_NAMES[i] + "\":\"" + strs[i] + "\",");
            }
        }
        String k = sb.toString();
        return k.substring(0, k.lastIndexOf(",")) + "}";
    }
    private static final String DEFAULT_URL = "https://www.eloam.net/";
    private static final String DEFAULT_APPID = "wxd7e8add904b2de37";//默认的小程序
    private static final String visitUrl = "\"url\":\"%s\",";
    private static final String SMALL_MIN_URL = "\"miniprogram\":{\"appid\":\"%s\",\"pagepath\":\"pages/visitRecord/visitRecord\"},";
    /**
     * 创建公众好消息组装方法
     */
    public static String toJsonPN(boolean isSmall,String appid,String... strs){
        if (strs.length != 3) throw new ArrayIndexOutOfBoundsException("入参长度必须为3");
        StringBuffer sb = new StringBuffer("{");
        for (int i = 0; i < 3; i++) {
            String tmps = WX_WARN_NAME[i];
            if ("data".equals(tmps)) {
                sb.append("\"" + tmps + "\":" + strs[i] + ",");
            } else {
                sb.append("\"" + tmps + "\":\"" + strs[i] + "\",");
            }
        }
        if(isSmall){
            if(StringUtil.isEmpty(appid)) appid = DEFAULT_APPID;
            sb.append(String.format(SMALL_MIN_URL,appid));
        }
        sb.append("\"topcolor\":\"#FF0000\"}");
        return sb.toString();
    }
    private static final String WARN_FIRST = "请注意！有新告警产生";
    private static final String WARN_REMARK = "请及时排除并处理！";

    public static RespWrapper<String> createWarnMessage(WarnMessageHelp help) {
        List<ParamProperty> list = new ArrayList<>(8);
        list.add(new ParamProperty("first", StringUtil.isEmpty(help.getFirst())?WARN_FIRST:help.getFirst(), COLOR_STYLE[0]));
        list.add(new ParamProperty("keyword1", help.getTerminalNo(), COLOR_STYLE[0]));
        list.add(new ParamProperty("keyword2", help.getTerminalType(), COLOR_STYLE[0]));
        list.add(new ParamProperty("keyword3", help.getSiteName(), COLOR_STYLE[0]));
        list.add(new ParamProperty("keyword4", help.getWarnMsg(), COLOR_STYLE[0]));
        list.add(new ParamProperty("keyword5", DateTimeUtils.formatDate(new Date(), DateTimeUtils.FORMAT),COLOR_STYLE[0]));
        list.add(new ParamProperty("remark", StringUtil.isEmpty(help.getRemark())?WARN_REMARK:help.getRemark(), COLOR_STYLE[1]));
        return RespWrapper.makeSuccessResp(privateStringList(list));
    }
}
