package com.comtika.safe.dao.equip.terminal;


import java.util.List;
import java.util.Map;

import com.comtika.safe.entity.equip.terminal.CtkEquipTerminal;

import org.beetl.sql.core.annotatoin.Param;
import org.beetl.sql.core.annotatoin.Sql;
import org.beetl.sql.core.annotatoin.SqlResource;
import org.beetl.sql.core.engine.PageQuery;
import org.beetl.sql.core.mapper.BaseMapper;


@SqlResource("equip.terminal")
public interface EquipTerminalDao extends BaseMapper<CtkEquipTerminal> {

	//根据设备编号或设备id去查找数据库
	List<Long> recheckEquip(@Param("terminalNo") String terminalNo, @Param("serialNo") String serialNo);


	Map<String, Object> queryEquipTerminalById( @Param("terminalId") Long terminalId);

	//设备列表
	PageQuery<Map<String, Object>> findTerminalList(PageQuery<Map<String, Object>> pageQuery);


	@Sql(value = "select t.equip_iccid,t.equip_imei from ctk_equip_terminal t where t.terminal_id = ?")
	Map<String, Object> fadFindTerminalIccId(Integer id);

	// 根据节点编号查询集中器号
	String queryTerminalByNodeNo(@Param("nodeNo")String nodeNo);

	@Sql(value = "update ctk_equip_terminal t set t.equip_iccid = ? where t.terminal_no = ? ")
	void updateTerminalIccId(String iccId, String id);

	@Sql(value = "update ctk_equip_terminal t set t.equip_imei = ? where t.terminal_no = ? ")
	void updateTerminalImei(String imei, String id);
	// 查询在线的设备
	@Sql(value = "select t.terminal_no from ctk_equip_terminal t where t.`status` = 1 ")
	List<String> initTerminalStatus();

	@Deprecated //查询充电的列表
	List<String> findChargingList(Map<String, Object> map);

	@Deprecated // 根据设备编号查询正在充电数据
	List<String> findChargingListByTerminalNo(String termianlNo);

	// 更新设备状态
	@Sql(value = "update ctk_equip_terminal t set t.`status` = ? where t.terminal_no = ?")
	void updateTerminalStatusByTerminalNo(int status, String k);
	// 查询OTA 版本
	@Sql(value = "select t.* from ctk_equip_terminal t where t.terminal_no = ?")
	CtkEquipTerminal findTerminalOtaVersion(String terminalNo);


	Map<String, Object> queryLoopNumberByTerminalNo(Map<String, Object> map);

	// 查询设备列表
    PageQuery<Map<String, Object>> fadFindTerminalList(PageQuery<Map<String, Object>> pageQuery);

    @Sql(value = "select count(1) from ctk_equip_socket s where s.equip_terminal_id = ?")
	int findSocketCount(Long terminalId);


	List<String> querySerialNobySerialNoList(@Param("list") List<String> list);
}
