package com.comtika.safe.dao.message;

import com.comtika.safe.entity.message.FadMessageConf;
import com.comtika.safe.entity.mobile.CommonHelp;
import com.comtika.safe.entity.mobile.EleTotalHelp;
import com.comtika.safe.entity.safe.TerminalNewestData;
import org.beetl.sql.core.annotatoin.Param;
import org.beetl.sql.core.annotatoin.Sql;
import org.beetl.sql.core.annotatoin.SqlResource;
import org.beetl.sql.core.mapper.BaseMapper;

import java.util.List;
import java.util.Map;

@SqlResource("mobile")
public interface FadMessageConfDao extends BaseMapper<FadMessageConf> {
    @Sql(value = "select cs.site_name from ctk_site cs where cs.id = ? limit 1")
    String findSiteName(Integer siteId);

    List<EleTotalHelp> findUserSiteEleTotal(Map<String, Object> condition);

    List<CommonHelp> findSiteList(Map<String, Object> condition);

    List<EleTotalHelp> findTerminalEleTotal(Map<String, Object> condition);

    List<EleTotalHelp> findSocketEleTotal(Map<String, Object> condition);

    List<TerminalNewestData> findTerminalDataTotal(@Param("terminalNo") String terminalNo);

    @Sql(value = "SELECT t.* FROM terminal_newest_data t where t.id = ?")
    TerminalNewestData findTerminalNewDataInfo(Integer id);

    @Sql(value = "select t.terminal_id id,t.terminal_no name from ctk_equip_terminal t where t.site_id = ?")
    List<CommonHelp> findTerminalCommonList(Integer siteId);

    @Sql(value = "select s.id,s.serial_no name from ctk_equip_socket s where s.equip_terminal_id = ?")
    List<CommonHelp> findTerSocketList(Integer terminalId);

    @Sql(value = "select sum(t.start_ele) start_ele,sum(t.end_ele) end_ele,t.create_time from terminal_ele_total t where t.terminal_id = ? and t.create_time >= ? and t.create_time <= ? GROUP BY t.create_time ORDER BY t.create_time")
    List<EleTotalHelp> findTerminalEleTotalList(Integer terminalId, Long startTime, long endTime);
}
