package com.comtika.safe.dao.safe;

import com.comtika.safe.entity.warn.WarnRecord;
import com.comtika.safe.entity.warn.help.WarnHelp;
import com.comtika.safe.entity.warn.help.WarnHomeHelp;
import com.comtika.safe.entity.warn.help.WarnMonthHelp;
import org.beetl.sql.core.annotatoin.Sql;
import org.beetl.sql.core.annotatoin.SqlResource;
import org.beetl.sql.core.engine.PageQuery;
import org.beetl.sql.core.mapper.BaseMapper;

import java.util.List;
import java.util.Map;

/**
 * @Author: miss[494977551@qq.com]
 * @Date: Create in 19:37 2020/8/26
 * @DESC:
 **/
@SqlResource("warn")
public interface IWarnRecordDao extends BaseMapper<WarnRecord> {
    // 这里查询告警
    PageQuery<Map<String, Object>> findWarnPageList(PageQuery<Map<String, Object>> pageQuery);

    List<WarnHelp> findSiteWarnRanking(Map<String, Object> condition);

    List<WarnMonthHelp> findWarnMonthTotal(Map<String, Object> condition);

    List<WarnHomeHelp> findWarnHomeTotal(Map<String, Object> condition);

    int findWarnTotal(Map<String, Object> condition);


    @Sql(value = "select r.*,su.`name` from warn_record r LEFT JOIN sys_user su on r.handle_user_id = su.user_id where r.id = ? limit 1")
    Map<String, Object> findWarnRecordInfo(Integer id);
}
