package com.comtika.safe.dao.task;

import com.comtika.safe.entity.task.TaskTemplate;
import com.comtika.safe.entity.task.TerminalTask;
import org.beetl.sql.core.annotatoin.Sql;
import org.beetl.sql.core.annotatoin.SqlResource;
import org.beetl.sql.core.engine.PageQuery;
import org.beetl.sql.core.mapper.BaseMapper;

import java.util.List;
import java.util.Map;

@SqlResource("task")
public interface TerminalTaskDao extends BaseMapper<TerminalTask> {
    PageQuery<Map<String, Object>> findTaskPageList(PageQuery<Map<String, Object>> pageQuery);


    @Sql(value = "select t.task_number from terminal_task t where t.terminal_no = ? and t.merchant_id = ? ORDER by t.task_number desc limit 1")
    Integer findMaxTaskNumber(String terminalNo,Integer merchantId);

    @Sql(value = "select t.* from terminal_task t where t.delete_status = 1 and t.terminal_no = ? and t.merchant_id = ? limit 1")
    TerminalTask findDeleteData(String terminalNo, Integer merchantId);

    PageQuery<Map<String, Object>> findTaskTemplateList(PageQuery<Map<String, Object>> pageQuery);

    List<TaskTemplate> findTaskTemplateListByTemplateName(Map<String, Object> condition);
}
