package com.comtika.safe.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

import com.comtika.safe.common.model.BaseModel;

import lombok.Getter;
import lombok.Setter;

/**
 * @version V1.0
 * @ClassName: SysOrgMerchant
 * @Description:组织架构-机构 （商户）
 */
@Getter
@Setter
@Entity
public class SysOrgMerchant extends BaseModel {
    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "id")
    private Long id;

    private Long orgId;// 组织架构节点id--预留

    private String orgName;// 组织架构名称

    private String orgCode;// 组织架构编号 --UUID

    private String orgFullPath;// 组织架构全路径 /分割

    private Integer status;// 状态 1启用，2停用

    private Long createrId;// 创建人

    private Long lastUpdateTime;// 最后更新时间

    private Long parentId;// 上级id

    private Long appId;// 该商户所使用的小程序id  外键，对应pub_app_config表主键

    private Integer orgType;//节点类型：0-根节点，1-机构，2-站点，3-职位, 不能使用8，8代指人员

}
