package com.comtika.safe.entity.task;

import com.alibaba.fastjson.JSONObject;
import com.comtika.safe.entity.task.help.TaskHelp;
import com.comtika.safe.entity.task.help.TaskTemplateHelp;
import lombok.Data;
import org.beetl.sql.core.annotatoin.AutoID;


/**
 * 定时任务模版
 */
@Data
public class TaskTemplate {
    @AutoID
    private Integer id;
    private String name;//模版名称
    private String remarks;//备注
    private Long startTime;//模版执行开始时间
    private Long endTime;//模版执行结束时间
    private Integer taskModel;//任务模式  02H 每天执行；03H 每周执行；04H 单次执行；
    private String taskTime;//任务时间
    private Integer weekTime;//星期
    private String bit;//回路数
    private Integer content; // 1 开  2关
    private Long createTime;//创建时间
    private Integer merchantId;//所属商户
    private Integer terminalType;//模版所属设备类型
    private Integer userId;// 用户id

    public void fadHandleData(TaskTemplateHelp help) {
        startTime = help.getStartTime();
        endTime = help.getEndTime();
        taskModel = help.getTaskModel();
        taskTime = help.getTaskTime();
        weekTime = help.getWeekTime();
        bit = JSONObject.toJSONString(help.getBitList());
        content = help.getContent();
        name = help.getName();
        remarks = help.getRemarks();
        terminalType = help.getTerminalType();
    }
    public TaskTemplateHelp convertToTaskHelp(){
        TaskTemplateHelp help = new TaskTemplateHelp();
        help.setContent(content);
        help.setEndTime(endTime);
        help.setStartTime(startTime);
        help.setTaskModel(taskModel);
        help.setWeekTime(weekTime);
        help.setBitList(JSONObject.parseArray(bit,Integer.class));
        help.setId(id);
        help.setTaskTime(taskTime);
        help.setName(name);
        help.setTerminalType(terminalType);
        help.setRemarks(remarks);
        return help;
    }
    public TaskHelp convertTask(){
        TaskHelp help = new TaskHelp();
        help.setBitList(JSONObject.parseArray(bit,Integer.class));
        help.setContent(content);
        help.setEndTime(endTime);
        help.setStatus(0);
        help.setStartTime(startTime);
        help.setTaskModel(taskModel);
        help.setTaskTime(taskTime);
        help.setWeekTime(weekTime);
        return help;
    }
}
