package com.comtika.safe.entity.task;

import com.alibaba.fastjson.JSONObject;
import com.comtika.safe.entity.task.help.TaskHelp;
import lombok.Data;
import org.beetl.sql.core.annotatoin.AutoID;

@Data
public class TerminalTask {
    @AutoID
    private Integer id;
    private Integer merchantId;
    private Integer siteId;
    private String terminalNo;
    private Integer taskNumber;// 1-250
    private Long startTime;
    private Long endTime;
    private Long updateTime;
    private Integer status;//状态 下方状态
    private Boolean deleteStatus;//删除状态
    private Integer taskModel;//任务模式  02H 每天执行；03H 每周执行；04H 单次执行；
    private String taskTime;//任务时间
    private Integer weekTime;//星期
    private String bit;//回路数
    private Integer content; // 1 开  2关

    public void fadHandleData(TaskHelp help) {
        terminalNo = help.getTerminalNo();
        startTime = help.getStartTime();
        endTime = help.getEndTime();
        updateTime = System.currentTimeMillis();
       // status = 0;
        deleteStatus = false;
        taskModel = help.getTaskModel();
        taskTime = help.getTaskTime();
        weekTime = help.getWeekTime();
        bit = JSONObject.toJSONString(help.getBitList());
        content = help.getContent();
    }
    public TaskHelp convertToTaskHelp(){
        TaskHelp help = new TaskHelp();
        help.setContent(content);
        help.setEndTime(endTime);
        help.setStartTime(startTime);
        help.setStatus(status);
        help.setTaskModel(taskModel);
        help.setTerminalNo(terminalNo);
        help.setWeekTime(weekTime);
        help.setBitList(JSONObject.parseArray(bit,Integer.class));
        help.setId(id);
        help.setTaskTime(taskTime);
        return help;
    }
}
