package com.comtika.safe.entity.task.help;

import com.comtika.safe.common.response.RespWrapper;
import com.comtika.safe.common.utils.StringUtil;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;

@Data
public class TaskHelp {
    private Integer id;//只有更新时
    private String terminalNo;//编号
    private Long startTime;//开始时间 13位时间戳
    private Long endTime;//结束时间 13位时间戳
    private Integer status;//状态 定时任务状态  -1 下发失败 0 未下发  1 下发成功
    private Integer taskModel;//任务模式   02H 每天执行；03H 每周执行；04H 单次执行
    private String taskTime;// 任务时间 譬如 08:60
    private Integer weekTime;// 星期 周任务执行星期：（0~6 对应星期日~星期六）
    private List<Integer> bitList = new ArrayList<>();//回路数 [1,2,3]
    private Integer content; // 1 开  2关

    public RespWrapper<Boolean> check(){
        if(StringUtil.isEmpty(terminalNo))
            return RespWrapper.makeFailResp("设备编号不能为空");
        if(startTime == null)
            return RespWrapper.makeFailResp("执行开始时间不能为空");
        if(endTime == null)
            return RespWrapper.makeFailResp("执行结束时间不能为空");
        if(taskModel == null)
            return RespWrapper.makeFailResp("定时任务模式不能为空");
        if(StringUtil.isEmpty(taskTime))
            return RespWrapper.makeFailResp("执行时间不能为空");
        if(content == null)
            return RespWrapper.makeFailResp("执行任务不能为空");
        if(taskModel == 3 && weekTime == null)
            return RespWrapper.makeFailResp("每周执行时，星期不能为空");
        if(taskModel != 3) weekTime = 0;
        return RespWrapper.makeSuccessResp(true);
    }
}
