package com.comtika.safe.entity.task.help;

import com.comtika.safe.common.response.RespWrapper;
import com.comtika.safe.common.utils.StringUtil;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;

@Data
public class TaskTemplateHelp {
    private Integer id;//只有更新时
    private Long startTime;//开始时间 13位时间戳
    private Long endTime;//结束时间 13位时间戳
    private Integer taskModel;//任务模式   02H 每天执行；03H 每周执行；04H 单次执行
    private String taskTime;// 任务时间 譬如 08:60
    private Integer weekTime;// 星期 周任务执行星期：（0~6 对应星期日~星期六）
    private List<Integer> bitList = new ArrayList<>();//回路数 [1,2,3]
    private Integer content; // 1 开  2关
    private String name;//名称
    private String remarks;//描述
    private Integer terminalType = 0;//设备类型-- 这个设备类型

    public RespWrapper<Boolean> check(){
        if(startTime == null)
            return RespWrapper.makeFailResp("执行开始时间不能为空");
        if(endTime == null)
            return RespWrapper.makeFailResp("执行结束时间不能为空");
        if(taskModel == null)
            return RespWrapper.makeFailResp("定时任务模式不能为空");
        if(StringUtil.isEmpty(taskTime))
            return RespWrapper.makeFailResp("执行时间不能为空");
        if(content == null)
            return RespWrapper.makeFailResp("执行任务不能为空");
        if(taskModel == 3 && weekTime == null)
            return RespWrapper.makeFailResp("每周执行时，星期不能为空");
        if(taskModel != 3) weekTime = 0;
        /*if(terminalType == null) return RespWrapper.makeFailResp("定时任务所属设备类型不能为空");*/
        if(StringUtil.isEmpty(name))return RespWrapper.makeFailResp("定时任务名称不能为空");
        return RespWrapper.makeSuccessResp(true);
    }
}
