package com.comtika.safe.service;

import java.io.Serializable;
import java.util.List;

import org.beetl.sql.core.engine.PageQuery;

/**
 * 基于beetlSQL的基类接口
 */
@SuppressWarnings({"hiding"})
public interface BaseService<T> {
    public void saveByHiber(T entity);

    public <T> T getByIdHiber(final Serializable id);

    public <T> T getByIdUniqueHiber(Serializable id);

    public void updateByHiber(T entity);

    public void updateTemplateById(T entity);

    public void deleteById(Serializable id);

    public List<T> listAll(int start, int size);

    public List<T> listAll();

    public PageQuery<T> pageQueryList(String sqlId, PageQuery<T> query, Class<T> clazz);

    public <T> T findByHiber(T entity);

    public List<T> listByHiber(T entity);

    /**
     * 批量新增实体
     *
     * @param clazz
     * @param list
     */
    public void insertBatch(Class clazz, List<T> list);

    /**
     * 批量修改实体
     *
     * @param clazz
     * @param list
     */
    public void updateBatchTemplateById(Class clazz, List<T> list);
}
