package com.comtika.safe.service.equip.product.impl;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.comtika.safe.common.response.RespWrapper;
import com.comtika.safe.dao.equip.product.ProductDao;
import com.comtika.safe.entity.equip.product.CtkProductType;
import com.comtika.safe.service.equip.product.ProductService;

@Service
public class ProductServiceImpl implements ProductService {
	
	@Autowired
	private ProductDao productDao;
	
	
	@Override
	public RespWrapper<Object> addProduct(CtkProductType ctkProductType) {
		try {
			productDao.insert(ctkProductType,true);
			if(ctkProductType.getId() != null)return RespWrapper.makeSuccessResp("新增成功！");
		} catch (Exception e) {
			e.printStackTrace();
			return RespWrapper.makeErrorResp("服务器错误，新增失败！");
		}
		return RespWrapper.makeFailResp("新增失败！");
	}


	@Override
	public RespWrapper<Object> queryList() {
		try {
			return RespWrapper.makeSuccessResp(productDao.queryList());
		} catch (Exception e) {
			e.printStackTrace();
			return RespWrapper.makeErrorResp("服务器错误，新增失败！");
		}
		
	}


	@Override
	public RespWrapper<Object> update(CtkProductType ctkProductType) {
		try {
			if(ctkProductType.getId() == null ){
				return RespWrapper.makeFailResp("参数有误，请检查！");
			}
			CtkProductType data = new CtkProductType();
			data.setId(ctkProductType.getId());
			data.setProductName(ctkProductType.getProductName());
			int num = productDao.updateTemplateById(data);
			if(num == 1)return RespWrapper.makeSuccessResp("修改成功！");
		} catch (Exception e) {
			e.printStackTrace();
			return RespWrapper.makeErrorResp("服务器错误，修改失败！");
		}
		return RespWrapper.makeFailResp("修改失败！");
	}

}
