package com.comtika.safe.service.merchant.impl;

import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.comtika.safe.common.utils.JXLUtil;
import com.comtika.safe.entity.metchant.help.MerchantExcelHelp;
import com.comtika.safe.service.site.impl.SiteServiceImpl;
import com.comtika.safe.service.warn.impl.WarnServiceImpl;

import org.beetl.sql.core.engine.PageQuery;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.comtika.safe.common.constant.ProjectConstant;
import com.comtika.safe.common.enums.RegistSourceEnum;
import com.comtika.safe.common.enums.SysOperateEnum;
import com.comtika.safe.common.enums.api.ApiErrorType;
import com.comtika.safe.common.enums.merchant.CooperatStatusEnum;
import com.comtika.safe.common.enums.sysuserdata.SysUserDataEnum;
import com.comtika.safe.common.enums.user.UserStatusEnum;
import com.comtika.safe.common.enums.user.UserTypeEnum;
import com.comtika.safe.common.response.RespWrapper;
import com.comtika.safe.common.utils.StringUtil;
import com.comtika.safe.common.utils.encrypt.MD5Coding;
import com.comtika.safe.config.ProjectConfig;
import com.comtika.safe.core.UserCoreCache;
import com.comtika.safe.core.lucene.LuceneUtils;
import com.comtika.safe.dao.mserchant.CtkMerchantDao;
import com.comtika.safe.dao.site.SiteDao;
import com.comtika.safe.dao.sys.UserRoleDao;
import com.comtika.safe.dao.sys.data.SysUserDataDao;
import com.comtika.safe.dao.sys.role.RoleDao;
import com.comtika.safe.dao.sys.user.UserDao;
import com.comtika.safe.entity.SysRoleUser;
import com.comtika.safe.entity.SysUser;
import com.comtika.safe.entity.data.SysUserData;
import com.comtika.safe.entity.metchant.CtkMerchant;
import com.comtika.safe.entity.metchant.EnableMerchant;
import com.comtika.safe.entity.metchant.RegisterMerchant;
import com.comtika.safe.entity.role.SysRole;
import com.comtika.safe.service.merchant.MerchantService;
import com.comtika.safe.service.sys.user.UserService;

@Service
public class MerchantServiceImpl implements MerchantService{

	/*@Autowired
	private UserService userService;*/

	@Autowired
	private CtkMerchantDao ctkMerchantDao;

	@Autowired
    private UserDao userDao;

	@Autowired
    private SysUserDataDao sysUserDataDao;

	@Autowired
	private SiteDao siteDao;

	@Autowired
	private ProjectConfig projectConfig;

	@Autowired
	private RoleDao roleDao;

	@Autowired
	private UserRoleDao userRoleDao;


	@Override
	public RespWrapper<Object> addMerchant(RegisterMerchant registerMerchant,UserCoreCache userCoreCache
			,HttpServletRequest request) {
		try {
			//1.新增商户
			CtkMerchant ctkMerchant = new CtkMerchant();
			registerMerchant.upCtkMerchant(ctkMerchant);//数据库实体类对象赋值
			ctkMerchantDao.insertTemplate(ctkMerchant, true);
			//2.新增商户用户
			SysUser sysUser = new SysUser();
			addMerchantUser(sysUser,registerMerchant,userCoreCache,ctkMerchant.getMerchantId());
			userDao.insertTemplate(sysUser, true);
			//3.修改商户管理员id
			CtkMerchant ctkMerchant1 = new CtkMerchant();
			ctkMerchant1.setMerchantId(ctkMerchant.getMerchantId());
			ctkMerchant1.setManagerId(sysUser.getUserId());
			int num = ctkMerchantDao.updateTemplateById(ctkMerchant1);
			if(num != 1) return RespWrapper.makeFailResp("新增商户失败！");
			//4.查询商户管理员角色,将商户管理员添加至数据权限中
			SysRole merchantSysRole = new SysRole();
			merchantSysRole.setRoleName(projectConfig.getMerchantRole());
			merchantSysRole = roleDao.templateOne(merchantSysRole);
			SysUserData data = new SysUserData();
			data.setUserId(sysUser.getUserId());
			data.setDataId(ctkMerchant.getMerchantId());
			data.setDataType(SysUserDataEnum.MERCHANT.getUserType());
			data.setRoleId(merchantSysRole.getId());
			sysUserDataDao.insert(data);
			//将该商户管理员加进角色中
			SysRoleUser sysRoleUser = new SysRoleUser();
			sysRoleUser.setRoleId(merchantSysRole.getId());
			sysRoleUser.setUserId(sysUser.getUserId());
			userRoleDao.insert(sysRoleUser);
			//5将市场专员添加至数据权限中
			SysRole meSysRole = new SysRole();
			meSysRole.setRoleName(projectConfig.getMarketRole());
			meSysRole = roleDao.templateOne(meSysRole);
			SysUserData data1 = new SysUserData();
			data1.setUserId(registerMerchant.getMarketerId());
			data1.setDataId(ctkMerchant.getMerchantId());
			data1.setDataType(SysUserDataEnum.MERCHANT.getUserType());
			data1.setRoleId(meSysRole.getId());
			sysUserDataDao.insert(data1);
		} catch (Exception e) {
			e.printStackTrace();
			//写进异常日志
            LuceneUtils.apiErrorLucene(ApiErrorType.merchant.getType(), request, "新增商户", e.getMessage());
			return RespWrapper.makeErrorResp("服务器错误！");
		}
		return RespWrapper.makeSuccessResp("新增商户成功！");
	}



	private void addMerchantUser(SysUser sysUser,RegisterMerchant registerMerchant,UserCoreCache userCoreCache,Long merchantId) {
		sysUser.setMerchantId(merchantId);
		sysUser.setUserType(UserTypeEnum.MERCHANT_USER.getId());
		sysUser.setLoginName(registerMerchant.getPhoneNo());
		String md5TruePwd = MD5Coding.encodeAddSaltCustom(registerMerchant.getPhoneNo(), MD5Coding.MD5SALT);//将密码md5加密
		sysUser.setPassword(md5TruePwd);
		sysUser.setUserName(registerMerchant.getManagerName());
		sysUser.setStatus(UserStatusEnum.AUDIT.getId());
		sysUser.setName(registerMerchant.getManagerName());
		sysUser.setRegistTime(System.currentTimeMillis());
		sysUser.setEmail(registerMerchant.getEmail());
		sysUser.setPhoneNo(registerMerchant.getPhoneNo());
		sysUser.setRegistSource(RegistSourceEnum.ADD.getId());

	}



	@Override
	public RespWrapper<Object> getMarketUsers(String roleName,HttpServletRequest request) {
		 try {
			 if(StringUtil.isEmpty(roleName)){
				 roleName = projectConfig.getMarketRole();
			 }
			 Map<String,Object> map = new HashMap<String, Object>();
			 map.put("roleName", roleName);
			 List<Map<String,Object>> list = ctkMerchantDao.getMarketUsers(map);
		     return RespWrapper.makeSuccessResp(list);
		} catch (Exception e) {
			e.printStackTrace();
			//写进异常日志
            LuceneUtils.apiErrorLucene(ApiErrorType.merchant.getType(), request, "获取市场专员列表", e.getMessage());
			return RespWrapper.makeErrorResp("服务器错误！");
		}
	}



	@Override
	public RespWrapper<Object> queryMerchantList(String merchantAbbr,Integer cooperatStatus, PageQuery<Map<String, Object>> pageQuery,HttpServletRequest request) {
		try {
			pageQuery.setPara("merchantAbbr", merchantAbbr);
			pageQuery.setPara("cooperatStatus", cooperatStatus);
			return RespWrapper.makeSuccessResp(ctkMerchantDao.queryMerchantList(pageQuery));
		} catch (Exception e) {
			e.printStackTrace();
			//写进异常日志
            LuceneUtils.apiErrorLucene(ApiErrorType.merchant.getType(), request, "商户列表", e.getMessage());
			return RespWrapper.makeErrorResp("服务器错误！");
		}
	}



	@Override
	public RespWrapper<Object> merchantDetail(Long merchantId, Boolean userFlag,HttpServletRequest request) {
		try {

            if( null == merchantId)return RespWrapper.makeFailResp("商户id不能为空！");
            Map<String,Object> map = new HashMap<String, Object>();
            map.put("merchantId", merchantId);
            Map<String,Object> detail = ctkMerchantDao.queryMerchantDetail(map);
            if( null == detail || null == detail.get("merchantId")) return RespWrapper.makeFailResp("商户不存在，请检查！");
            if(userFlag == null || userFlag) {
                //查出商户下人员列表，用于管理员选择
                List<Map<String,Object>> userList = userDao.getUsersByMerchantId(map);
                detail.put("userList", userList);
            }
            return RespWrapper.makeSuccessResp(detail);
        } catch (Exception e) {
        	e.printStackTrace();
        	//写进异常日志
            LuceneUtils.apiErrorLucene(ApiErrorType.merchant.getType(), request, "获取商户详情", e.getMessage());
            return RespWrapper.makeErrorResp("查询失败：" + e.getMessage());
        }
	}



	@Override
	public RespWrapper<Object> updateMerchant(RegisterMerchant merchant,HttpServletRequest request) {
		try {
			//1.查询原有的商户信息，判断市场专员和商户管理员是否发生变化
			CtkMerchant ctkMerchant = new CtkMerchant();
			ctkMerchant.setMerchantId(merchant.getMerchantId());
			ctkMerchant = ctkMerchantDao.templateOne(ctkMerchant);
			if(  null == ctkMerchant ) return RespWrapper.makeFailResp("商户id不存在，请检查！");
			System.out.println(ctkMerchant.toString());
			//修改商户数据权限 -- 如果商户管理员或者市场专员发生变化，就会修改数据权限
			updateSysMerchantData(merchant,ctkMerchant);
			//将前端传过来的值赋值进数据库实体对象
			merchant.upCtkMerchant(ctkMerchant);
			ctkMerchantDao.updateTemplateById(ctkMerchant);
            return RespWrapper.makeSuccessResp(merchant.getMerchantName());
        } catch (Exception e) {
        	e.printStackTrace();
        	//写进异常日志
            LuceneUtils.apiErrorLucene(ApiErrorType.merchant.getType(), request, "修改商户", e.getMessage());
            return RespWrapper.makeErrorResp("修改失败：");
        }
	}



	private void updateSysMerchantData(RegisterMerchant merchant,CtkMerchant ctkMerchant) {
		Set<Long> siteIdSet = new HashSet<Long>();;
		//如果商户管理员或者市场专员发送变化，先查询商户下的所有站点
		if((null != merchant.getManagerId() && !(merchant.getManagerId().equals(ctkMerchant.getManagerId())))
				||
		  (null != merchant.getMarketerId() && !(merchant.getMarketerId().equals(ctkMerchant.getMarketerId())))){
			Map<String,Object> map = new HashMap<String, Object>();
			map.put("merchantId", ctkMerchant.getMerchantId());
			List<Map<String,Object>> list = siteDao.querySetSiteIdbyMrchantId(map);
			if(null != list && !list.isEmpty() && list.size() > 0  ){
				for (Map<String, Object> map2 : list) {
					System.out.println(map2.get("siteId"));
					siteIdSet.add(Long.parseLong("" + map2.get("siteId")));
				}
			}
		}
		//1.判断商户管理员是否发生变化
		if( null != merchant.getManagerId() && !(merchant.getManagerId().equals(ctkMerchant.getManagerId())) ){
			Map<String,Object> map = new HashMap<String, Object>();
			//这个是商户管理员发生变化，则需要修改数据权限
			//如果商户管理员发送了变化，需要将数据权限改为现在的商户管理员
			Set<Long> merchantSet = new HashSet<Long>();
			merchantSet.add(ctkMerchant.getMerchantId());
			map.put("originalUserId", ctkMerchant.getManagerId());//原来商户管理员的用户id
			map.put("dataId", merchantSet);//商户id
			map.put("nowUserId", merchant.getManagerId());//现在商户管理员的用户id
			map.put("dataType", SysUserDataEnum.MERCHANT.getUserType());//商户类型
			sysUserDataDao.updateMerchantOrSiteData(map);
			//修改站点的数据权限
			if(null != siteIdSet && !siteIdSet.isEmpty() && siteIdSet.size() > 0 ){
				map.clear();
				map.put("originalUserId", ctkMerchant.getManagerId());//原来商户管理员的用户id
				map.put("dataId", siteIdSet);//站点id的set集合
				map.put("nowUserId", merchant.getManagerId());//现在商户管理员的用户id
				map.put("dataType", SysUserDataEnum.SITE.getUserType());//站点类型
				sysUserDataDao.updateMerchantOrSiteData(map);
			}
		}
		//2.判断市场专员是否发生变化
		if( null != merchant.getMarketerId() && !(merchant.getMarketerId().equals(ctkMerchant.getMarketerId())) ){
			Map<String,Object> map = new HashMap<String, Object>();
			//这个是市场专员发生变化，则需要修改数据权限
			Set<Long> merchantSet = new HashSet<Long>();
			merchantSet.add(ctkMerchant.getMerchantId());
			map.put("originalUserId", ctkMerchant.getMarketerId());//原来市场专员的用户id
			map.put("dataId", merchantSet);//商户id
			map.put("nowUserId", merchant.getMarketerId());//现在市场专员的用户id
			map.put("dataType", SysUserDataEnum.MERCHANT.getUserType());//站点类型
			sysUserDataDao.updateMerchantOrSiteData(map);
			//修改站点的数据权限
			if(null != siteIdSet && !siteIdSet.isEmpty() && siteIdSet.size() > 0 ){
				map.clear();
				map.put("originalUserId", ctkMerchant.getMarketerId());//原来市场专员的用户id
				map.put("dataId", siteIdSet);//站点id的set集合
				map.put("nowUserId", merchant.getMarketerId());//现在市场专员的用户id
				map.put("dataType", SysUserDataEnum.SITE.getUserType());//站点类型
				sysUserDataDao.updateMerchantOrSiteData(map);
			}
		}
	}



	@Override
	public RespWrapper<Object> enableMerchant(EnableMerchant enableMerchant,HttpServletRequest request) {
		try {
			if( null == enableMerchant.getMerchantId() || null == enableMerchant.getStatus()){
				return RespWrapper.makeFailResp("参数有误，请检查！");
			}
			CtkMerchant detail = new CtkMerchant();
	        detail.setMerchantId(enableMerchant.getMerchantId());
	        int protocolStatus = 0;
	        Integer status = enableMerchant.getStatus();
	        if(enableMerchant.getStatus() == SysOperateEnum.PASS.getId()) {
	            protocolStatus = CooperatStatusEnum.COOPERATION.getId();
	        }else if(status == SysOperateEnum.NO_PASS.getId()) {
	            protocolStatus = CooperatStatusEnum.NO_PASS.getId();
	        }else if(status == SysOperateEnum.START_COOPERATION.getId()) {
	            protocolStatus = CooperatStatusEnum.IN_COOPERATION.getId();
	        }else if(status == SysOperateEnum.END_COOPERATION.getId()) {
	            protocolStatus = CooperatStatusEnum.END_COOPERATION.getId();
	        }
	        String msg = "商户【" + SysOperateEnum.getEnumById(protocolStatus).getValue() + "】";
	        detail.setCooperatStatus(protocolStatus);
	        ctkMerchantDao.updateTemplateById(detail);
	        return RespWrapper.makeSuccessResp(msg);
		} catch (Exception e) {
			e.printStackTrace();
			//写进异常日志
            LuceneUtils.apiErrorLucene(ApiErrorType.merchant.getType(), request, "启用/停用/审核商户", e.getMessage());
			return RespWrapper.makeErrorResp("服务器错误！");
		}

	}



	@Override
	public RespWrapper<Object> queryMerchantAbbrList(UserCoreCache userCoreCache,HttpServletRequest request) {
		try {
			Map<String,Object> map = new HashMap<String, Object>();
			if (userCoreCache != null&& !ProjectConstant.ADMIN.equals(userCoreCache.getLoginName())) {
				map.put("merchantData", userCoreCache.getMerchantData());
			}
			List<Map<String,Object>> list = ctkMerchantDao.queryMerchantAbbrList(map);
			return RespWrapper.makeSuccessResp(list);
		} catch (Exception e) {
			e.printStackTrace();
			//写进异常日志
            LuceneUtils.apiErrorLucene(ApiErrorType.merchant.getType(), request, "获取所有商户（商户id，商户全称，商户简称）", e.getMessage());
			return RespWrapper.makeErrorResp("服务器错误！");
		}

	}

	@Override
	public RespWrapper fadFindMerchantList(MerchantExcelHelp help, UserCoreCache userCache) {
		return RespWrapper.makeSuccessResp(doFindMerchantList(help,userCache,false));
	}

	@Override
	public RespWrapper merchantExcel(MerchantExcelHelp help, UserCoreCache userCache, HttpServletResponse response) {
		PageQuery<Map<String, Object>> pageQuery = doFindMerchantList(help, userCache, false);
		List<String> columnList = new ArrayList<>();
		List<String> excelList = new ArrayList<>();
		addTerminalExcel(columnList,excelList);
		List<Map<String, Object>> list = pageQuery.getList();
		list.forEach(s->{
			// 站点状态、以及区域
			handleMerchantStatus(s,"cooperatStatus");
			handleMerchantType(s,"merchantType");
			SiteServiceImpl.handleArea(s,"area");
		});
		String fileName = "商户列表导出";
		try {
			JXLUtil.execlWrite(list,excelList,columnList,fileName,response,fileName);
		}catch (Exception e){
			return RespWrapper.makeFailResp("导出实时数据错误");
		}
		return null;
	}

	private void handleMerchantType(Map<String, Object> s, String key) {
		Object o = s.get(key);
		if(o != null){
			Integer integer = Integer.valueOf(o.toString());
			if(integer == 1) s.put(key,"企业");
			else if(integer == 2) s.put(key,"个体工商户");
			else s.put(key,"个人");
		}
	}

	private void handleMerchantStatus(Map<String, Object> s, String key) {
		Object o = s.get(key);
		if(o != null){
			Integer integer = Integer.valueOf(o.toString());
			switch (integer){
				case -1: s.put(key,"审核未通过");break;
				case 0: s.put(key,"待审核");break;
				case 1: s.put(key,"待合作");break;
				case 2: s.put(key,"合作中");break;
				case 3: s.put(key,"合作已结束");break;
				default: s.put(key,"待审核");
			}

		}
	}

	private PageQuery<Map<String,Object>> doFindMerchantList(MerchantExcelHelp help, UserCoreCache userCache,boolean isExcel){
		Map<String,Object> condition = new HashMap<>(4);
		if(!ProjectConstant.ADMIN.equals(userCache.getLoginName())){
			condition.put("merchantIds",userCache.getMerchantData());
		}
		if(help.getStatus() != null) condition.put("status",help.getStatus());
		if(StringUtil.isNotEmpty(help.getMerchantName())) condition.put("merchantName",help.getMerchantName());
		PageQuery<Map<String,Object>> pageQuery = new PageQuery<>();
		pageQuery.setParas(condition);
		if(isExcel){
			pageQuery.setPageNumber(1);
			pageQuery.setPageSize(WarnServiceImpl.excelMaxNum);
		}else {
			pageQuery.setPageNumber(help.getPageNum());
			pageQuery.setPageSize(help.getPageSize());
		}
		pageQuery.setOrderBy("t.merchant_id desc");
		pageQuery = ctkMerchantDao.fadFindMerchantList(pageQuery);
		return pageQuery;
	}
	private void addTerminalExcel(List<String> columnList,List<String> excelList){
		columnList.add(JXLUtil.SERIAL_NO);
		excelList.add("序号");
		columnList.add("merchantAbbr");
		excelList.add("商户简称");

		columnList.add("merchantType");
		excelList.add("商户类型");

		columnList.add("cooperatStatus");
		excelList.add("合作状态");
		columnList.add("managerName");
		excelList.add("管理员");
		columnList.add("phoneNo");
		excelList.add("管理员手机号");
		columnList.add("marketerName");
		excelList.add("服务专员");

		columnList.add("merchantName");
		excelList.add("商户名称");

		columnList.add("address");
		excelList.add("详细地址");

		columnList.add("area");
		excelList.add("所属区域");

		columnList.add("email");
		excelList.add("邮箱");
		columnList.add("merchantTitle");
		excelList.add("商户Title");
		columnList.add("merchantLogo");
		excelList.add("商户Logo");
	}



	@Override
	public RespWrapper<Object> updateMerchantLogoAndTitle(Long merchantId,String merchantLogo, String merchantTitle,HttpServletRequest request) {
		try {
			if(null == merchantId)return RespWrapper.makeFailResp("商户id不能为空！");
			CtkMerchant ctkMerchant = new CtkMerchant();
			ctkMerchant.setMerchantId(merchantId);
			ctkMerchant.setMerchantLogo(merchantLogo);
			ctkMerchant.setMerchantTitle(merchantTitle);
			int num = ctkMerchantDao.updateTemplateById(ctkMerchant);
			if( num == 1) return RespWrapper.makeSuccessResp("修改成功！");
		} catch (Exception e) {
			e.printStackTrace();
			//写进异常日志
            LuceneUtils.apiErrorLucene(ApiErrorType.merchant.getType(), request, "修改商户logo与title", e.getMessage());
			return RespWrapper.makeErrorResp("服务器错误，修改失败！");
		}
		return RespWrapper.makeFailResp("修改失败，请联系管理员！");
	}



	@Override
	public RespWrapper<Object> queryMerchantLogoAndTitle(Long merchantId,HttpServletRequest request) {
		try {
			Map<String,Object> map = new HashMap<String, Object>();
			map.put("merchantId", merchantId);
			map = ctkMerchantDao.queryMerchantLogoAndTitle(map);
			return RespWrapper.makeSuccessResp(map);
		} catch (Exception e) {
			e.printStackTrace();
			//写进异常日志
            LuceneUtils.apiErrorLucene(ApiErrorType.merchant.getType(), request, "查询商户logo与title", e.getMessage());
			return RespWrapper.makeErrorResp("服务器错误，修改失败！");
		}
	}


}
