package com.comtika.safe.service.meter.impl;

import com.comtika.safe.common.response.RespWrapper;
import com.comtika.safe.dao.meter.WattMeterDao;
import com.comtika.safe.entity.meter.CtkWattMeter;
import com.comtika.safe.service.meter.IMeterService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class MeterServiceImpl implements IMeterService {

    @Autowired
    private WattMeterDao wattMeterDao;
    @Override
    public RespWrapper<List<CtkWattMeter>> findWattMeterList(Integer siteId) {
        CtkWattMeter wattMeter = new CtkWattMeter();
        wattMeter.setSiteId(siteId);
        return RespWrapper.makeSuccessResp(wattMeterDao.template(wattMeter));
    }

    @Override
    public RespWrapper<Boolean> addWattMeter(CtkWattMeter ctkWattMeter) {
        CtkWattMeter wattMeter = new CtkWattMeter();
        wattMeter.setSiteId(ctkWattMeter.getSiteId());
        wattMeter.setTerminalNo(ctkWattMeter.getTerminalNo());
        if(wattMeterDao.templateCount(wattMeter) > 0)
            return RespWrapper.makeFailResp("该站点下已经存在该设备编码的电表");
        wattMeter.setRemarks(ctkWattMeter.getRemarks());
        wattMeterDao.insert(wattMeter);
        return RespWrapper.makeSuccessResp(true);
    }

    @Override
    public RespWrapper<Boolean> updateWattMeter(CtkWattMeter ctkWattMeter) {
        CtkWattMeter single = wattMeterDao.single(ctkWattMeter.getId());
        if(single == null)
            return RespWrapper.makeFailResp("该设备下的电表唯一id 错误");
        single.setTerminalNo(ctkWattMeter.getTerminalNo());
        single.setRemarks(ctkWattMeter.getRemarks());
        wattMeterDao.updateTemplateById(single);
        return RespWrapper.makeSuccessResp(true);
    }

    @Override
    public RespWrapper<List<String>> findSiteAllTerminalNo(Integer siteId) {
        List<String> list = wattMeterDao.findSiteAllTerminalNo(siteId);
        return RespWrapper.makeSuccessResp(list);
    }

    @Override
    public RespWrapper<Boolean> deleteWattMeter(Integer id) {
        if(id == null) return RespWrapper.makeFailResp("电表记录唯一id 不能为空");
        int i = wattMeterDao.deleteById(id);
        if(i > 0)return RespWrapper.makeSuccessResp(true);
        return RespWrapper.makeFailResp("未知原因失败");
    }
}
