recheckEquip
===
SELECT 
  terminal_id 
FROM
  ctk_equip_terminal 
WHERE terminal_no = #terminalNo#
OR serial_no = #serialNo#


findTerminalList
===
SELECT 
  #page(" cet.*,cs.site_name,cpt.product_name,ces.socket_num ")# 
FROM
  ctk_equip_terminal cet 
  LEFT JOIN ctk_site cs 
    ON cs.site_id = cet.site_id 
  LEFT JOIN ctk_product_type cpt 
    ON cet.equip_product_type_id = cpt.id
  LEFT JOIN (SELECT COUNT(1) AS socket_num , equip_terminal_id FROM ctk_equip_socket GROUP BY equip_terminal_id) ces 
    ON ces.equip_terminal_id = cet.terminal_id 
WHERE 1 = 1
@if(!isEmpty(siteData)){
	AND cet.site_id in (#join(siteData)#) 
@}
@if(!isEmpty(siteId)){
	AND cet.site_id = #siteId#
@}
@if(!isEmpty(siteName)){
	and cs.site_name LIKE #'%'+siteName+'%'# 
@}
@if(!isEmpty(equipIccid)){
	and cet.equip_iccid like #'%'+equipIccid+'%'#
@}
@if(!isEmpty(equipImei)){
	and cet.equip_imei like #'%'+equipImei+'%'#
@}
@if(!isEmpty(terminalNo)){
	AND cet.terminal_no like #'%'+terminalNo+'%'# 
@}
@if(!isEmpty(status)){
	AND cet.status = #status# 
@}
@if(!isEmpty(equipProductTypeId)){
	AND cet.equip_product_type_id = #equipProductTypeId# 
@}

queryEquipTerminalById
===
SELECT 
  cet.*,cs.site_name,cpt.product_name  
FROM
  ctk_equip_terminal cet 
  LEFT JOIN ctk_site cs 
    ON cs.site_id = cet.site_id 
  LEFT JOIN ctk_product_type cpt 
    ON cet.equip_product_type_id = cpt.id 
WHERE 1 = 1
@if(!isEmpty(terminalId)){
	AND cet.terminal_id = #terminalId# 
@}

queryTerminalByNodeNo
===
* 根据节点编号获取集中器编号
SELECT t.terminal_no FROM `ctk_equip_terminal` t,`ctk_equip_node` s WHERE t.merchant_id = s.equip_terminal_id
@if(!isEmpty(nodeNo)){
	and s.node_no = #nodeNo#
@}

queryLoopNumberByTerminalNo
===
SELECT 
  t1.loop_number 
FROM
  (SELECT 
    equip_product_type_id 
  FROM
    ctk_equip_terminal 
  WHERE terminal_no = #terminalNo#) t 
  LEFT JOIN ctk_product_type t1 
    ON t.equip_product_type_id = t1.`id` 


fadFindTerminalList
===
* 查询设备列表
SELECT 
  #page(" cet.*,cs.site_name,cpt.product_name,ces.socket_num ")# 
FROM
  ctk_equip_terminal cet 
  LEFT JOIN ctk_site cs 
    ON cs.site_id = cet.site_id 
  LEFT JOIN ctk_product_type cpt 
    ON cet.equip_product_type_id = cpt.id
  LEFT JOIN (SELECT COUNT(1) AS socket_num , equip_terminal_id FROM ctk_equip_socket GROUP BY equip_terminal_id) ces 
    ON ces.equip_terminal_id = cet.terminal_id 
WHERE 1 = 1
@if(!isEmpty(siteIds)){
	AND cet.site_id in (#join(siteIds)#) 
@}
@if(!isEmpty(siteName)){
	and cs.site_name LIKE #'%'+siteName+'%'# 
@}
@if(!isEmpty(iccid)){
	and cet.equip_iccid like #'%'+iccid+'%'#
@}
@if(!isEmpty(imei)){
	and cet.equip_imei like #'%'+imei+'%'#
@}
@if(!isEmpty(terminalNo)){
	AND cet.terminal_no like #'%'+terminalNo+'%'# 
@}
@if(!isEmpty(status)){
	AND cet.status = #status# 
@}
@if(!isEmpty(terminalType)){
	AND cet.equip_product_type_id = #terminalType# 
@}

querySerialNobySerialNoList
===
SELECT 
  serial_no 
FROM
  ctk_equip_terminal 
WHERE serial_no in (#join(list)#)
