queryMerchantAndSiteNumber
===
SELECT 
  t1.merchant_number,
  t2.site_number
FROM
  (SELECT 
    COUNT(1) AS merchant_number 
  FROM
    ctk_merchant
  WHERE 1 = 1
@if(!isEmpty(merchantData)){
	AND merchant_id in (#join(merchantData)#) 
@}
) t1 
  LEFT JOIN 
    (SELECT 
      COUNT(1) AS site_number 
    FROM
      ctk_site
  WHERE 1 = 1
@if(!isEmpty(siteData)){
	AND site_id in (#join(siteData)#) 
@}
) t2  ON 1 = 1 

queryEquipNumber
===
SELECT 
  cet.`status`,
  cpt.`product_type` 
FROM
   (SELECT 
    cet.`status`,
    cet.`equip_product_type_id` 
  FROM
    ctk_equip_terminal cet
  WHERE 1 = 1
@if(!isEmpty(siteData)){
	AND site_id in (#join(siteData)#) 
@}
    ) cet
  LEFT JOIN ctk_product_type cpt 
    on cet.`equip_product_type_id` = cpt.`id` 
    
querySite
===
SELECT 
  cs.site_id,
  cs.site_name,
  cs.longitude,
  cs.latitude,
  cs.merchant_id,
  cs.install_time,
  cs.contact_person_name,
  cs.contact_person_phone,
  cs.site_address,
  cm.merchant_name,
  cm.merchant_abbr 
FROM
  (SELECT 
    cs.site_id,
    cs.site_name,
    cs.longitude,
    cs.latitude,
    cs.merchant_id,
    cs.install_time,
    cs.contact_person_name,
    cs.contact_person_phone,
    cs.site_address 
  FROM
    ctk_site cs 
  WHERE 1 = 1 
@if(!isEmpty(siteData)){
	AND cs.site_id in (#join(siteData)#) 
@}
  ) cs 
  LEFT JOIN ctk_merchant cm 
    ON cs.merchant_id = cm.merchant_id 


querySiteWarn
===
SELECT 
  wr.`pre_warn`,
  wr.`warn_status`,
  wr.`site_id` 
FROM
  warn_record wr 
WHERE 1 = 1
@if(!isEmpty(siteData)){
	AND wr.`site_id` in (#join(siteData)#) 
@}
    
findHomeEleTotal
===
* 首页统计电量操作
SELECT
	sum(t.start_ele) start_ele,
	sum(t.end_ele) end_ele
FROM
	terminal_ele_total t
where 1=1
@if(!isEmpty(startTime)){
    and t.create_time = #startTime#
@}
@if(!isEmpty(siteIds)){
    and t.site_id in (#join(siteIds)#)
@}     
