getMarketUsers
===
SELECT 
  user_id,
  user_name 
FROM
  sys_user 
WHERE user_id IN 
  (SELECT 
    user_id 
  FROM
    sys_role_user 
  WHERE role_id IN 
    (SELECT 
      id 
    FROM
      sys_role 
    WHERE 1 =2 
@if(!isEmpty(roleName)){
	or role_name = #roleName# 
@}    
    ))
    
queryMerchantList
===
SELECT #page("t.`merchant_id`,t.`merchant_abbr`,t.`merchant_type`,t.`cooperat_status`,su.`user_name` AS manager_name ,s.`user_name` AS marketer_name ")#
FROM
  (SELECT 
    merchant_id,
    merchant_abbr,
    merchant_type,
    cooperat_status,
    manager_id,
    marketer_id 
  FROM
    ctk_merchant 
  WHERE 1 = 1
@if(!isEmpty(merchantData)){
	AND merchant_id in (#join(merchantData)#) 
@}
@if(!isEmpty(merchantAbbr)){
	and merchant_abbr LIKE #'%'+merchantAbbr+'%'# 
@}
@if(!isEmpty(cooperatStatus)){
	and cooperat_status = #cooperatStatus# 
@}
  ) t 
  LEFT JOIN sys_user su 
    ON su.user_id = t.manager_id 
  LEFT JOIN sys_user s 
    ON s.user_id = t.marketer_id
    

queryMerchantDetail
===
SELECT 
  t.*,
  su.`user_name` AS manager_name,
  su.phone_no,
  s.`user_name` AS marketer_name
FROM
  (SELECT 
    * 
  FROM
    ctk_merchant 
  WHERE 1 = 1
@if(!isEmpty(merchantId)){
	AND merchant_id = #merchantId#
@}  
  ) t 
  LEFT JOIN sys_user su 
    ON su.user_id = t.manager_id 
  LEFT JOIN sys_user s 
    ON s.user_id = t.marketer_id 


queryMerchantAbbrList
===
SELECT 
  cm.merchant_id,
  cm.merchant_name,
  cm.merchant_abbr,
  su.`user_name` 
FROM
  ctk_merchant cm LEFT JOIN sys_user su ON cm.`manager_id` = su.`user_id`
WHERE 1 = 1
@if(!isEmpty(merchantData)){
	AND cm.merchant_id in (#join(merchantData)#) 
@}


fadFindMerchantList
===
* 查询商户信息
SELECT #page("t.*,su.`user_name` AS manager_name,su.phone_no ,s.`user_name` AS marketer_name ")#
FROM
  (SELECT 
    merchant_id,
    merchant_abbr,
    merchant_type,
    cooperat_status,
    manager_id,
    marketer_id,
	merchant_name,
	area,
	address,
	email,
	merchant_title,
	merchant_logo
  FROM
    ctk_merchant 
  WHERE 1 = 1
@if(!isEmpty(merchantIds)){
	AND merchant_id in (#join(merchantIds)#) 
@}
@if(!isEmpty(merchantName)){
	and merchant_abbr LIKE #'%'+merchantName+'%'# 
@}
@if(!isEmpty(status)){
	and cooperat_status = #status# 
@}
  ) t 
  LEFT JOIN sys_user su 
    ON su.user_id = t.manager_id 
  LEFT JOIN sys_user s 
    ON s.user_id = t.marketer_id
    
queryMerchantLogoAndTitle
===
SELECT 
  merchant_id,
  merchant_title,
  merchant_logo 
FROM
  ctk_merchant 
WHERE 1 = 2 
@if(!isEmpty(merchantId)){
	OR merchant_id = #merchantId# 
@}

