findWarnPageList
===
* 查询告警数据
SELECT
	#page("w.*,u.user_name")#
FROM
	warn_record w
LEFT JOIN sys_user u ON w.handle_user_id = u.user_id
where 1=1
@if(!isEmpty(siteId)){
    and w.site_id = #siteId#
@}
@if(!isEmpty(merchantId)){
    and w.merchant_id = #merchantId#
@}
@if(!isEmpty(terminalNo)){
    and w.terminal_no like #'%'+terminalNo+'%'#
@}
@if(!isEmpty(typeId)){
    and w.type_id = #typeId#
@}
@if(!isEmpty(warnType)){
    and w.warn_type = #warnType#
@}
@if(!isEmpty(startTime)){
    and w.create_time >= #startTime#
    and w.create_time < #endTime#
@}
@if(!isEmpty(status)){
    and w.status = #status#
@}
@if(!isEmpty(siteIds)){
    and w.site_id in (#join(siteIds)#)
@}
@if(!isEmpty(warnStatus)){
    and w.warn_status = #warnStatus#
@}
@if(!isEmpty(preWarn)){
    and w.pre_warn = #preWarn#
@}

findSiteWarnRanking
===
* 查询站点告警
SELECT
	r.warn_status,
	r.site_id,
	r.site_name
FROM
	warn_record r
WHERE
	1 = 1
@if(!isEmpty(siteIds)){
    and r.site_id in (#join(siteIds)#)
@}
@if(!isEmpty(merchantIds)){
    and r.merchant_id in (#join(merchantIds)#)
@}

findWarnMonthTotal
===
* 12个月告警统计
SELECT
	count(1) count,
	r.pre_warn
FROM
	warn_record r
WHERE
	1 = 1
@if(!isEmpty(startTime)){
   and r.create_time >= #startTime#
@}
@if(!isEmpty(endTime)){
   and r.create_time < #endTime#
@}
@if(!isEmpty(siteIds)){
    and r.site_id in (#join(siteIds)#)
@}
@if(!isEmpty(merchantIds)){
    and r.merchant_id in (#join(merchantIds)#)
@}
GROUP BY r.pre_warn

findWarnHomeTotal
===
* 查询首页告警数统计
SELECT
	r.create_time,
	r.pre_warn
FROM
	warn_record r
WHERE
	1 = 1
@if(!isEmpty(startTime)){
   and r.create_time >= #startTime#
@}
@if(!isEmpty(endTime)){
   and r.create_time < #endTime#
@}
@if(!isEmpty(siteIds)){
    and r.site_id in (#join(siteIds)#)
@}
@if(!isEmpty(merchantIds)){
    and r.merchant_id in (#join(merchantIds)#)
@}

findWarnTotal
===
* 查询数据统计
SELECT
	count(1) count
FROM
	warn_record r
WHERE
	1 = 1
@if(!isEmpty(warnStatus)){
    and r.warn_status = #warnStatus#
@}
@if(!isEmpty(siteIds)){
    and r.site_id in (#join(siteIds)#)
@}
